/****
 * NOT USED IN THE EXT .. and needs to be fixed for many changes since it was used.
 * (VIABLE THO)
 */

class anne_datasource {
    constructor($nObj) {
        this.dsGens = [];
        this.srcNObj = $nObj;
        this.ddsNObj = $nObj;
        this.cols = [];
        this.data = [];
        this.filters = [];
        this.unsaved_filters = [];
        
        //these are just the params inherited from the be-tree (and alt-be-tree).
        //There are many more props available via the joined data-sets that ANNE offers
        //as a default.  If ur DS reference country in a column, then that column taps
        //into the country neuron..  It, itself, has an entire set of props that can be 
        //reached from this DS.  We will work LATER on how to best let the user choose those
        //in the gui.  There is an issue on chasing all these values out in the browser
        //and it must be done right as to not bog down the entire system.
        this.availble_prop_relns = [];

        //this means this is a neuron as the data source, gen 1.
        //this will not be stored on-chain this way...
        //any neuron can be a GEN1 datasource,
        //but to store any filters a legit datasource will be created.
        this.GEN1SRC = true; 
        
        //when a saved or new (unchanged) DS is edited and changed,
        //we will turn this on.
        this.bSAVEABLE_CHGS = false;
    }


    init_manual_override = async($manualNOBJS=null, $colNOBJS=[])=> {
        this.GEN1SRC=true;
        this.ddsNObj = this.srcNObj;
        this.dsGens.push(this.ddsNObj.temp_nid);  //we're the first one. :)

        this.genColsOverride($colNOBJS);
        this.genDataOverride($manualNOBJS);
    }

    /**
     * override the cols manual array of nObjs that are the columns.
     * Do not add any default extras.  Just what is passed in.
     */
    genColsOverride = function ($colNOBJS) {
        var col_nids = [];
        for (var n=0; n < $colNOBJS.length; n++) {
            var colNOBJ = $colNOBJS[n];
            if (col_nids.indexOf(colNOBJ.temp_nid)==-1) {
                col_nids.push(colNOBJ.temp_nid);
                var text = colNOBJ.text;
                if (colNOBJ.short!=undefined) text=colNOBJ.short;

                //we can look at the TERMINATING TYPE of the colNOBJ
                //and check for number/date/string
                //VET THIS... (should be a bit more robust)
                var ttype = "string"
                if (colNOBJ.bTERMINATING_TYPE==true) {
                    var ttOBJ = MEMG.getTerminatingType(colNOBJ);
                    if (ttOBJ.temp_nid==MEM.date.temp_nid) ttype = "date";
                    else if (ttOBJ.temp_nid==MEM.number.temp_nid) ttype ="number";
                    else if (ttOBJ.temp_nid==MEM.url.temp_nid) ttype ="url";
                }
                else  ttype = "anne";

                var dataprop = ""; 
                
                //we do not store .prop_ vales in the memorymanager 
                //as it would create overhead that we don't want to pay for
                //stuff we may or may not use.
                var param_name = MEMG.getRelonFromWithRToType(colNOBJ.outs, TYPE_SYS, MEM.PARAM_NAME.nid, TO_TYPE_STRING);
                if (param_name!=null) dataprop = param_name.to_s;
                else dataprop = "prop_"+colNOBJ.temp_nid;
                
                var displayprop = dataprop;
                this.cols.push({
                        active:true, 
                        text:text, 
                        ttype:ttype, 
                        dataprop:dataprop, 
                        displayprop:displayprop, 
                        datanid:colNOBJ.temp_nid, 
                        prelon:colNOBJ.nid,
                        c:this.cols.length,
                        bPENDING_SAVE:false
                    });
            }
        }


        //set an easy ptr to the filters from the columns so when we 
        //process the column data we can easily filter as needed.
        for (var c=0; c < this.cols.length; c++) {
            var datanid = this.cols[c].datanid;
            if (datanid==undefined) continue;
            if (this.filters[datanid]!=undefined) {
                this.cols[c].filters = this.filters[datanid];
            }
        }
    }


    /**
     * override the nObjs in a data table with a manual array
     * No children are desired.  Simply what is passed in.
     */
     genDataOverride = function($overrideNOBJS) {
        var nObjs = [];
        for (var n=0; n < $overrideNOBJS.length; n++) {
            var nObj = $overrideNOBJS[n];
            var dObj = {'nObj':nObj, active:true};
            var bPASS = this.propify(nObj, this.cols);
            if (bPASS==false) continue;  //do not push this to the data.
            this.data.push(dObj);
        }
        console.log("%c WE HAVE "+this.data.length+" base records in this datasource", 'background: white; color: green');
    }


    /*** init ************************************************ xx/xx/202x ***
	******************************************************** Mr.Scatman ****/ 
    init = async()=> {
                     

        //this will handle chasing the DDS out to its root neuron..
        //it will then get all the children of that root neuron.
        //it returns out the srcNOBJ.

        //WE WILL NEED TO CHASE OUT ALL FILTERS AND APPLY THEM TO THE DATA SET,
        //IN THE GENERATIONAL ORDER FROM EARLIEST (highest in tree) to lowest.
        //ie,  ds #1-> src country..  (has filter A)
        //ds #2 -> src ds#1.. (has filters B, and C)
        //ds #3-> src ds#2.. (has filters D)
        
        //after all filters are applied we arrive at THIS datasource.
        
        var DDSNOBJ = await ANNE.CHASE.chaseDDS_Src(this.srcNObj);
        if (DDSNOBJ.temp_nid!=this.srcNObj.temp_nid) {
            this.GEN1SRC = false; 
            this.ddsNObj = this.srcNObj;
            this.srcNObj = DDSNOBJ;
            var testNObj = this.ddsNObj;

            this.dsGens.push(testNObj.temp_nid);

            //traverse up the DDS chain..
            while(testNObj["be_"+MEM.ANNE_DDS_SRC.temp_nid]!=undefined) {
                var ddsNid = testNObj["be_"+MEM.ANNE_DDS_SRC.temp_nid];
                testNObj = MEMG.getNeuronByTempNid(ddsNid);
                if (testNObj!=null) this.dsGens.push(testNObj.temp_nid);
            }

            //oldest to newest is now here.. for us to properly process the filters..
            this.dsGens.reverse();
        }
        
        else {
            this.GEN1SRC=true;
            this.ddsNObj = this.srcNObj;
            this.dsGens.push(this.ddsNObj.temp_nid);  //we're the first one. :)
        }

        await this.genFilters();
        await this.genCols();
        this.genData();
    }


    /*** genFilters ****************************************** xx/xx/202x ***
    * generate the desired/selected columns for this datasource.            *
    * If this is a root neuron DS there are no filters other than the       *
    * deny/let which worldview already handles.                             *
	******************************************************** Mr.Scatman ****/ 
    genFilters = async()=> {
        var filternidsall = [];

        //loop the datasource(s).. this is the root neuron and then
        //any layered DS neurons that use the root and filter down to a lessor set.
        for (var d=0; d < this.dsGens.length; d++) {
            var ddsNObj = MEMG.getNeuronByTempNid(this.dsGens[d]);
            var filterRelons = MEMG.getRelonsFromWith_fast(ddsNObj.outs, TYPE_BE, MEM.ANNE_DDS_FILTER.temp_nid, TO_TYPE_ANNE); 
            if (filterRelons==null || filterRelons.length==0) continue;
            var filternids = MEM.extractTempNidsFromRelonsTo(filterRelons);
            console.log(filternids);
            for (var f=0; f < filternids.length; f++) {
                if (filternidsall.indexOf(filternids[f])==-1) {
                    filternidsall.push(filternids[f]);
                }
            }
        }

        if (filternidsall.length) {
            await ANNE.CHASE.lookupMinTNids(filternidsall);
            var filterNObjs = MEM.extractToNObjsFromRelons(filterRelons);
            
            //our list of all filters, chased out, ready to be applied.
            console.log(filterNObjs);
            ANNE.TALK.printNObjs(filterNObjs);

            //we need to store these easy-access for the columns..
            for (var f=0; f < filterNObjs.length; f++) {
                var filterNObj = filterNObjs[f];
                var relon = MEMG.getRelonFromWithRToType(filterNObj.outs, TYPE_HAS, MEM.FILTER_PROP.nid, TO_TYPE_ANNE);
                
                //set the key of the filters to the temp_nid of the filter prop..
                //ie, if MEM.name was a filter prop, then filters[ MEM.name.temp_nid] = [ filter1];
                if (relon!=null) {
                    if (this.filters[relon.t] == undefined) {
                        this.filters[relon.t] = [filterNObj];
                    }
                    else this.filters[relon.t].push(filterNOBj);
                }
                
            }
        }

        //now we can store our filters and apply them to the dataset properly.
    }


    /*** genCols ********************************************* xx/xx/202x ***
    * generate the desired/selected columns for this datasource.            *
    * These can be directly specified.  If not, we take the default.        *
	******************************************************** Mr.Scatman ****/ 
    genCols = async()=> {

        //any non gen1src has specified its base cols in the first DS,
        //and then any downstream ones additional net-diff columns in the DS neurons.
        if (this.GEN1SRC==false) {
            
            var col_nids = [];

            //handle any other cols specified in any of the other BE-line DS.
            for (var d=0; d < this.dsGens.length; d++) {
                var dsNObj = MEMG.getNeuronByTempNid(this.dsGens[d]);
                if (dsNObj.bes[0]!=MEM.ANNE_DDS.temp_nid) continue;

                console.log("looking for prop relons on "+dsNObj.text);
                var propRelons = MEM.getRelonsFromWith(dsNObj.outs, MEM.DS_PROP.nid);
                
                //expected:
                //DDS->DS_PROP->propNObj
                console.log(propRelons);
                for (var r=0; r < propRelons.length; r++) {
                    var propRelon = propRelons[r];
                    if (col_nids.indexOf(propRelon.r)==-1) {
                        col_nids.push(propRelon.t);
                        var toNOBJ = MEMG.getNeuronByTempNid(propRelon.t);
                        var text = toNOBJ.text;
                        if (toNOBJ.short!=undefined) text=toNOBJ.short;

                        //we can look at the TERMINATING TYPE of the toNOBJ
                        //and check for number/date/string
                        //VET THIS... (should be a bit more robust)
                        var ttype = "string"
                        if (toNOBJ.bTERMINATING_TYPE==true) {
                            var ttOBJ = MEMG.getTerminatingType(toNOBJ);
                            if (ttOBJ.temp_nid==MEM.date.temp_nid) ttype = "date";
                            else if (ttOBJ.temp_nid==MEM.number.temp_nid) ttype ="number";
                            else if (ttOBJ.temp_nid==MEM.url.temp_nid) ttype ="url";
                        }
                        else {
                            ttype = "anne";
                        }

                        var dataprop = ""; 
                        
                        //we do not store .prop_ vales in the memorymanager 
                        //as it would create overhead that we don't want to pay for
                        //stuff we may or may not use.
                        var param_name = MEMG.getRelonFromWithRToType(toNOBJ.outs, TYPE_SYS, MEM.PARAM_NAME.nid, TO_TYPE_STRING);
                        if (param_name!=null) dataprop = param_name.to_s;
                        else dataprop = "prop_"+relonNObj.t;
                        
                        var displayprop = dataprop;
                        this.cols.push({
                                active:true, 
                                text:text, 
                                ttype:ttype, 
                                dataprop:dataprop, 
                                displayprop:displayprop, 
                                datanid:propRelon.t, 
                                prelon:propRelon.txid,
                                c:this.cols.length,
                                bPENDING_SAVE:false
                            });
                    }
                }
            }

            //populate the inactive columns.
            await this.doDefaultCols(true, col_nids);
        }

        //don't worry about saving these, yet..
        //this is just a neuron-viewed-as-a-ds.
        else await this.doDefaultCols();

        //set an easy ptr to the filters from the columns so when we 
        //process the column data we can easily filter as needed.
        for (var c=0; c < this.cols.length; c++) {
            var datanid = this.cols[c].datanid;
            if (datanid==undefined) continue;
            if (this.filters[datanid]!=undefined) {
                this.cols[c].filters = this.filters[datanid];
            }
        }
    }


    /*** doDefaultCols *************************************** xx/xx/202x ***
	******************************************************** Mr.Scatman ****/ 
    doDefaultCols = async($bSETALLACTIVEFALSE=false, $alreadyDone=[])=> {
        var aParams = await MEMG.getParentLineParamsLive(this.srcNObj);
        ANNE.TALK.printRelons(aParams);
        var default_oks = [MEM.class.temp_nid, MEM.inst.temp_nid, MEM.name.temp_nid];
        var bDIDPARENT = false;
        for (var p=0; p < aParams.length; p++) {
            var prelon = aParams[p];
            if ($alreadyDone.length && $alreadyDone.indexOf(prelon.r)!=-1) continue;
            var active = true;
            if ($bSETALLACTIVEFALSE==true) active = false;

            //if NOT a param on THIS neuron, AND not a default (class/inst/name) 
            //inherited or this level BE, skip this as a default col.
            //We will allow for all the skips to be accessed in the settings checkbox menu
            //to add more cols to the table. (yikes)
            if (default_oks.indexOf(prelon.r)!=-1) {
                if (prelon.r==MEM.name.temp_nid) {
                    this.cols.push({
                                active:active, 
                                text:"name", 
                                ttype:"string", 
                                dataprop:"text", 
                                datanid:prelon.r, 
                                prelon:prelon.txid,
                                c:this.cols.length,
                                bPENDING_SAVE:false
                            });
                    continue;   
                }

                //only do one for this.
                else if (prelon.r==MEM.inst.temp_nid || prelon.r==MEM.class.temp_nid) {
                    if (bDIDPARENT==true) continue;
                    ANNE.TALK.printRelon(prelon);
                    bDIDPARENT=true;
                    this.cols.push({
                            active:active, 
                            text:"parent", 
                            ttype:"anne", 
                            dataprop:"be", 
                            datanid:prelon.r, 
                            prelon:prelon.txid, 
                            filters:null,
                            c:this.cols.length,
                            bPENDING_SAVE:false
                        });
                    continue;  
                }
            }

            var relnNOBJ = MEMG.getNeuronByTempNid(prelon.r);
            var text = relnNOBJ.text;
            if (relnNOBJ.short!=undefined) text=relnNOBJ.short;
            var ttype = "string"
            var toNOBJ = MEMG.getNeuronByTempNid(prelon.t);
            if (relnNOBJ.bTERMINATING_TYPE==true) {
                var ttOBJ = MEMG.getTerminatingType(toNOBJ);
                if (ttOBJ==null) continue;
                if (ttOBJ.temp_nid==MEM.date.temp_nid) ttype = "date";
                else if (ttOBJ.temp_nid==MEM.number.temp_nid) ttype ="number";
                else if (ttOBJ.temp_nid==MEM.url.temp_nid) ttype ="url";
            }
            else {
                ttype = "anne";
            }

            var dataprop = ""; 
            var param_name = MEMG.getRelonFromWithRToType(relnNOBJ.outs, TYPE_SYS, MEM.PARAM_NAME.nid, TO_TYPE_STRING);
            if (param_name!=null) {
                dataprop = param_name.to_s;
            }
            else {
                ANNE.TALK.printRelon(prelon);
                console.log("data prop for reln:"+relnNOBJ.text);
                dataprop = relnNOBJ.temp_nid;
                dataprop = "prop_"+dataprop;
            }

            var dataprop_disp = dataprop+"_disp";

            //this may be different, for now just set it the same.
            var displayprop = dataprop_disp;

            //available for selection but not defaulted as selected in the datasource.
            if (prelon.f!=this.srcNObj.temp_nid) active=false;

            this.cols.push({   
                        active:active, 
                        text:text, 
                        ttype:ttype, 
                        display:displayprop, 
                        dataprop:dataprop, 
                        datanid:relnNOBJ.temp_nid, 
                        prelon:prelon.txid, 
                        filters:null,
                        c:this.cols.length,
                        bPENDING_SAVE:false
                    });
            
        }
    }


    /*** addSingleColRuntime ********************************* xx/xx/202x ***
    * runtime adds of columns are just adding in a column to the datasource *
    * view.  They do not REMOVE data from the dataset -- if the new col     *
    * does not fit an active filter just make the .active = false.  If this *
    * new datasource is saved then the next time it runs it will not        *
    * include this record.                                                  *
	******************************************************** Mr.Scatman ****/ 
    addSingleColRuntime = function($col) {
        
        //set the col active.  Before every dataset was made we create the quick
        //cols available.  The ones not available in the cols array are cols that
        //are properties on drill-thru-able neurons.  We will handle those seperately
        //on-demand as there can be any number (even hundreds) of those depending
        //on what neurons this record references.
        $col.active = true;      

        for (var d=0; d < this.data.length; d++) {
            var bPASS = this.propify(this.data[d].nObj, [$col]);
            if (bPASS==false) this.data[d].active=false;  
        }
    }


    /*** getColByDatanid ************************************* xx/xx/202x ***
	******************************************************** Mr.Scatman ****/ 
    getColByDatanid = function ($datanid) {
        for (var c=0; c < this.cols.length; c++) {
            if (this.cols[c].datanid==$datanid) return this.cols[c];
        }
        return null;
    }


    /*** removeSingleCol ************************************* xx/xx/202x ***
	******************************************************** Mr.Scatman ****/ 
    removeSingleCol = function($col) { $col.active = false; }


    /*** genData ********************************************* xx/xx/202x ***
    * This gen data is intended to setup the data source and thus can       *
    * remove straight-away items that fail any filter.  WE do not allow     *
    * a DS of a DS to undo a filter.  Better to create a new more-core DS   *
    * without the original filter.   They are net narrowers... filters..    *
    * narrowing the possible data records.. never increasing them.          *
	******************************************************** Mr.Scatman ****/ 
    genData = function() {
        var nObjs = [];

        var bDOINSTS = true;
        var bDONIDLIST = false;
        var bDOALLBES = true; //chg this if we have our specialz in.
        
        this.srcNObj.getAllDownlineChildren(nObjs, 0, bDOINSTS, bDONIDLIST, bDOALLBES);

        for (var n=0; n < nObjs.length; n++) {
            var childNObj = nObjs[n];
            var dObj = {nObj:childNObj, active:true};
            var bPASS = this.propify(childNObj, this.cols);
            if (bPASS==false) continue;  //do not push this to the data.
            this.data.push(dObj);
        }
        console.log("%c WE HAVE "+this.data.length+" base records in this datasource", 'background: white; color: green');
    }


    /*** propify ********************************************* xx/xx/202x ***
    * we should only have to propfity an object once.. to set its quick     *
    * props in its neuron object (for easy reference).  This will speed up  *
    * future data sources that use this same data (in the same browser      *
    * session).                                                             *
	******************************************************** Mr.Scatman ****/ 
    propify = function ($dNObj, $cols) {
        
        //one fail, the entire "record" fails.  This is a filter.
        var bFAIL = false;  

        //for each col.. propifty that property of the dNObj, if it exists.
        //if it doesn't, set it to "".
        for (var c=0; c < $cols.length; c++) {
            var col = $cols[c];

             //we can do nothing without a dataprop.
            if (col.dataprop==undefined) continue;
           
            //multiple filters here are ALWAYS ANDS...
            //as they are additive filters provided on top of existing Datasources.
            //any nuances to expressions / ORs etc will be internal to each filter.
            //a JS eval will eval the prepared filter..
            //we can easily create alt prog lang handling w/ an eval specific to that
            //language.  Right now we use JS.. so JS it is.
            var filters = col.filters;
            var bFOUNDCOL = false;

            //propify this data prop once for this dataobj.
            //we've already propfied.. just test if a filter, else continue as-is (data is in datasource).
            if ($dNObj[col.dataprop]!=undefined && $dNObj[col.dataprop]!="") {
                if (filters!=null) {
                    var val = $dNObj[ col.dataprop ];
                    if (anne_x_filter.testFiltersRuntime(val, filters) ==false) {
                        return false;   //auto fail.
                    }
                }
                bFOUNDCOL = true;
            }

            //loop the data objs props to find our target data..
            //(store the dataprop quick ref so we only do this once.
            else {
                for (var o=0; o < $dNObj.outs.length; o++) {
                    var rel = $dNObj.outs[o];
                    if (rel.r==col.datanid) {
                        var val = MEMG.getToTextOfRelon(rel, true);    //we wil convert this to honor value functs
                        if (filters!=null) {
                            if (anne_x_filter.testFiltersRuntime(val, $filters) ==false) {
                                return false;
                            }
                        }

                        //note, we could set this prop in the memory hander but there would
                        //be a great net-ram cost to store a bunch of props we may not be using.
                        //When considering hundreds of thousands of neurons this can be the straw
                        //that breaks the camel's back.
                        //We're already pushing RAM limits doing this BI/data analysis platform in 
                        //the browser.  :)
                        $dNObj[col.dataprop] = val; 
                        
                        if (col.ttype=="url") {
                            var url = val;
                            if (url.length>24) url = substring(val.length-24);
                            $dNObj[col.dataprop] = "<a href='"+val+"' class='table-url' target='new'>"+url+"</a>";
                        }
                        
                        bFOUNDCOL = true;
                        break;
                    }
                }
                if (bFAIL==true) return false;
            }
            
            if (bFOUNDCOL==false) $dNObj[col.dataprop] = "";
        }
        if (bFAIL==true) return false;
        return true;
    }


    /*** getFilterStrings ************************************ xx/xx/202x ***
	******************************************************** Mr.Scatman ****/ 
    getFilterStrings = function() {
        var keys = Object.keys(this.filters);
        var filterStrs = [];
        for (var k=0; k < keys.length; k++) {
            var filter_prop = keys[k];
            var filterPropNOBJ = MEMG.getNeuronByTempNid(filter_prop);

            //filters array (could be more than 1)
            //for this prop...
            var filters = this.filters[filter_prop];
            var filtersString = anne_x_filter.printRelonFilters(filters);

            var propName = "";
            if (filterPropNOBJ["pname"]!=undefined) propName=filterPropNOBJ["pname"];
            else propName = filterPropNOBJ.text;//"prop_"+filterPropNOBJ.temp_nid;
            filterStrs.push("<em>"+propName+"</em> with expression:<b>"+filtersString+"</b>");
        }

        if (filterStrs.length==0) return "";
        return "filtering "+filterStrs.join("<BR>");
    }

    //loop through the cols to see if we have any pending changes.
    //(we just turned a col off.. and potentially we have no more changes.
    //we use this to turn off the save button
    setPendingChanges = function() {
        for (var c=0; c < this.cols.length; c++) {
            if (this.cols[c].bPENDING_SAVE!=undefined && this.cols[c].bPENDING_SAVE==true) {
                if (this.bSAVEABLE_CHGS==false) {
                    ANNE.playSound("attention");
                    this.bSAVEABLE_CHGS = true;
                    return true;
                }
                return false;   //saveable chgs it true, but false here means we already knew that.
            }
        }

        //check the filters.
        if (this.unsaved_filters.length) {
            if (this.bSAVEABLE_CHGS==false) {
                ANNE.playSound("attention");
                this.bSAVEABLE_CHGS = true;
                return true;
            }
            return false;       //saveable chgs it true, but false here means we already knew that.
        }

        this.bSAVEABLE_CHGS = false;
        return false;
    }


    /*** make_unsaved_filter ********************************* xx/xx/202x ***
	******************************************************** Mr.Scatman ****/ 
    make_unsaved_filter = async($filterStr, $cIndex)=> {
        console.log("make unsaved filter : "+$filterStr, $cIndex);
        var unsaved = this.unsaved_filters[$cIndex];
        var col = this.cols[$cIndex];
        var datanid = col.datanid;
        var relnPropNOBJ = MEMG.getNeuronByTempNid(datanid);

        if (unsaved==undefined) {
            if ($filterStr=="") return;
            this.unsaved_filters[$cIndex]=await ANNE_X.newFilterFromString(null, $filterStr, relnPropNOBJ);
        }
        else {
            if ($filterStr=="") {
                delete this.unsaved_filters[$cIndex];
                return;
            }
            this.unsaved_filters[$cIndex]=await ANNE_X.newFilterFromString(null, $filterStr, relnPropNOBJ);
        }
    }

    saveEditsToExisting = function() {
        alert("save edits to existing DS");
    }

    savePendingChangesToNew = function() {
        alert("save new changes in new neuron w/ filters");
    }
}