/**
 * aon
 */
 class dossier_aon extends neuron_dossier {
    constructor ($pgui, $secondary=null, $third=null, $misc=null) {
        super($pgui, $secondary, $third, $misc);
        this._faucet_recommended = 120000;          //1200 coins, 120,000 annies    
        this._faucet_annies_per_user = 1200;        //1200 annies per aon, 100 onboardings
        console.log("%c dossier_aon", TALK.bgredbig);
    }
     
    
    /**
     * 
     * @param {*} $pguicopy 
     */
    initASYNC = async($pguicopy)=>{
        ANNE.A.removeSelf(this.el_bebox_img);
        await this.getData(false, this.nObj);
        await this.doHeading(false, []);
        var bDOPENDING = true;
        await this.getBalance(bDOPENDING); 

        await this.doAllHas(this.el_content);

        this.rel_apo = MEMG.getHasRelon(this.nObj.outs, MEM.annies_per_aon.temp_nid);
        this.rel_annode_uri = MEMG.getHasRelon(this.nObj.outs, MEM.ANNODE_URI.temp_nid);
        var euokNOBJ = MEMG.getOrMakeIfNew("7771584740156988236");
        //this.rel_existing_user_ok = MEMG.getHasRelon(this.nObj.outs, euokNOBJ.temp_nid);
        this.bVALID=true;
        var req_missing = 0;

        if (this.nObj.owned_by==USER._userNObj.nid) {
            this._mode = "maker";
            this.el_stuff=ANNE.A.ezEl(this.el_content, "div", "simple-row");
            if (this.rel_apo==null) {  
                req_missing+=1;              
                this.rel_param_apo = MEMG.getParamRelon(this.all_relons, MEM.annies_per_aon.temp_nid);
                var btn = this.makeCollabBtn(this.el_stuff, TXB.TXTYPE_CHILD_RELON, this.rel_param_apo, "set annies per aon faucet use");
                this.bVALID=false;
                btn.setAttribute("prompt", "How many annies should each faucet use distribute?  (minimum "+UTILS.formatNumber(this._faucet_annies_per_user)+").");
                btn.setAttribute("minimum", this._faucet_annies_per_user+"");
            }
            if (this.rel_annode_uri==null) {
                req_missing+=1;                
                this.rel_param_annode_uri = MEMG.getParamRelon(this.all_relons, MEM.ANNODE_URI.temp_nid);
                var btn = this.makeCollabBtn(this.el_stuff, TXB.TXTYPE_CHILD_RELON, this.rel_param_annode_uri, "set faucet annode uri");
                btn.setAttribute("default", ANNE._annodesLS.last_uri);
                btn.setAttribute("prompt", "What is the URI of the ANNODE this faucet will live on?  It should be the ANNODE you are on now.");
            }
            //if (this.rel_existing_user_ok==null) {                
                //this.rel_param_euok_uri = MEMG.getParamRelon(this.all_relons, euokNOBJ.temp_nid);
                //var btn = this.makeCollabBtn(this.el_stuff, TXB.TXTYPE_CHILD_RELON, this.rel_param_euok_uri, "existing user ok? (default no)");
                //btn.setAttribute("prompt", "Is it ok for an existing user with low balance to use this faucet?");
            //}
            if (this.nObj.ghost==true) {
                if (req_missing>0) ANNE.A.hide(this.el_upgrade_ghost_relons);
                else ANNE.A.show(this.el_upgrade_ghost_relons);
            }
        }

        else {
            this._mode="user";
            if (this.rel_apo==null) req_missing+=1;
            if (this.rel_annode_uri==null) req_missing+=1;        
        }

        if (this.nObj.ghost==false) {    
            if (req_missing==0) {
                var fund_col = ANNE.A.ezElPrepend(this.el_actions, "div", "simple-col fba");
                fund_col.style="text-align:left";
                var btn = ANNE.A.ezButton(fund_col, "", "fund this faucet!", "anne-tiny-btn btn-purple-sq btn-maxH", e=>this.fundThisFaucet(e));
            }


            var txs = await ANNE.API.getDirectFundsOf(this.nObj.nid);
            if (txs.length>0) {
                var el_funders = ANNE.A.ezEl(this.el_bes_content, "div", "section-title-center", "funders");
                for (var t=0; t < txs.length; t++) {
                    var tx = txs[t];
                    var row = ANNE.A.ezEl(el_funders, "div", "simple-row");
                    var col1 = ANNE.A.ezEl(row, "div", "simple-col tal50");
                    var col2 = ANNE.A.ezEl(row, "div", "simple-col tal50");
                    ANNE.A.ezAnneDisplayApprox(col1, tx.amount);
                    EXT_BTNS.makeRawTXLink(col2, tx.txid, false, 8, true);
                    EXT_BTNS.makeNeuronLink(col2, tx.sender_nid);
                }
                if (txs.length==0) {
                    ANNE.A.ezEl(this.el_bes_content, "div", "section-title-center", "There are no funders of this faucet.");
                }
            }
        }

        ANNE.A.smartScroll("scrollable_"+this.ID, 72);
    }


    fundThisFaucet = async($e)=>{
        console.log("fund this faucet");
        var paramsObj = new page_params(null, null, null);
        paramsObj.misc = {default_fund_to_nid:this.nObj.nid, annies:this._faucet_recommended};
        await PAGES.openPage("send_funds", paramsObj);
    }

    /**
     * help the maker of the ghost upgade when reqs are met
     */
    dataAdded = function($new_relon) {
        var req_missing = 0;
        if (this._mode=="maker") {
            this.rel_apo = MEMG.getHasRelon(this.nObj.outs, MEM.annies_per_aon.temp_nid);
            if (this.rel_apo==null) req_missing+=1;
            this.rel_annode_uri = MEMG.getHasRelon(this.nObj.outs, MEM.ANNODE_URI.temp_nid);
            if (this.rel_annode_uri==null) req_missing+=1;
            if (this.nObj.ghost==true) {
                if (req_missing>0) ANNE.A.hide(this.el_upgrade_ghost_relons);
                else {
                    ANNE.A.show(this.el_upgrade_ghost_relons);
                }
            }
        }
    }
}