
/**
 * date
 */
 class dossier_date extends neuron_dossier {
    constructor ($pgui, $secondary=null, $third=null, $misc=null) {
        super($pgui, $secondary, $third, $misc);
        console.log("%c dossier_date", TALK.bgredbig);

        this.bDIDOTHERDATES = false;
        this.datesGOBJ = null;
    }
    initASYNC = async($pguicopy)=>{
        await this.getData(false, this.nObj);
        await this.doHeading();
        //await this.getBalance(); 

        //this.doAKA(this.el_bes_content);
        //this.doFKA(this.el_bes_content);
        this.doAltBES(this.el_bes_content);

        //no needed collab for outbound params on dates.
        //these are linked in to or used in events.
        if (this.nObj.owned_by!=MEM.ANNE_ACCTID) {
            await this.doAllParams(this.el_content);
        }

        await this.doAllHas(this.el_bes_content, "section-title-center");    //generic.
        
        //do ins
        //if (this.nObj.bes[0]==MEM.daymonth.temp_nid || this.nObj.bes[0]==MEM.monthyear.temp_nid) {
            //we want to lookup full date neurons of daymonth and monthyear matches.
            //we then want to see events that had those full neurons as ROLE_WHERE.
            //this.doPartialDateEvents();
        //}

        await this.doAllInsSection2(this.el_content, "inbound references", true);


        this.adate = new anne_date();
        this.adate.loadFromNeuron(this.nObj, false);
            
        if (this.adate.daymonthNOBJ!=null) {
            console.log(this.adate.daymonthNOBJ.text);

            //var headerDiv = gObj.div_header;
            //var bodyDiv = gObj.div_body;
            //bodyDiv.classList.add("tal4colrows");
        
            var THIS = this;
                
            this.datesGOBJ = await this.doCustomGetSection(this.el_content, 

                //only will be called once per the doCustomGetSection.
                async($var)=>{

                    //get from neurons that point to a to_s.
                    await ANNE.API.getAllFromNeuronRelonsGeneric(MEM.daymonth.nid, THIS.adate.daymonthNOBJ.nid);

                    //sort these dates later.  For now, just show them.    
                    var hits = 0;
                        
                    for (var i=0; i < THIS.adate.daymonthNOBJ.ins.length; i++) {
                        var rel = THIS.adate.daymonthNOBJ.ins[i];
                        if (rel.reln!=ANNE.MEM.daymonth.nid) continue;
                        var fromNOBJ = MEMG.getNeuronByNid(rel.from_nid);
                        var elrn = ANNE.A.ezSpan(THIS.datesGOBJ.div_body, "", "neuron");
                        var sp = ANNE.MEM_UDF.makeNeuronLink(elrn, fromNOBJ, "dib");
                        sp.style.display="block";
                        hits+=1;
                    }

                    if (hits==0) {
                        var elrn = ANNE.A.ezSpan(THIS.datesGOBJ.div_body, "", ""); 
                        elrn.innerHTML="no results found for "+this.adate.daymonthNOBJ.text;
                    }

                }, 
                "bDIDOTHERDATES",
                "dates on this day");

        }
            
        //
        //await ANNE.API.getDates(0, this.adate.monthNOBJ.nid, this.adate.dateNOBJ.nid);

        //this.monthNOBJ = 
        //await this.doCustomGetSection(this.el_content, $nObjs, "On this day");

        //events in the body
        await this.displayEvents(this.el_content);

        //see dates on this month+day  (JULLY 4th)
        //see events on this month+yr  (JULY 2002)

        //do.. birthdays
        //deathdays
        //events..
        await this.doAnumSection(this.el_content);
        
        //this.doBRAINSection(this.el_content);
        this.addAwarvu();

        await  this.doImgs(this.el_thumbs); //images after the body
        //this.doMeta(this.el_meta);  //left stats
        //this.doAllSysRelons(this.el_admin); //right admins
        //this.doDebug();

        ANNE.A.smartScroll("scrollable_"+this.ID, 72);
    }
}
