
/**
 * distro
 */
 class dossier_distro extends neuron_dossier {
    constructor ($pgui, $secondary=null, $third=null, $misc=null) {
        super($pgui, $secondary, $third, $misc);
        console.log("%c dossier_distro", TALK.bgredbig);
    }

    
    initASYNC = async($pguicopy)=>{

        ANNE.A.removeSelf(this.el_bebox_img);
        
        await this.getData(false, this.nObj);
        await this.doHeading(false, []);
        
        ANNE.A.removeSelf("garden_"+this.nObj.temp_nid);
        
        await this.doAllHas(this.el_content); 
        
        
        //do we need ins?  Where are the votes on the distro???
        await this.doAllInsSection2(this.el_content, "inbound references", true);
       

        //if distro vote call final relon is missing (AND WE ARE THE OWNER), allow a fix here to make and broadcast that relon.
        if (this.nObj.owned_by==USER._userNObj.nid) {
            var rel_distro_vote = MEMG.getSysMsgRelon(USER._userNObj.outs, MEM.distro_vote.temp_nid);
            var rel_freeze = MEMG.getSysMsgRelon(this.nObj.outs, MEM.CMD_FREEZE.temp_nid);
                    
            //must have a rel freeze to call a vote!
            if (rel_distro_vote==null && rel_freeze!=null) {
                var elholder = ANNE.A.ezEl(this.el_content, "div", "vote-call-holder");
                this.el_call_vote_btn = ANNE.A.ezButton(elholder, "", "call the vote (send final cmd)", "anne-tiny-btn btn-purple-sq btn-vote-call", async(e)=>{
                    ANNE.A.hide(this.el_call_vote_btn);
                    var ghost = await GHOSTDATA.makeGhostRelon(TYPE_SYS_MSG, USER._userNObj, MEM.distro_vote.nid, TO_TYPE_ANNE, this.nObj.nid);
                    
                    var rel_freeze = MEMG.getSysMsgRelon(this.nObj.outs, MEM.CMD_FREEZE.temp_nid);
                    if(rel_freeze==null) {
                        ghost.sys_ref_txid = rel_freeze.txid;    
                    }
                    
                    SENDQ.addRelonToSendQ(ghost, true, TXB.TXTYPE_ANORG_VOTECALL, function() {
                        console.log("yay");
                    })
                });
            }
            else {
                ANNE.TALK.printRelon(rel_distro_vote);
            }
        }


        ANNE.A.smartScroll("scrollable_"+this.ID, 72);
    }

}
