
class page_params {
    constructor ($s=null, $c=null, $f=null, $p1=null, $p2=null,$p3=null,$p4=null,$p5=null,$p6=null,$p7=null) {
        this.s_cbk=$s;      //success
        this.c_cbk=$c;      //cancel
        this.f_cbk=$f;      //fail
        this.p1=$p1;
        this.p2=$p2;
        this.p3=$p3;
        this.p4=$p4;
        this.p5=$p5;
        this.p6=$p6;
        this.p7=$p7;
        
        //this allows for tossing things in here to look for specifically.
        //tabber's are set by the pages at runtime which are assigned to be rendered.
        //the tabber is the object "UP" to the parent from the child tab (page_gui)
        this.misc = null;
    }
}


/**
 * helpful obj for callbacks to manipulate the gui/dom/apps after que sends.
 * Typcally the pgui and callback str/funct are used...
 * Othertimes we use this object for more.
 */
class gui_extras {
    constructor($pgui=null, $callback_str="", $callback_funct=null) {
        this._pgui = $pgui;
        this._callback_str = $callback_str;
        this._callback_funct = $callback_funct;
        
        this._status_text = "";
        this._collab_txid = "";

        this._bLASTINQ = false;
        this._passthru = null;

        this._el_display = null;
        this._guitracker = null;

        this._launch = false;

        this._bDONTPULL = false;
        this._bMUSTPULL = false;

        this._guid = null;
    }


    /**
     * @param {string} - just the guid of the pgui
     */   
    set guid($pgui) { this._guid=$guid; }
    get guid() { return this._guid; }


    /**
     * @param {page_gui} - callback function str to be eval'd
     */   
    set pgui($pgui) { this._pgui=$pgui; }
    get pgui() { return this._pgui; }


    /**
     * @param {function} - callback function str to be eval'd
     */  
    set callback_str($cs) { this._callback_str=$cs; }
    get callback_str() { return this._callback_str; }


    /**
     * @param {function} - callback function
     */  
    set callback_funct($cf) { 
        if (typeof $cf!=="function") {
            console.log("(nf_param) callback $cf is not a function");
            return;
        }
        this._callback_funct=$cf; 
    }
    get callback_funct() { return this._callback_funct; }


    /**
     * @param {string} - simple status of the collab (a/d/p)
     * a-approved d-declined p-pending
     */  
    set status_text($st) { this._status_text=$st; }
    get status_text() { return this._status_text; }
    

    /**
     * @param {string} - long txid string
     */  
    set collab_txid($ct) { this._collab_txid=$ct; }
    get collab_txid() { return this._collab_txid; }


    /**
     * @param {boolean} - Is this the last item in the q?
     */  
    set bLASTINQ($liq) { this._bLASTINQ=$liq; }
    get bLASTINQ() { return this._bLASTINQ; }


    /**
     * @param {Object} - A relon
     */  
    set passthru($pt) { this._passthru=$pt; }
    get passthru() { return this._passthru; }


    /**
     * @param {string}   //todo, this may be an actual DOM element
     */    
    set el_display($el) { this._el_display=$el; }
    get el_display() { return this._el_display; }


    /**
     * @param {string}
     */
    set guitracker($pt) { this._guitracker=$pt; }
    get guitracker() { return this._guitracker; }


    /**
     * @param {boolean}
     */
    set launch($launch) { this._launch=$launch; }
    get launch() { return this._launch; }


    /**
     * @param {boolean}
     */
     set bDONTPULL($bDONTPULL) { this._bDONTPULL=$bDONTPULL; }
     get bDONTPULL() { return this._bDONTPULL; }


    /**
     * @param {boolean}
     */
    set bMUSTPULL($bMUSTPULL) { this._bMUSTPULL=$bMUSTPULL; }
    get bMUSTPULL() { return this._bMUSTPULL; }
}