var scripts = [];
var pre = "/js/";
var version = "1.9"+Math.random();

scripts.push({name:"mem_ez", forcenew:false, ref:pre+"mem/", blocking:true});
scripts.push({name:"mem_search", forcenew:false, ref:pre+"mem/", blocking:true});
scripts.push({name:"aware", forcenew:false, ref:pre+"base/", blocking:true});
scripts.push({name:"anne_selectors", ref:pre+"base/selectors/", forcenew:false, blocking:true});
scripts.push({name:"ss_selectors", ref:pre+"base/selectors/", forcenew:false, blocking:true});
scripts.push({name:"smartsearch", ref:pre+"base/", forcenew:false, blocking:true});
scripts.push({name:"browserfixes", ref:pre+"other/", blocking:true});

//i want to get rid of these!
scripts.push({name:"signumjs", ref:pre+"signum/", blocking:true});
scripts.push({name:"signumjs.crypto.min", ref:pre+"signum/", blocking:true});
scripts.push({name:"signumjs.http.min", ref:pre+"signum/", blocking:true});
scripts.push({name:"signumjs.util.min", ref:pre+"signum/", blocking:true});

scripts.push({name:"net", ref:pre+"network/", forcenew:false, blocking:true});
scripts.push({name:"API", ref:pre+"network/", forcenew:false, blocking:true});
scripts.push({name:"anne_DOM", forcenew:false, ref:pre+"base/", blocking:true});
scripts.push({name:"govenor", forcenew:false, ref:pre+"base/", blocking:true});
scripts.push({name:"history", forcenew:false, ref:pre+"db/", blocking:true});
scripts.push({name:"IDB", ref:pre+"db/", forcenew:false, blocking:true});

scripts.push({name:"send_queue", ref:pre+"sendq/", forcenew:false, blocking:true});
scripts.push({name:"sender", ref:pre+"sendq/", forcenew:false, blocking:true});
scripts.push({name:"gui_stuff", ref:pre+"gui/", forcenew:false, blocking:true});
scripts.push({name:"db_local", ref:pre+"db/", forcenew:false, blocking:true});
scripts.push({name:"history_local", ref:pre+"db/", forcenew:false, blocking:true});

scripts.push({name:"misc_classes", ref:pre+"base/", forcenew:false, blocking:true});
scripts.push({name:"images", ref:pre+"base/utils/", forcenew:false, blocking:true});
scripts.push({name:"a2a", ref:pre+"base/", forcenew:false, blocking:true});

scripts.push({name:"anne_msgs", ref:pre+"gui/", forcenew:false, blocking:true});
scripts.push({name:"anne_settings", ref:pre+"gui/", forcenew:false, blocking:true});

scripts.push({name:"services", ref:pre+"base/services/", forcenew:false, blocking:true});
scripts.push({name:"globals_service", ref:pre+"base/services/", forcenew:false, blocking:true});
scripts.push({name:"service_genprop", ref:pre+"base/services/", forcenew:false, blocking:true});
scripts.push({name:"arraymap", ref:pre+"base/utils/", forcenew:false, blocking:true}); 


scripts.push({name:"lukat", ref:pre+"tops/", forcenew:false, blocking:true});
scripts.push({name:"location", ref:pre+"base/", forcenew:false, blocking:true});
scripts.push({name:"CHASE", ref:pre+"network/", forcenew:false, blocking:true});
scripts.push({name:"tx_builder", ref:pre+"network/", forcenew:false, blocking:true});
scripts.push({name:"anne_relon_table", ref:pre+"gui/widgets/", forcenew:false, blocking:true});
scripts.push({name:"anne_table", ref:pre+"gui/widgets/", forcenew:false, blocking:true});
scripts.push({name:"anne-paginator", ref:pre+"gui/widgets/", forcenew:false, blocking:true});
scripts.push({name:"annex", ref:pre+"base/", forcenew:false, blocking:true});
scripts.push({name:"TALK", ref:pre+"base/", forcenew:false, blocking:true});

scripts.push({name:"login_solo", ref:"solo_parts/", forcenew:false, blocking:true});
scripts.push({name:"send_funds", forcenew:false, ref:"solo_parts/", blocking:true});
scripts.push({name:"anneid2", forcenew:false, ref:"solo_parts/", blocking:true});

scripts.push({name:"lnots", ref:pre+"tops/", forcenew:false, blocking:true});

scripts.push({name:"searchsettings", ref:pre+"gui/", forcenew:false, blocking:true});
scripts.push({name:"utils_3js", ref:pre+"gui/", forcenew:false, blocking:true});

scripts.push({name:"ghostdata", forcenew:false, ref:pre+"mem/", blocking:true});
scripts.push({name:"ghosts", forcenew:false, ref:pre+"tops/", blocking:true});

scripts.push({name:"revelatian", forcenew:false, ref:pre+"gui/", blocking:true});

//am i still using this?????
scripts.push({name:"DNDAlert", forcenew:false, ref:pre+"other/", blocking:true});
scripts.push({name:"md5.min", forcenew:false, ref:pre+"other/", blocking:true});


var blocking = 0;

var scriptLooper=function($callback, $verbose=false) {
    //console.log("loadings scripts:"+scripts.length);
    if (scripts.length) {
        var script = scripts.shift();
        const existingScript = document.getElementById(script.name);
        if (existingScript) {
            scriptLooper($callback, $verbose);
        }
        var ref = script.ref+script.name+".js";
        
        let myScript = document.createElement("script");

        //tack in module.
        if (script.type!=undefined) {
            myScript.setAttribute("type", script.type);
        }

        if (script.forcenew==true) ref = ref+"?v="+version;
        if (script.blocking==true) {
            blocking+=1;
            //console.log(script.name + " is blocking.. blocking:"+blocking);
            document.head.appendChild(myScript);
            
            myScript.onload = async()=> {
                blocking-=1;   
                if ($verbose) console.warn("loaded "+myScript.id+" blocking:"+blocking);    
                scriptLooper($callback, $verbose);
            }
        }
        myScript.src = ref;
        myScript.id = script.name+"_loadid";

    }
    else {
        //console.log("blocking:"+blocking);
        $callback();
    }
}

var initScriptLoads = async($callback, $verbose=false)=> {
    scriptLooper($callback, $verbose);
}
