
/** 
 * Functions that get and lookup stuff. 
 * 
 * getaaa,  lookupaaa, 'aaa'Lookup, extract..
 * 
 * @author {Mr.Scatman} 
 */

class mem_gets extends anne_singleton {
    constructor () {
        super(false);
    }
    init = function($MEM) {
    }


    /**
     * Is this neuron ($nObj) in the be downline of the neuron with temp_nid $temp_nid?
     * 
     * @param {anne_neuron} - the neuron you are checking
     * @param {int} - the temp nid of the class you are trying to see if the neuron is within.
     * @author {Mr.Scatman}  
     */
    besOf = function ($nObj, $target_temp_nid_class) {
        if (typeof $target_temp_nid_class !=="number") {
            if ($target_temp_nid_class.temp_nid!=undefined) $target_temp_nid_class = $target_temp_nid_class.temp_nid;
            alert("fix your bad (besOf) caller! 2nd param should be a integer, not a neuron!");
            return false;
        }
        
        //quick hit direct parent class.
        if ($nObj.bes[0]==$target_temp_nid_class) return true;

        return MEMG.chaseUpLineForParentMatch($nObj, $target_temp_nid_class);
    }

    //aliases
    isBes = function($nObj, $target_temp_nid_class) { return MEMG.besOf($nObj, $target_temp_nid_class); }
    besIn = function($nObj, $target_temp_nid_class) { return MEMG.besOf($nObj, $target_temp_nid_class); }
    isBeA = function($nObj, $target_temp_nid_class) { return MEMG.besOf($nObj, $target_temp_nid_class); }
    isBeOf = function($nObj, $target_temp_nid_class) { return MEMG.besOf($nObj, $target_temp_nid_class); }
    beIsA = function($nObj, $target_temp_nid_class) { return MEMG.besOf($nObj, $target_temp_nid_class); }
    

    /**
     * 
     * @param {anne_neuron} $nObj 
     * @param {Array} $bes_tnids 
     * @returns 
     */
    isBesOfs = function($nObj, $bes_tnids) {
        for (var b=0; b <$bes_tnids.length; b++) {
            var tnid = $bes_tnids[b];
            if (this.isBeOf($nObj, tnid)==true) return true;
        }
        return false;
    }


    /**
     * these are .tnid, .ntype objs not just an array of tnids.
     * @param {*} $nObj 
     * @param {*} $tnidntypeobs 
     * @returns 
     */
    isBesOfs2 = function($nObj, $tnidntypeobs) {
        for (var b=0; b <$tnidntypeobs.length; b++) {
            var obj = $tnidntypeobs[b];
            if ($nObj.ntype!=obj.ntype) continue;
            if (this.isBeOf($nObj, obj.tnid)==true) return true;
        }
        return false;
    }


    /**
     *   
     * @author {Mr.Scatman}  
     */
    buildParentLine=function($nObj, $bDOSELF=true, $bNIDARRAY=false, $tnidsunique=null, $ignoreToTnids=[]) {
        var tnids = $tnidsunique;
        if (tnids==null) tnids = [];
        if ($nObj==null) return tnids;
        if ($bDOSELF==true) tnids.push($nObj.temp_nid);

        if ($nObj.bes.length) {
            var bes = $nObj.bes;
            var lines = [];

            //not all bes are worth of be line chasing..
            //best to not PUT them in the bes array to begin with? (ie, be->eval->four
            for (var b=0; b < bes.length; b++) {
                var be_temp_nid = $nObj.bes[b];
                if (tnids.length && tnids.indexOf(be_temp_nid)!=-1) break;
                var nObj = MEMG.getNeuronByTempNid(be_temp_nid);
                if (nObj==null) return tnids;

                if ($ignoreToTnids.length>0 && $ignoreToTnids.indexOf(nObj.temp_nid)!=-1) break;

                //temp hack to honor polity and BE relns.. what we really need to honor
                //is any pre-defined BE_CHILDREN BE_PARENT relons which define
                //special be parentage for any given class.  These we can honor.. the other
                if (b!=0 && be_temp_nid!=MEM.polity.temp_nid && be_temp_nid!=MEM.ec_is.temp_nid) continue;
                lines.push(nObj);
                tnids.push(nObj.temp_nid);
            }

            //chase BE lines.  We inherit params from all BES.  (reconsidering this..)
            
            //we use tnids here to make sure we never chase any dupe lines.
            for (var ab=0; ab < lines.length; ab++) {
                MEMG.buildParentLine(lines[ab], false, true, tnids);
            }
        }

        if ($bNIDARRAY==true) return tnids;
        else return MEMG.getNObjsFromTempNidList(tnids);
    }


    /**
     *   
     * @author {Mr.Scatman}  
     */
    buildUpAndDownline=function($nObj, $bNIDARRAY=false, $bINSTS=false, $bDOSELF=true, $bINCLUDECLASS=true) {
        var childrenLines = [];
        $nObj.getAllDownlineChildren(childrenLines, 0, $bINSTS, $bNIDARRAY); 
        var parentLine = MEM.buildParentLine($nObj, $bDOSELF, $bNIDARRAY);
        if ($bINCLUDECLASS==true) {
            if ($bNIDARRAY==true) parentLine.push(MEM.class.temp_nid);
            else parentLine.push(MEM.class);
        }
        if (parentLine.length>1) parentLine = parentLine.reverse();
        return parentLine.concat(childrenLines);
    }


    /*** concatUplineRelons *************************************************
    * This expects the buildParentLineExtendedLive was used in the case     *
    * of chasing parents and assumes the array of nObjs is ordered from     *
    * highest on the tree (lowest be lvl) down (TOP DOWN).  It can then     *
    * override dupes params with the one it finds further DOWN.             *
    ******************************************************** Mr.Scatman ****/
    concatUplineRelons = function($arr, $aNewRels) {
        for (var r=0; r < $aNewRels.length; r++) {
            var newRel = $aNewRels[r];
            if ($arr.length) {
                var bDUPE=false;
                for (var x=0; x < $arr.length; x++) {
                    var existingRel = $arr[x];
                    if (existingRel.r==newRel.r && existingRel.to_s == newRel.to_s) {
                        if (existingRel.type==TYPE_PARAM) {
                            //take the new relon, it came later or was at same
                            //lvl but a primary be (not a sideways be)
                            $arr[x]=newRel; 
                            bDUPE=true;
                        }
                    }
                }
                if (bDUPE==false) $arr.push(newRel);
            }
            else $arr.push(newRel);
        }
    }


    buildParentLineExtendedLive=async($nObj, $retArr=null)=> {
        if ($nObj==null) return;
        $retArr.push($nObj);    //don't push inst's actual params
        if ($nObj.be && $nObj.bes.length) {
            var bes = $nObj.bes;
    
            if (bes.length && bes[0]!=MEM.class.temp_nid) {
                await CHASE.lookupMinTNids(bes);
            }
    
            //do this for each of our bes..  (chase the respective be lines..
            //chase the PRIMARY BE last.
            for (var b=bes.length-1; b >= 0; b--) {
                var be_nid = bes[b];
                var nObj = MEMG.getNeuronByTempNid(be_nid);
                await MEMG.buildParentLineExtendedLive(nObj, $retArr);
            }
        }
        return;
    }



    /**
     *   
     * @author {Mr.Scatman}  
     */
    chaseUpLineForParentMatch=function($nObj, $target_temp_nid) {
        if (typeof $target_temp_nid !=="number") {
            if ($target_temp_nid.temp_nid!=undefined) $target_temp_nid = $target_temp_nid.temp_nid;
            alert("fix your bad (chaseUpLineForParentMatch) caller! 2nd param should be a integer, not a neuron!");
            return false;
        }
        if ($target_temp_nid==$nObj.temp_nid) return true;
        var parentTempNid=$nObj.bes[0];
        var loops = 20;     //safety first. 
        while (loops>=0 && parentTempNid && parentTempNid!=MEM.___SELF___.temp_nid) {
            if (parentTempNid == $target_temp_nid) {
                //console.log("found target_temp_nid:"+$target_temp_nid);
                return true;
            }
            var thisNOBJ = MEMG.getNeuronByTempNid(parentTempNid);
            if (thisNOBJ.be_lvl==0) break;
            parentTempNid=thisNOBJ.bes[0];
            //console.log("(culfpm) "+thisNOBJ.text+" parentTempNid:"+parentTempNid);
            loops--;
        }
        var targetNOBJ = MEMG.getNeuronByTempNid($target_temp_nid);
        //console.log("did not find target_temp_nid:"+$target_temp_nid+" text:"+targetNOBJ.text+" nid:"+targetNOBJ.nid+" in be line of '"+$nObj.text+"' nid:"+$nObj.nid);
        return false;
    }


    /**
     * @author {Mr.Scatman}  
     */
    concatUniqueRelnToPrioritize=function($arr, $aNewRelons, $nidPriority, $bINHERITOK=true) {
        for (var r=0; r < $aNewRelons.length; r++) {
            var newRel = $aNewRelons[r];
            if ($arr.length) {
                var bDUPE=false;
    
                //could use a prototype search here, but meh
                for (var x=0; x < $arr.length; x++) {
                    var existingRel = $arr[x];
                    
                    //no inherits for these.
                    if ($bINHERITOK==false && existingRel.f!=$nidPriority) continue;

                    //we have an inherited dupe.. take the nidPriority one!
                    if (existingRel.r==newRel.r && existingRel.to_s == newRel.to_s) {
                        if (existingRel.f==$nidPriority) {
                            bDUPE=true;
                            break;
                        }
                        
                        //swap out the existing with this one!
                        else {
                            $arr[x]=newRel;
                            bDUPE = true;
                            break;
                        }
                    }
                }
                if (bDUPE==false) $arr.push(newRel);
                else continue;
            }
            else $arr.push(newRel);
        }
    }
    

    /**
     * Search the text, case-insensitive, of all neurons in local memory.
     * 
     * @author {Mr.Scatman}  
     */
    extractAllFromRelons=function($aRelons, $bSKIPIFHASTEXT=true, 
                                    $bDOEXTRAS=false, $skipRelnNids=[], $bDONIDS=false) {
        var aList = [];
        var aNidsList = [];
        var chase_nids = [];
        
        for (var r=0; r < $aRelons.length; r++) {
            var rObj = $aRelons[r];
            if (rObj.to_type!=TO_TYPE_ANNE) continue;
            
            //we aren't extracting from these....
            if ($skipRelnNids.length && $skipRelnNids.indexOf(rObj.r)!=-1) continue;    

            var fNObj = MEMG.getNeuronByNid(rObj.from_nid);
            if (fNObj==null) {
                if (chase_nids.indexOf(rObj.from_nid)==-1) chase_nids.push(rObj.from_nid);
                continue;
            }

            var rNObj = MEMG.getNeuronByNid(rObj.reln);
            if(rNObj==null) {
                if (chase_nids.indexOf(rObj.reln)==-1) chase_nids.push(rObj.reln);
                continue;
            }

            var toNObj = MEMG.getNeuronByNid(rObj.to_s);
            if(toNObj==null) {
                if (chase_nids.indexOf(rObj.to_s)==-1) chase_nids.push(rObj.to_s);
                continue;
            }
        }

        
        //chase_nids if we have them
        //await ANNE.CHASE.lookupMinList(chase_nids, [0,1,2,3,7]);
            
        for (var r=0; r < $aRelons.length; r++) {
            var rObj = $aRelons[r];
            if (rObj.to_type!=TO_TYPE_ANNE) continue;
            
            //we aren't extracting from these....
            if ($skipRelnNids.length && $skipRelnNids.indexOf(rObj.r)!=-1) continue;    

            var fNObj = MEMG.getNeuronByNid(rObj.from_nid);
            if (fNObj==null) continue;
            
            if ($bSKIPIFHASTEXT==true && fNObj.text!=""); 
            else if (fNObj.bCHASED_min==undefined && aNidsList.indexOf(fNObj.temp_nid)==-1) {
                aList.push(fNObj.nid);
                aNidsList.push(fNObj.temp_nid);
            }
            var rNObj = MEMG.getNeuronByNid(rObj.reln);
            if ($bSKIPIFHASTEXT==true && rNObj.text!="");
            else if (rNObj.bCHASED_min==undefined && aNidsList.indexOf(rNObj.temp_nid)==-1) {
                aList.push(rNObj.nid);
                aNidsList.push(rNObj.temp_nid);
            }
            
            
            var tNObj = null;
            if (rObj.t!=undefined) tNObj = MEMG.getNeuronByNid(rObj.to_s);
            else {
                tNObj = MEMG.getOrMakeIfNew(rObj.to_s);
                if (tNObj!=null) {
                    rObj.t = tNObj.temp_nid;   //fix it while we are here.
                    if ($bSKIPIFHASTEXT==true && tNObj!=null && tNObj.text!="");
                    else if (tNObj.bCHASED_min==undefined && aNidsList.indexOf(tNObj.temp_nid)==-1) {
                        aList.push(tNObj.nid);
                        aNidsList.push(tNObj.temp_nid);
                    }
                }
            }

            if ($bDOEXTRAS==true) {
                if (rObj.owned_by!=undefined && rObj.owned_by!="") {
                    var ownedByNObj = MEMG.getOrMakeIfNew(rObj.owned_by);
                    if ($bSKIPIFHASTEXT==true && ownedByNObj.text!="");
                    else if (ownedByNObj.bCHASED_min==undefined && aNidsList.indexOf(ownedByNObj.temp_nid)==-1) {
                        aList.push(ownedByNObj.nid);
                        aNidsList.push(ownedByNObj.temp_nid);
                    }
                }
                if (rObj.sponsored_by!=undefined && rObj.sponsored_by!="") {
                    var sponsoredByNObj = MEMG.getOrMakeIfNew(rObj.sponsored_by);
                    if ($bSKIPIFHASTEXT==true && sponsoredByNObj.text!="");
                    else if (sponsoredByNObj.bCHASED_min==undefined && aNidsList.indexOf(sponsoredByNObj.temp_nid)==-1) {
                        aList.push(sponsoredByNObj.nid);
                        aNidsList.push(sponsoredByNObj.temp_nid);
                    }
                }
            }

        }
        if ($bDONIDS) return aNidsList;
        return aList;
    }


    /**
     * Search the text, case-insensitive, of all neurons in local memory.
     * 
     * @author {Mr.Scatman}  
     */
    extractAllFromRelonsAndChaseMin=async($aRelons, $SHARD=20, $bDOEXTRAS=false)=> {
        var temp_nids = MEMG.extractAllFromRelons($aRelons, true, $bDOEXTRAS, [], true);
        if (temp_nids.length==0) return;

        //chase out the min info on these nid addresses,
        var SHARD = $SHARD;
        if (temp_nids.length) {
            var lookup = [];
            for (var i=0; i  < temp_nids.length; i++) {
                if (lookup.length < SHARD) lookup.push(temp_nids[i]);
                else {
                    var done = await ANNE.CHASE.lookupMinTNids(lookup);
                    lookup = [];
                }
            }
            if (lookup.length) {
                var done = await ANNE.CHASE.lookupMinTNids(lookup);
                lookup = [];
            }
        }
        return;
    }


    /**
     * 
     */
    getDefines = function($nObj) {
        var nObjs = [];
        for (var r=0; r < $nObj.outs.length; r++) {
            if($nObj.outs[r].r==MEM.DEFINES.temp_nid) {
                var nObj = MEMG.getNeuronByTempNid($nObj.outs[r].t);
                nObjs.push(nObj);
            }
        }
        return nObjs;
    }


    /**
     *
     */
    getDefinedBy = function($nObj) {
        if ($nObj==undefined || $nObj==null) return null;
        for (var r=0; r < $nObj.outs.length; r++) {
            if($nObj.outs[r].r==MEM.DEFINED_BY.temp_nid) {
                var nObj = MEMG.getNeuronByTempNid($nObj.outs[r].t);
                return nObj;
            }
        }
        return null;
    }

    


    /**
     * Runtime relons for context.
     * This is not for display -- it is for dpool context resolutions.
     * Upline relons that are otherwise ignored (grandparents) in the standard inheritance
     * use are included in the results here to enable better context pool matching.
     */
    getRuntimeRelonsForContext = async($nid, $types)=> {
        var nObj = MEMG.getNeuronByNid($nid);
        if ($types==null) $types = [TYPE_SYS, TYPE_BE, TYPE_PARAM, TYPE_HAS, TYPE_CLUMP, TYPE_ROLE, TYPE_BRAIN];
        var bADDSELF = true;
        var bEXTRAPRETURN = true;
        
        //we want all dupes and all uplines.. we're not building a context pool.
        var bFORINHERITANCE = false;    

        var acceptable_outs = MEMG.getParentLineRelons(nObj, $types, [], bADDSELF, bEXTRAPRETURN, bFORINHERITANCE);

        var bUS = USER.isUsOrOwnedByUs(nObj.nid);
        var outs = acceptable_outs;
        if (outs.length==0) outs = nObj.outs;
        if (outs.length==0) return outs;

        //do our best to have basic info for all the parts of the relons.
        await MEMG.extractAllFromRelonsAndChaseMin(outs,true);
        
        var finalRelons=[];
        var _usedTXIDs=[];
        //var types=[0,1,2,3,5,6,7,8,9];

        for (var r=0; r < outs.length; r++) {
            var relon = outs[r];
            if (_usedTXIDs.indexOf(relon.txid)!=-1) continue;
            _usedTXIDs.push(relon.txid);
            finalRelons.push(relon);
        }

        return finalRelons;
    }


    /**
     * Get a comprehensive list of relons (including inherited) according to ANNE L1 protocol.
     * 
     * We do not get the special relon types here.. they apply only to the neuron they are on.
     * 
     * @param {string} - nid longstring 
     * @author {Mr.Scatman}
     */
    getRuntimeRelons = async($nid, $types=null)=> {
        if (($nid instanceof anne_neuron) == true) {
            if ($nid.nid!=undefined) {
                console.warn("(getRuntimerelons should take a nid, not a neuron!");
                $nid = $nid.nid;
            }
            else {
                console.warn("(getRuntimerelons) bad param");
                return [];
            }
        }

        var nObj = MEMG.getNeuronByNid($nid);
        
        //quick annode lookup??
        if (nObj==null) {
            alert("no nobj for getRuntimerelons");
            return;
        }

        var acceptable_outs = [];
        if ($nid!=USER._userNObj.nid) {
            if (MEM.tempBeIsA(nObj.temp_nid, MEM.identity.temp_nid, NTYPE_INST)==true) {
                var basic_other_identity_types  = [TYPE_HAS, TYPE_BE, TYPE_CLUMP, TYPE_ROLE];
                acceptable_outs = MEMG.prepForIdentity(nObj, basic_other_identity_types);
            }
            else {
                if ($types==null) $types = [TYPE_SYS, TYPE_BE, TYPE_PARAM, TYPE_HAS, TYPE_CLUMP, TYPE_ROLE, TYPE_BRAIN];
                var bADDSELF = true;
                var bEXTRAPRETURN = true;
                var bINHERITANCE = true;
                acceptable_outs = MEMG.getParentLineRelons(nObj, $types, [], bADDSELF, bEXTRAPRETURN, bINHERITANCE);
            }
        }

        //used for self-identity
        else {
            acceptable_outs = MEMG.prepForIdentity(nObj, $types);
        }

        //var bUS = USER.isUsOrOwnedByUs(nObj.nid);
        var outs = acceptable_outs;
        if (outs.length==0) outs = nObj.outs;
        if (outs.length==0) return outs;

        //do our best to have basic info for all the parts of the relons.
        await MEMG.extractAllFromRelonsAndChaseMin(outs,true);

        var finalRelons=[];
        var _usedTXIDs=[];

        for (var r=0; r < outs.length; r++) {
            var relon = outs[r];
           
            if (_usedTXIDs.indexOf(relon.txid)!=-1) continue;
            if (relon.type==TYPE_PARAM) {
                if (relon._multiples_ok==undefined || relon._multiples_ok==false) {
                    var toNObj = MEMG.getNeuronByNid(relon.to_s);
                    var bWEHAVEIT=false;
                    var relNOBJ = MEMG.getNeuronByTempNid(relon.r);

                    //roles are THE DEFINITION of the class concept.
                    //they are now bound by the PARAM restrictions.
                    //the params are for the roles IT assigns.
                    if (relNOBJ.ntype==NTYPE_CLASS && MEM.isRoleR(relon.r)==false) {
                        bWEHAVEIT = MEM.hasMetClassDefn(outs, relon, toNObj);
                        if (bWEHAVEIT == true) continue;
                    }
                }
            }
            
            _usedTXIDs.push(relon.txid);
            finalRelons.push(relon);
        }

        //gets relons from collab space (MEM_UDF._collab_relons)
        //this injects relons that are not in _aRelon space so we can
        //use them as if they were.  Only the ADMIN or submitter
        var andy_relons = MEM_UDF.getAndyTblRelonsForNid($nid);
        if (andy_relons!=null) {
            for (var a=0; a < andy_relons.length; a++) {
                if (_usedTXIDs.indexOf(andy_relons[a].txid)!=-1) continue;
                finalRelons.push(andy_relons[a]);
                _usedTXIDs.push(andy_relons[a].txid);
            }
        }
        return finalRelons;
    }
    
    
    /**
     */
     prepForIdentity = function($targetNOBJ, $types=null) {
        var inherit_relons = MEMG.getParentLineRelons($targetNOBJ,[TYPE_PARAM]);
        var acceptable_outs = [];
        var params = inherit_relons.params;
        var txids = [];

        //these are only params.
        for (var i=0; i < params.length; i++) {
            var rel=params[i];

            //identities are instances.  We will inherit the default class param of class->class and 
            //we don't want that in here.
            if (rel.r == MEM.class.temp_nid) continue;

            var fObj = MEMG.getNeuronByTempNid(rel.f);
            var rnOBJ = MEMG.getNeuronByTempNid(rel.r);
        
            //no params of sys classes.
            //these are set by sys processes.
            if (rnOBJ.bes[0] == MEM.__ANNE_SYS_CLASS.temp_nid) continue;

            //var dimen = MEMG.getRelonByTempR(rnOBJ.outs, MEM.relon_dimension.temp_nid);
            var target_relon_type = TYPE_HAS;
            if (rnOBJ.target_type!=undefined) {
                target_relon_type = rnOBJ.target_type;
            }

            //if (dimen!=null) target_relon_type = dimen.to_s;
            rel.target_type = target_relon_type;
            
            if (fObj.prompt!=undefined) rel.prompt = fObj.prompt;// :"";

            if (txids.indexOf(rel.txid)==-1) {
                acceptable_outs.push(rel);
                txids.push(rel.txid);
            }
        }
            
        var types = [];
        if ($types==null) types = [TYPE_HAS, TYPE_BE, TYPE_CLUMP, TYPE_ROLE];
        else types = $types;
        var hasbe_outs = MEMG.getAllRelonsOfType($targetNOBJ.outs, types);
        //ANNE.TALK.printRelons(hasbe_outs);
        if (hasbe_outs.length) {
            for (var h=0; h < hasbe_outs.length; h++) {
                var rel = hasbe_outs[h];
                if (txids.indexOf(rel.txid)==-1) {
                    acceptable_outs.push(rel);
                    txids.push(rel.txid);
                }
            }
        }
        return acceptable_outs;
    }


    /** 
     * @author {Mr.Scatman} 
     */
     getToTextOfRelon=function($rObj, $bSHORTOK=false) {
        if ($rObj.to_type==TO_TYPE_ANNE) {
            var tObj = MEMG.getNeuronByTempNid($rObj.t);
            if (tObj) {
                if ($bSHORTOK==true && tObj.short!=undefined) return tObj.short;
                return tObj.text;
            }
            else return "";
        }
        else return $rObj.to_s;
    }

    getAllRelonsWithRelnOnly=function($reln){
        var matches=[];
        for (var r=0; r < ANNE.MEM._aRelons.length; r++) {
            var rObj = ANNE.MEM._aRelons[r];
            if (rObj.reln==$reln) {
                matches.push(rObj);
            }
        }
        return matches;
    }

    /** 
     * @author {Mr.Scatman} 
     */
    getRelonsFromWith_fast = function ($outs, $type, $r, $to_type) {
        var matches=[];
        for (var r=0; r < $outs.length; r++) {
            var rObj = $outs[r];
            if (rObj.r==$r && rObj.type==$type && rObj.to_type==$to_type) {
                matches.push(rObj);
            }
        }
        return matches;
    }


    getRelonsFromWith2 = function ($outs, $type, $r) {
        var matches=[];
        for (var r=0; r < $outs.length; r++) {
            var rObj = $outs[r];
            if (rObj.r==$r && rObj.type==$type) {
                matches.push(rObj);
            }
        }
        return matches;
    }

    /**
     * This function is intended to be run and chase all relevant max info   
     * on parentLine, honoring garden and WV.                                
     * The chase for parents does not yet honor garden and WV because we     
     * first have to acquire it to know what the garden and WV is!          
     * Note: this was used in the DATA SOURCE building and not yet in the EXT
     * 
     * @author {Mr.Scatman} 
     */
    getParentLineParamsLive=async($nObj)=> {
        var selfAndUpNObjs = [];
        await MEMG.buildParentLineExtendedLive($nObj, selfAndUpNObjs);

        console.log(selfAndUpNObjs);

        //now we can honor garden/wv and get the params array.
        var allParamRelons = [];
        if (selfAndUpNObjs.length==0) return allParamRelons;
        selfAndUpNObjs.reverse();

        //for each item in our selfAndUp -- snag the PARAM relons.
        //process then from TOP DOWN to override w/ later relons.
        //TREES are defined bottom up but inherit top down -- so the child 
        //can override any inherited parent BE.
        for (var  n=0; n < selfAndUpNObjs.length; n++) {
            var lineNOBJ = selfAndUpNObjs[n];
            var aRelons = MEMG.getAllParamsOf(lineNOBJ.outs);
            if (aRelons) {
                MEMG.concatUplineRelons(allParamRelons, aRelons);
            }
        }
        return allParamRelons;
    }


    /** 
     * @author {Mr.Scatman} 
     */
     getSysTypeObjByTypeAndBe=function($enum_val, $beNObj) {
        var sObj=null;
        for (var s=0; s < MEM._SYS_TYPE_CODES.length; s++) {
            sObj = MEM._SYS_TYPE_CODES[s];
            if (sObj.SYS_ENUM_VAL==$enum_val && sObj.bes.indexOf($beNObj.temp_nid)!==-1) return sObj;
        }
        return null;
    }

    /**
     * 
     * @param {*} $enum_val 
     * @returns 
     */
    getSysTypeObjByType=function($enum_val) {
        var sObj=null;
        for (var s=0; s < MEM._SYS_TYPE_CODES.length; s++) {
            sObj = MEM._SYS_TYPE_CODES[s];
            if (sObj.SYS_ENUM_VAL==$enum_val) return sObj;
        }
        return null;    
    }

    /** 
     * @author {Mr.Scatman} 
     */
    getSysToTypeObjByTypeAndBe=function($enum_val, $beNObj) {
        var sObj=null;
        for (var s=0; s < MEM._SYS_TO_TYPE_CODES.length; s++) {
            sObj = MEM._SYS_TO_TYPE_CODES[s];
            if (sObj.SYS_ENUM_VAL==$enum_val && sObj.bes.indexOf($beNObj.temp_nid)!==-1) return sObj;
        }
        return null;
    }
    getSysToTypeObjByType=function($enum_val) {
        var sObj=null;
        for (var s=0; s < MEM._SYS_TO_TYPE_CODES.length; s++) {
            sObj = MEM._SYS_TO_TYPE_CODES[s];
            if (sObj.SYS_ENUM_VAL==$enum_val) return sObj;
        }
        return null;    
    }


    /**
     *   
     * @author {Mr.Scatman}  
     */
     getAllBesOf = function ($arr, $iggy_temps=[]) {
        var aMatches = [];
        for (var r=0; r < $arr.length; r++) {
            var rObj = $arr[r];
            if ($iggy_temps.length && $iggy_temps.indexOf(rObj.r)!=-1) continue;
            if (rObj.type==TYPE_BE) aMatches.push(rObj);
        }
        return aMatches;
    }


    /**
     *   
     * @author {Mr.Scatman}  
     */
    getAllSysMsgOf = function ($arr, $iggy_temps=[]) {
        var aMatches = [];
        for (var r=0; r < $arr.length; r++) {
            var rObj = $arr[r];
            if ($iggy_temps.length && $iggy_temps.indexOf(rObj.r)!=-1) continue;
            if (rObj.type==TYPE_SYS_MSG) aMatches.push(rObj);
        }
        return aMatches;
    }


    /**
     *   
     * @author {Mr.Scatman}  
     */
    getAllBrainsOf = function ($arr, $iggy_temps=[]) {
        var aMatches = [];
        for (var r=0; r < $arr.length; r++) {
            var rObj = $arr[r];
            if ($iggy_temps.length && $iggy_temps.indexOf(rObj.r)!=-1) continue;
            if (rObj.type==TYPE_BRAIN) aMatches.push(rObj);
        }
        return aMatches;
    }

        

    /**
     *   
     * @author {Mr.Scatman}  
     */
    getAllClasses = function () {
        var children = MEM.class.children;
        return MEMG.getNObjsFromTempNidList(children); 
    }


    /**
     *   
     * @author {Mr.Scatman}  
     */
    getALLNIDSINLOCALMEM = function($bINSTONLY=false) {
        var tnids = [];
        for (var n=0; n < MEM._aNeurons.length; n++) {
            if ($bINSTONLY==true) if (MEM_.aNeurons[n].ntype!=NTYPE_INST) continue;
            tnids.push(MEM._aNeurons[n].temp_nid);
        }
        return tnids;
    }


   /**
     */
    getAllRelonsOfType=function($outs, $types) {
        var matches=[];
        for (var r=0; r < $outs.length; r++) { if ($types.indexOf($outs[r].type)!==-1) matches.push($outs[r]);} 
        return matches;
    }


    /**
     *   
     * @author {Mr.Scatman}  
     */
    getAllSysOf = function ($arr, $iggy_temps=[]) {
        var aMatches = [];
        for (var r=0; r < $arr.length; r++) {
            var rObj = $arr[r];
            if ($iggy_temps.length && $iggy_temps.indexOf(rObj.r)!=-1) continue;
            if (rObj.type==TYPE_SYS) aMatches.push(rObj);
        }
        return aMatches;
    }
    

    /**
     *   
     * @author {Mr.Scatman}  
     */
    getAllUplineBes = function($nObj, $bes, $loops=0) {
        if ($loops>30) return "STOP";
        for (var b=0; b < $nObj.bes.length; b++) {
            var beNOBJ = MEMG.getNeuronByTempNid($nObj.bes[b]);
            if (beNOBJ.temp_nid==MEM.class.temp_nid) return;
            if ($bes.indexOf(beNOBJ.temp_nid)==-1) $bes.push(beNOBJ.temp_nid);
            var test = MEMG.getAllUplineBes(beNOBJ, $bes, $loops++);   //recurse up.. (shouldn't be long here..);  
            if (test=="STOP") return "STOP";
        }
        return;
    }


    /**
     * Extract all clump relons from a neuron.
     * These clump relons point to clumps so we can expect to handle them accordingly.
     * @author {Mr.Scatman}  
     */
     getAllClumpsOf = function ($arr, $iggy_temps=[]) {
        var aRelons = [];
        for (var r=0; r < $arr.length; r++) {
            var rObj = $arr[r];
            if ($iggy_temps.length && $iggy_temps.indexOf(rObj.r)!=-1) continue;
            if (rObj.type==TYPE_CLUMP) aRelons.push(rObj);
        }
        return aRelons;
    }

    getAllClumpNids = function ($arr, $iggy_temps=[]) {
        var clump_nids = [];
        for (var r=0; r < $arr.length; r++) {
            var rObj = $arr[r];
            if ($iggy_temps.length && $iggy_temps.indexOf(rObj.r)!=-1) continue;
            if (rObj.type==TYPE_CLUMP) {
                if (clump_nids.indexOf(rObj.to_s)==-1) clump_nids.push(rObj.to_s);
            }
        }
        return clump_nids;
    }


    /**
     * Extract all has relons from a neuron.
     * 
     * @author {Mr.Scatman}  
     */
    getAllHasOf = function ($arr, $iggy_temps=[]) {
        var aMatches = [];
        for (var r=0; r < $arr.length; r++) {
            var rObj = $arr[r];
            if ($iggy_temps.length && $iggy_temps.indexOf(rObj.r)!=-1) continue;
            if (rObj.type==TYPE_HAS) aMatches.push(rObj);
        }
        return aMatches;
    }


    /**
     * 
     */
     getAllInstNOBJS = function($skips=[]) {
        var nOBJS = [];
        for (var n=0; n < MEM._aNeurons.length; n++) {
            if(MEM._aNeurons[n].ntype==NTYPE_INST) {
                if ($skips.length && $skips.indexOf(MEM._aNeurons[n].bes[0])!=-1) continue;
                nOBJS.push(MEM._aNeurons[n]);
            }
        }
        return nOBJS;
    }


    /**
     * 
     */
    getAllInstTnids = function() {
        var tnids = [];
        for (var n=0; n < MEM._aNeurons.length; n++) {
            if(MEM._aNeurons[n].ntype==NTYPE_INST) tnids.push(MEM._aNeurons[n].temp_nid);
        }
        return tnids;
    }


    /**
     * Extract all param relons from a neuron.
     * 
     * @author {Mr.Scatman}  
     */
    getAllParamsOf = function ($arr, $relnMatching="", $iggy_temps=[]) {
        var aMatches = [];
        for (var r=0; r < $arr.length; r++) {
            var rObj = $arr[r];
            if ($iggy_temps.length && $iggy_temps.indexOf(rObj.r)!=-1) continue;
            if (rObj.type==TYPE_PARAM) {
                if ($relnMatching!="" && rObj.reln!=$relnMatching) continue;
                else aMatches.push(rObj);
            }
        }
        return aMatches;
    }

    /**
     * Extract all the semantic roles (proper) from a neuron.
     * The HAS/BE/PARAM are technically semantc in nature but they are
     * short-hand roles of the triplet format in their respective dimensions.   
     * @author {Mr.Scatman}  
     */
     getAllRolesOf = function ($arr, $iggy_temps=[]) {
        var aMatches = [];
        var txids = [];
        for (var r=0; r < $arr.length; r++) {
            var rObj = $arr[r];
            if ($iggy_temps.length && $iggy_temps.indexOf(rObj.r)!=-1) continue;
            if (rObj.type==TYPE_ROLE) {
                if (txids.indexOf(rObj.txid)==-1) {
                    aMatches.push(rObj);
                    txids.push(rObj.txid);
                }
            }
        }
        return aMatches;
    }
    

    /**
     * Get all relons with a reln of given types.
     * 
     * @param {array} - The outs
     * @param {array} - The acceptable reln temp_nids.
     * @param {array} - The acceptable types
     * 
     * @author {Mr.Scatman} 
    */
     getAllRelonsWithRelnTempNids=function($outs, $reln_temp_nids, $types) {
        if ($reln_temp_nids==undefined || $reln_temp_nids==null) {
            console.warn("fix this getAllRelonsWithRelnTempNids");
            return [];
        }
        var aMatches = [];
        if ($outs.length==0) return aMatches;
        for (var r=0; r < $outs.length; r++) {
            var rObj = $outs[r];
            if ($reln_temp_nids.indexOf(rObj.r)!=-1) {
                if ($types.length==0) aMatches.push(rObj);
                else if ($types.indexOf(rObj.type)!==-1) aMatches.push(rObj);
            }
        }
        return aMatches;
    }

    /**
     */
    getBELINEDelegation = function($nObj) {
        var dg = $nObj.delegation;
        if (dg==undefined) dg = [];
        var safety = 0;
        var parentNOBJ = MEMG.getNeuronByTempNid($nObj.bes[0]);
        while(parentNOBJ!=null && safety < 15) {
            if (parentNOBJ.delegation!=null && parentNOBJ.delegation.length) {
                dg = dg.concat(parentNOBJ.delegation);
            }
            if (parentNOBJ.be_lvl==0) break;
            if (parentNOBJ.bes.length==0) break;
            safety+=1;
            parentNOBJ = MEMG.getNeuronByTempNid(parentNOBJ.bes[0]);
        }
        return dg;
    }


    /**
     *   
     * @author {Mr.Scatman}  
     */
    getBeNOBJ=function($outs, $type) {
        if ($outs.length==0) return null;
        var temp_nid =-1;
        if ($type==NTYPE_INST) temp_nid = MEM.inst.temp_nid;
        else if ($type==NTYPE_CLASS) temp_nid = MEM.class.temp_nid;
        else return null;
    
        for (var r=0; r < $outs.length; r++) {
            if ($outs[r].r==temp_nid) return MEMG.getNeuronByTempNid($outs[r].t);
        }
        return null;
    }

    /**
     */
    getBeRelon=function($outs, $relnTnid) {
        for (var r=0; r < $outs.length; r++) {
            if ($outs[r].r==$relnTnid && $outs[r].type==TYPE_BE) return $outs[r];
        }
        return null;
    }
    getBeOrHasRelon=function($outs, $relnTnid) {
        for (var r=0; r < $outs.length; r++) {
            if ($outs[r].r==$relnTnid && ($outs[r].type==TYPE_BE || $outs[r].type==TYPE_HAS)) return $outs[r];
        }
        return null;
    }


    /**
     * 
     * @param {*} $outs 
     * @param {*} $relnTnid 
     * @returns 
     */
    getBeRelons=function($outs, $relnTnid) {
        var rels=[];
        for (var r=0; r < $outs.length; r++) {
            if ($outs[r].r==$relnTnid && $outs[r].type==TYPE_BE) rels.push($outs[r]);
        }
        return rels;
    }
    getBeOrHasRelons=function($outs, $relnTnid) {
        var rels=[];
        for (var r=0; r < $outs.length; r++) {
            if ($outs[r].r==$relnTnid && ($outs[r].type==TYPE_BE || $outs[r].type==TYPE_HAS)) rels.push($outs[r]);
        }
        return rels;
    }

    /**
     * 
     * @param {*} $outs 
     * @param {*} $relnTnid 
     * @param {*} $toS 
     * @returns 
     */
    getBeRelonTo=function($outs, $relnTnid, $toS) {
        for (var r=0; r < $outs.length; r++) {
            if ($outs[r].r==$relnTnid && $outs[r].type==TYPE_BE && $outs[r].to_s==$toS) return $outs[r];
        }
        return null;
    }

    /**
     * @author {Mr.Scatman}  
     */
    getBeParentRelon = function ($nObj) {
        for (var r=0; r < $nObj.outs.length; r++) {
            var rObj = $nObj.outs[r];
            if (rObj.type==TYPE_BE && (rObj.r==MEM.class.temp_nid || rObj.r==MEM.inst.temp_nid)) return $nObj.outs[r];
        }
        return null
    }
    
    /**
     * Get a bool object's options and supply it in a bool obj for gui use.
     * 
     * @param {anne_neuron} - the bool neuron
     * @author {Mr.Scatman} 
     * 
     */
     getBoolPair=function($boolNOBJ) {
        if ($boolNOBJ.children<2) return null;
        var boolObj = {yesNOBJ:null, noNOBJ:null}
        for (var c=0; c < $boolNOBJ.children.length; c++) {
            var childNOBJ = MEMG.getNeuronByTempNid($boolNOBJ.children[c]);
            if (childNOBJ.value==undefined || childNOBJ.value==null) {
                MEM.boolean.set_value(childNOBJ);
                if (childNOBJ.value==undefined || childNOBJ.value==null) return null;
                if (childNOBJ.value==1) boolObj.yesNOBJ = childNOBJ;
                else if (childNOBJ.value==0) boolObj.noNOBJ = childNOBJ;
            }
            else if (childNOBJ.value==1) boolObj.yesNOBJ = childNOBJ;
            else if (childNOBJ.value==0) boolObj.noNOBJ = childNOBJ;

        }

        if (boolObj.yesNOBJ!=null && boolObj.noNOBJ!=null) return boolObj;
        return null;
    }

    /** 
     * @author {Mr.Scatman} 
     */
     getEmulatedNeuronByClassAndValue=function($beNOBJ, $text) {
        var bEXACT = true;
        var bDOAKAS = false;
        var bEMULATEDOK = true;
        if ($beNOBJ==null) {
            console.log("rut roh");
            return null;
        }
        var aMatches = MEMS.searchText($text, [NTYPE_INST], bEXACT, bDOAKAS, $beNOBJ.temp_nid, bEMULATEDOK);
        if (aMatches.length) {
            return aMatches[0];
        }
        return null;
    }

    /**
     * 
     * @returns 
     */
    getGhosts = function() {
        var aGhosts = [];
        for (var n=0; n < MEM._aNeurons.length; n++) {
            if (MEM._aNeurons[n].ghost==true) {
                aGhosts.push(MEM._aNeurons[n]);
            }
        }
        ANNE.TALK.printNObjs(aGhosts);
        return aGhosts;
    }


    /** 
     * @author {Mr.Scatman} 
     */
    getTextListByRelonTos = function($relons, $sep=", ") {
        var list = [];
        for (var r=0; r < $relons.length; r++) {
            var rel = $relons[r];
            list.push( MEMG.__MASTER_DISPLAY_RELON_TO(rel) );
        }
        if (list.length==0) return list;
        else if (list.length==1) return list[0];
        return list.join($sep);
    }


    /** 
     * @author {Mr.Scatman} 
     */
    getGlobalNeuron=function($classNObj, $val) {
        //check for number.
        if ($classNObj.temp_nid==ANNE.MEM.number.temp_nid) {
            for (var n=0; n < ANNE.MEM.number.ins.length; n++) {
                var rObj = ANNE.MEM.number.ins[n];
                if (rObj.r == MEM.eval.temp_nid && rObj.reln.to_s==$val) {
                    return MEMG.getNeuronByTempNid(ANNE.MEM.number.ins[n].f);
                }
            }
        }
        else if ($classNObj.temp_nid==ANNE.MEM.date.temp_nid) {
            //alert("to do date get global")
        }
        else if ($classNObj.temp_nid==ANNE.MEM.location.temp_nid) {
            //alert("to do get location global");
        }
        else if ($classNObj.temp_nid==ANNE.MEM.neuronImg.temp_nid) {
            var in_mem_now = MEMG.getHasTo(ANNE.MEM.fileFingerPrint.temp_nid, $val);
            if (in_mem_now!=null) {
                return ANNE.MEMG.getNeuronByTempNid(in_mem_now.f);
            }
            for (var n=0; n < ANNE.MEM.neuronImg.ins.length; n++) {
                var rObj = ANNE.MEM.neuronImg.ins[n];
                var imgNOBJ = ANNE.MEMG.getNeuronByTempNid(rObj.f);
                var finger = ANNE.MEMG.getHasRelonTo(imgNOBJ.outs, ANNE.MEM.fileFingerPrint.temp_nid, $val);
                if (finger!=null) {
                    return imgNOBJ;
                }
            }
        }
        return null;
    }

    
    /**
     * No longer used?  (like a gazillion of these old functions...)
     * 
     * @param {*} $classNObj 
     * @param {*} $val 
     * @param {*} $reln 
     * @param {*} $to_s 
     * @returns 
     */
    getNeuronWithRelon=async($classNObj, $val, $reln, $to_s, $bEXACT=true)=> {
        
        //search local memmory for this thing by class and text
        var wvs = [];
        var bes_tnids = [$classNObj.temp_nid];
        if (ANNE.USER._bWORLDVIEWBIPASS==false) wvs = MEM.getWorldViewNidList();
        var searchObj = { 
            text:$val, 
            wvs:wvs, 
            bes:bes_tnids,
            bes_tnids:bes_tnids,
            exact:$bEXACT,
            applywvtobeline:$bAPPLYWVTOBELINE,
            inbeline:0,
            chaseIt:true
        };
        var bDOPRE = false; //ok to end by finding match
        var aMatches = await CHASE.anne_global_search(searchObj, bDOPRE);
        
        //verify if the matching things also have the desired relon (reln/to_s);
        var final_matches = [];
        if (aMatches.length) {
            for (var m=0; m < aMatches.length; m++) {
                var matchNOBJ = aMatches[m];
                if (MEMG.hasRelon(matchNOBJ.outs, $reln, $to_s)==true) {
                    final_matches.push(matchNOBJ);
                }
            }
        }

        //return an array(always)
        return final_matches;
    }



    /**
     * Get a subanndle in memory for a given parent anndle/subanndle.
     * @param {*} $parentNOBJ 
     * @param {*} $name 
     * @returns 
     */
    getSubAnndle = function($parentNOBJ, $name) {
        $name = $name.toLowerCase();
        for (var r=0; r< $parentNOBJ.outs.length; r++) {
            var rel = $parentNOBJ.outs[r];
            if (rel.r!=MEM.subanndle_of.temp_nid) continue;
            var nOBJ = MEMG.getNeuronByTempNid(rel.t);
            if (nOBJ.text.toLowerCase()==$name) return nOBJ;
        }
        return null;
    }


    /** 
     * @author {Mr.Scatman} 
     */
    getMineNObjs = function($mustBeNids=[]) {
        if (ANNE.USER==null) return;
        var owns = ANNE.USER._userNObj.owns;
        var nObjs = [];
        for (var n=0; n < owns.length; n++) {
            var nObj = MEMG.getNeuronByTempNid(owns[n]);
            if (nObj.mine==true) {
                if ($mustBeNids.length) {
                    if($mustBeNids.indexOf(nObj.bes[0])!==-1) nObjs.push(nObj);
                }
                else nObjs.push(nObj);
            }
        }
        return nObjs;
    }


    /** 
     * @author {Mr.Scatman} 
     * @param {anne_neuron} - the user
     * 
     * We will not pull rememberz here.. it only works with what is in local mem.
     * This is primarily intended for the logged-in user thus they will have all their
     * relons in mem already.
     */
    getRememberzNObjs = function($nObj) {
        var outs = $nObj.outs;
        var nObjs = [];
        for (var r=0; r < outs.length; r++) {
            var rel = outs[r];
            if (rel.type!=TYPE_AWARENESS) continue;
            if (rel.r!=MEM.rememberz.temp_nid) continue;
            if (rel.to_type!=TO_TYPE_ANNE) continue;
            var nObj = MEMG.getNeuronByTempNid(rel.t);
            nObjs.push(nObj);
        }
        return nObjs;
    }


    /**
     * 
     * @param {String} $sponsored_by - nid longstring 
     * @param {anne_neuron} $classNOBJ 
     * @returns 
     */
    getSponsoredBy=function($sponsored_by, $classNOBJ) {
        var sp_nObjs = [];
        var sp_audit=0;
        
        if ($classNOBJ instanceof anne_neuron == false) {
            console.log("pass nOBJ please, fix this");
            $classNOBJ=MEMG.getNeuronByNid($classNOBJ);
        }
        
        for (var n=0; n  < MEM._aNeurons.length; n++) {
            if (MEM._aNeurons[n].sponsored_by!=$sponsored_by) continue;
            sp_audit+=1;
            
            if (MEM._aNeurons[n].is($classNOBJ)==false) {
                continue;
            }
            
            sp_nObjs.push(MEM._aNeurons[n]);
        }
        console.log("(getSponsoredBy) sp_audit %c"+sp_audit, ANNE.TALK.bgyellow);
        return sp_nObjs;
    }
    
    
    /**
     * 
     * @param {*} $sponsored_by 
     * @param {anne_neuron} $classNOBJ
     * @returns 
     */
    getSponsoredByClasses=function($sponsored_by, $classNOBJ) {
        var sp_nObjs = [];
        var sp_audit=0;
        if ($classNOBJ instanceof anne_neuron == false) {
            console.log("pass nOBJ please, fix this");
            $classNOBJ=MEMG.getNeuronByNid($classNOBJ);
        }
        for (var n=0; n  < MEM._aNeurons.length; n++) {
            if (MEM._aNeurons[n].sponsored_by!=$sponsored_by) continue;
            sp_audit+=1;
            if (MEM._aNeurons[n].ntype!=NTYPE_CLASS) continue;
            if (MEM._aNeurons[n].is($classNOBJ)==false) continue;
            sp_nObjs.push(MEM._aNeurons[n]);
        }
        console.log("(getSponsoredByClasses) sp_audit %c"+sp_audit, ANNE.TALK.bgyellow);
        return sp_nObjs;
    }
    
    
    /**
     * 
     * @param {*} $str 
     * @param {*} $wvs 
     * @returns 
     */
    getDateNeuron=async($str, $wvs=[])=> {
        var arr = await ANNE.MEM.searchTextIndex($str);
        for (var a=0; a < arr.length; a++) {
            var nObj = arr[a];
            if ($wvs.length==0) {
                if (nObj.owned_by!=ANNE.MEM.ANNE_ACCTID && nObj.owned_by!=ANNE.USER._userNObj.nid) {
                    continue;
                }
            }

            if (nObj.bes.indexOf(ANNE.MEM.date_gregorian.temp_nid)!=-1) {
                return nObj;
            }
            else if (nObj.bes.indexOf(ANNE.MEM.monthyear.temp_nid)!=-1) {
                return nObj;
            }
            else {
                console.log("Matching nObj.text "+nObj.text+" but not a date.");
            }
        }
        return null;
    }

    

    /**
     * This is not going to be in RAM unless we lookup TYPE_SYS_MSGs..
     * Also problematic is these getting stuck in MEM (not deleted)...
     * as they are just temp relons.. They should NOT be stored in db mem, only local RAM!
     * @param {*} $outs 
     * @returns 
     */
    getUnconfirmedAnnex = function($outs){
        for (var r=0; r < $outs.length; r++) {
            var rel = $outs[r];
            if (rel.type!=TYPE_SYS_MSG) continue;

            //note: dont save this relon, EVER
            if (rel.reln!=ANNE.MEM.INTRA_BLOCK_PENDING.nid) continue; //intra block pending.
            
            if (rel.to_s!="pending annex chg") continue;
            if (rel.sys_ref_txid==undefined) continue;

            if (rel.sys_ref_txid==rel.txid) {
                console.log("WHY?????????");
                continue;
            }
            var annex_rel = MEMG.lookupByTXID(rel.sys_ref_txid);
            if (annex_rel && annex_rel.r==MEM.annex.temp_nid && annex_rel.time<=0) {
                return annex_rel;//s.b -1 for unconf, fixing that now.
            }
            else {
                console.log("what is up with this????");
            }
        }

        //lookup here with API.. it is worth the trouble to save the user
        //adding info to their queue and getting a failed send.
        
        return null;
    }


    /** 
     * Can filter for specific types of things
     * @author {Mr.Scatman} 
     */
     getIdentityStuff = function($identity_nid, $bDOINGOWNED=true, $bDOINGSPONSORED=true, $bDOINGREMEMBERZ=true, $bGHOSTS=true, $filter_tnids=[]) {
        var identity_nObj = MEMG.getOrMakeIfNew($identity_nid);
        if (identity_nObj.owns==null) identity_nObj.owns=[];
        var nObjs = [];
        var tnids = []; //faster to check for dupes.. doesn't return out.
        var missing = [];
        var ghost_skips = 0;
         
        if ($bDOINGOWNED==true && identity_nObj.owns!=null) {
            for (var n=0; n < identity_nObj.owns.length; n++) {
                var nObj = MEMG.getNeuronByTempNid(identity_nObj.owns[n]);
                if ($bGHOSTS==false && nObj.ghost==true) {
                    ghost_skips+1;
                    continue;
                }
                if (nObj==null) {
                    if (missing.indexOf(nObj.nid)!=-1) missing.push(nObj.nid);
                    continue;
                }
                if ($filter_tnids.length && MEM.isInBeLines(nObj, $filter_tnids)==true) continue;
                if (tnids.indexOf(nObj.temp_nid)==-1) {
                    nObjs.push(nObj);
                    tnids.push(nObj.temp_nid);
                }
            }
        }

        //this should work for any user (now) if we have the relons.
        if ($bDOINGSPONSORED==true) {
            MEMG.setMySponsored(identity_nObj.nid);
            for (var s=0; s < identity_nObj.my_sponsored.length; s++) {
                var nObj = MEMG.getNeuronByTempNid(identity_nObj.my_sponsored[s]);
                if (nObj==null) {
                    if (missing.indexOf(nObj.nid)!=-1) missing.push(nObj.nid);
                    continue;
                }

                //shouldn't be remembering neurons if they have a sponsored by.. this is likely ptless
                if ($bGHOSTS==false && nObj.ghost==true) {  
                    ghost_skips+1;
                    continue;
                }
                if ($filter_tnids.length && MEM.isInBeLines(nObj, $filter_tnids)==true) continue;
                
                if (tnids.indexOf(nObj.temp_nid)==-1) {
                    nObjs.push(nObj);
                    tnids.push(nObj.temp_nid);
                }
            }
        }

        //this will work with any user if we have the data..
        //typically we WON'T be pulling all their awareness relons.
        if ($bDOINGREMEMBERZ==true) {
            var nObjRememberz = MEMG.getRememberzNObjs(identity_nObj);
            for (var n=0; n < nObjRememberz.length; n++) {
                var nObj = nObjRememberz[n];
                if (nObj==null) {
                    if (missing.indexOf(nObj.nid)!=-1) missing.push(nObj.nid);
                    continue;
                }

                //shouldn't be remembering ghosts.. this is likely ptless
                if ($bGHOSTS==false && nObj.ghost==true) { 
                    ghost_skips+1;
                    continue;
                }
                if ($filter_tnids.length && MEM.isInBeLines(nObj, $filter_tnids)==true) continue;
                
                if (tnids.indexOf(nObj.temp_nid)==-1) {
                    nObjs.push(nObj);
                    tnids.push(nObj.temp_nid);
                }
            }
        }

        //consider chasing.
        if (ANNE.SETTINGS.debug()==true) {
            console.log(missing);
            console.log("ghost skips:"+ ghost_skips);
        }
        return nObjs;
    }


    /** 
     * @author {Mr.Scatman} 
     */
     getMyStuffByClass = function($identity_nid, $bDOINGOWNED=true, $bDOINGSPONSORED=true, $bDOINGREMEMBERZ=true, $bGHOSTS=true, $class_tnids=[], $ntypes=[]) {
        var identity_nObj = MEMG.getOrMakeIfNew($identity_nid);
        if (identity_nObj.owns==null) identity_nObj.owns=[];

        //pull mystuff from local db first.

        var nObjs = [];
        var tnids = []; //faster to check for dupes.. doesn't return out.
        if ($bDOINGOWNED==true && identity_nObj.owns!=null) {
            for (var n=0; n < identity_nObj.owns.length; n++) {
                var nObj = MEMG.getNeuronByTempNid(identity_nObj.owns[n]);
                if ($ntypes.length && $ntypes.indexOf(nObj.ntype)==-1) continue;
                if ($class_tnids.length>0 && MEM.isInBeLines(nObj, $class_tnids)==false) continue;
                if ($bGHOSTS==false && nObj.ghost==true) continue;
                if (tnids.indexOf(nObj.temp_nid)==-1) {
                    nObjs.push(nObj);
                    tnids.push(nObj.temp_nid);
                }
            }
        }

        //this should work for any user (now) if we have the relons.
        if ($bDOINGSPONSORED==true) {
            
            //do it again anyways.
            MEMG.setMySponsored(identity_nObj.nid);

            for (var s=0; s < identity_nObj.my_sponsored.length; s++) {
                var nObj = MEMG.getNeuronByTempNid(identity_nObj.my_sponsored[s]);
                if ($ntypes.length && $ntypes.indexOf(nObj.ntype)==-1) continue;
                if ($class_tnids.length && MEM.isInBeLines(nObj, $class_tnids)==false) continue;
                if ($bGHOSTS==false && nObj.ghost==true) continue;
                if (tnids.indexOf(nObj.temp_nid)==-1) {
                    nObjs.push(nObj);
                    tnids.push(nObj.temp_nid);
                }
            }
        }

        if ($bDOINGREMEMBERZ==true) {
            var nObjRememberz = MEMG.getRememberzNObjs(identity_nObj);
            for (var n=0; n < nObjRememberz.length; n++) {
                var nObj = nObjRememberz[n];
                if (nObj==null) {
                    if (missing.indexOf(nObj.nid)!=-1) missing.push(nObj.nid);
                    continue;
                }
                //shouldn't be remembering ghosts.. this is likely ptless
                if ($bGHOSTS==false && nObj.ghost==true) continue;
                
                if (tnids.indexOf(nObj.temp_nid)==-1) {
                    nObjs.push(nObj);
                    tnids.push(nObj.temp_nid);
                }
            }
        }

        return nObjs;
    }
    

    /** 
     * @author {Mr.Scatman} 
     */
     getNeuronByNid = function ($nid, $maxFireWeight=0.03) {
        if ($nid == undefined || $nid == null || $nid == '') {
            console.log("(getNeuronByNid)nid address was not provided (null)");
            return null;
        }
        if (($nid+"").length<10) {
            console.warn("find the violators");
            return null;
        }
    
        return MEMG.__hashNeuronLookup($nid, $maxFireWeight);
    }


    /** 
     * @author {Mr.Scatman} 
     */
    getNeuronByPendingNid=function($pending_nid) {
        var parts = $pending_nid.split("_");
        if (parts[0]=="new") return MEMG.__hashNeuronLookup(parts[1]);
        console.log("trouble with pending nid");
        return null;
    }


    /** 
     * @author {Mr.Scatman} 
     */
     getNeuronByTempNid = function ($temp_nid, $maxFireWeight=0.01) {
        if ($temp_nid==undefined) return null;
        //signa anne chain convert TEST.. REMOVE THIS CHECK AFTER VETTING.
        if ((""+$temp_nid).length>8) {
            console.warn("error in getNeuronByTempNid "+$temp_nid+"(intended getNeuronByNid??)");
            return MEMG.getNeuronByNid($temp_nid);
        }
        var temp = parseInt($temp_nid);
        if (isNaN(temp)==true) return null;

        if (ANNE.BRAIN!=null) {
            ANNE.BRAIN.fireNeuron(ANNE.MEM._aNeurons[temp], $maxFireWeight);
        }

        return ANNE.MEM._aNeurons[temp];
    }

    
    /**
     * TODO: reroute this if text indexes are not turned on.
     * They can be memory intense.
     * @param {*} $str 
     * @returns an array of tnids for the neurons
     */
    getTnidsByAnbl = function($str) {
        var str = $str.toLowerCase();
        str = str.trim();
        return ANNE.BRAIN.getTnidsByAnbl(str);
    }
    

    /** 
     * NOT very fast, in any use of the word.  MUCH MORE IDEAL to use the 
     * getNObjsFromTempNidList now that bes, adopted, and children arrays 
     * are all temp_nid index arrays.       
     *  
     * @author {Mr.Scatman} 
     */
    getNObjsFromNidList=function($aList) {
        var aNObjs = [];
        for (var n=0; n<$aList.length;n++) {
            if ($aList[n]==undefined || $aList[n]==null) {
                console.warn("(getNObjsFromNidList) bad data in arr")
                continue;
            }
            var nObj = MEMG.getNeuronByNid($aList[n]);
            aNObjs.push(nObj);
        }
        return aNObjs;
    }

    getNObjsFromRelonsToS=function($relons) {
        var aNObjs = [];
        for (var r=0; r<$relons.length;r++) {
            if ($relons[r]==undefined || $relons[r]==null) {
                console.warn("(getNObjsFromRelonsToS) bad data in arr")
                continue;
            }
            if ($relons[r].to_type!=TO_TYPE_ANNE) continue;
            var nObj = MEMG.getNeuronByTempNid($relons[r].t);
            aNObjs.push(nObj);
        }
        return aNObjs;
    }

    /** 
     * @author {Mr.Scatman} 
     */    
    getNObjsFromTempNidList=function($aList, $ignoreList=[], $bINSTSONLY=false) {
        var aNObjs = [];
        for (var n=0; n<$aList.length;n++) {
            var val = $aList[n];

            //sometimes we accidently pass in neurons here and not temp_nids.
            if ((val instanceof anne_neuron) == true) {
                if ($ignoreList.length && $ignoreList.indexOf(val.nid)!=-1) continue;
                aNObjs.push(val);
            }
            else {
                var nObj = MEMG.getNeuronByTempNid($aList[n]);
                if ($ignoreList.length && $ignoreList.indexOf(nObj.nid)!=-1) continue;
                if ($bINSTSONLY==true && nObj.ntype==NTYPE_INST) continue;
                aNObjs.push(nObj);
            }
        }
        return aNObjs;
    }


    /**
     * Get or make a new integer.
     * @param {*} $int 
     * @returns 
     */
    getOrMakeIfNewInteger=async($aec, $int)=> {
        var intyr = $int+"";
        
        for (var i=0; i < ANNE.MEM.integer.ins.length; i++) {
            var intNOBJ = ANNE.MEMG.getNeuronByTempNid( ANNE.MEM.integer.ins[i].f);
            if (intNOBJ==null) continue;
            if (intNOBJ.text==intyr) {
                return intNOBJ;
            } 
        }
        var result = await CHASE.getGlobal(ANNE.MEM.integer, intyr);
        if (result.status=="good" && result.message=="available") {
            if ($aec!=null) $aec.printf("added new integer neuron", _BLUE, intyr);
            var ghostNOBJ = await GHOSTDATA.makeGhostNeuron(ANNE.MEM.integer, intyr, NTYPE_CLASS);
            return ghostNOBJ;
        }
        else {
            if ($aec!=null) $aec.printf("found existing integer", _YELLOW, intyr);
            console.log(result);
            console.log("already exists");
            return result.result;//this should be the nOBJ
        }
    }


    /**
     * 
     * @param {anne_external_connector} $aec 
     * @param {*} $name 
     * @param {*} $extraReln 
     * @param {*} $extraTo 
     * @returns 
     */
    getOrMakeIfNewPerson=async($aec, $name, $extraReln=null, $extraToType=null, $extraTo=null, $bEARLYEXIT=false)=> {        
        if ($extraReln==null && $aec!=null && $aec.hasPerson($name)==true) {
            return {status:"good", match:$aec.getPerson($name)};
        }

        var name = $name.toLowerCase();
        
        var extraRelnNOBJ = null;
        if ($extraReln!="" && $extraReln!=null) extraRelnNOBJ = MEMG.getNeuronByNid($extraReln);
        
        for (var i=0; i < MEM.person.ins.length; i++) {
            if (MEM.person.ins[i].type!=TYPE_BE) continue;
            if (MEM.person.ins[i].r!=MEM.inst.temp_nid) continue;
            var personNOBJ  = MEMG.getNeuronByTempNid( MEM.person.ins[i].f);
            if (personNOBJ==null) continue;

            if (personNOBJ.text.toLowerCase()==name) {
                if (extraRelnNOBJ!=null) {
                    //var wikirel = MEMG.getHasRelon(nObj.outs, ANNE.MEM.wikipart.temp_nid);
                    var rel = MEMG.getRelonByTempR(personNOBJ.outs, extraRelnNOBJ.temp_nid);
                    if (rel!=null) {
                        if (rel.to_s!=$extraTo) continue;
                    }
                }

                $aec.printf("found existing person (by alias) of", _YELLOW, $name);
                return {status:"good", match:personNOBJ};
            }
            if (personNOBJ.aka_lower!=null && personNOBJ.aka_lower.length>0) {
                if (personNOBJ.aka_lower.indexOf(name)!=-1) {
                    if (extraRelnNOBJ!=null) {
                        var rel = MEMG.getRelonByTempR(personNOBJ.outs, extraRelnNOBJ.temp_nid);
                        if (rel!=null) {
                            if (rel.to_s!=$extraTo) continue;
                        }
                    }
                    if ($aec!=null) $aec.printf("found existing person (by alias) of", _YELLOW_i, $name);
                    return {status:"good", match:personNOBJ};
                }
            }
        }

        if ($bEARLYEXIT==true) return {status:"early_exit"};


        //would be lovely if we could have snagged the 0/1 relons here..
        //hmmmm.
        var NOBJS = await CHASE.queryFoNeuronByClassAndRelon(MEM.person, $name, $extraReln, $extraToType, $extraTo);
        
        if (NOBJS!=undefined && NOBJS!=null && NOBJS.length) {
            if (NOBJS.length==1) {
                var bAUDITFAIL=false;

                //audit
                if (extraRelnNOBJ!=null) {
                    var rel = MEMG.getRelonByTempR(NOBJS[0].outs, extraRelnNOBJ.temp_nid);
                    if (rel!=null) {
                        if (rel.to_s!=$extraTo) {
                            console.log("AUDIT FAIL SMOKEY.");
                            bAUDITFAIL=true;
                        }
                    }
                }
                
                if (bAUDITFAIL==true) {
                    if ($aec!=null)$aec.printf("AUDIT FAIL, ambiguous persons for", _GREEN, $name);
                    return {status:"ambiguous", matches:NOBJS};
                }

                if ($aec!=null)$aec.printf("found existing person", _YELLOW, $name);
                return {status:"good", match:NOBJS[0]};
            }
            else {

                //figure out why we have ambiguous results here.
                for (var n=0; n < NOBJS.length; n++) {
                    console.log(NOBJS[n].text+" "+NOBJS[n].nid);
                    ANNE.TALK.printRelons(NOBJS[n].outs);
                }
            }
            if ($aec!=null) $aec.printf("ambiguous persons for", _GREEN, $name);
            return {status:"ambiguous", matches:NOBJS};
        }

        //this will make a first name + last name alias if there is no suffix
        var nObj = await GHOSTDATA.makeGhostNeuron(MEM.person, $name, NTYPE_INST);
        if ($aec!=null) $aec.addPerson(nObj);
        if ($aec!=null) $aec.printf("added new person", _YELLOW, $name);
        return {status:"good", match:nObj};
    }


    /**
     * 
     * @param {*} $parentClass 
     * @returns 
     */
    estimateClassNames = function($parentClass) {
        var downline =[];
        var names = [];
        $parentClass.getAllDownlineChildren(downline,0, false, false, false, false); 
        for (var d=0; d <downline.length; d++) {
            var ctNOBJ = downline[d];
            names.push(ctNOBJ.text);
        }
        return names;
    }
    

    /**
     * Easy and quick way to get or make a new ghost corp.
     * @param {*} $name 
     * @param {*} $companyTypeNOBJ 
     * @returns 
     */
    getOrMakeIfNewCorp=async($aec, $name, $companyTypeNOBJ=null)=> {
        if ($aec.hasCorp($name)==true) {
            return {status:"good", match:$aec.getCorp($name)};
        }

        var desperados = [];

        //use the new text index, better
        var aMatches = await CHASE.nakeSearchForResolution($name, MEM.company.temp_nid);
        //console.log(aMatches);    

        if (aMatches.length>0) {
            if ($companyTypeNOBJ==null) {
                $aec.printf("found existing corp of",_GREEN);
                return {status:"good", match:aMatches[0]};
            }

            //if we have a companyTypeNOBJ requirement..
            for(var m=0; m < aMatches.length; m++) {
                var ct = "";
                if (aMatches[m]._company_type==undefined) {
                    var ct_rel = MEMG.getRelonFromWithR(aMatches[m].outs, TYPE_BE, MEM.company_type.temp_nid);
                    if (ct_rel!=null) {
                        ct = ct_rel.to_s;
                        aMatches[m]._company_type=ct_rel.to_s;
                    }
                    else {
                        desperados.push(aMatches[m]);
                        continue;
                    }
                }
                else ct = aMatches[m]._company_type;

                var ctypeNOBJ = MEMG.getNeuronByNid(ct);

                if (ctypeNOBJ && ctypeNOBJ.is($companyTypeNOBJ)==true) {
                    $aec.printf("found existing corp of", _YELLOW, $name,_WHITE, "of type", _BLUE_i,$companyTypeNOBJ.text);
                    return {status:"good", match:aMatches[m]};
                }

                //we changed the company type logic, so just take the damn thing.
                //we don't want dupes based on reparses of this.
                else desperados.push(aMatches[m]);
            }
        }


        if (desperados.length) {
            if (desperados.length==1){
                $aec.printf("found existing corp of", _YELLOW,$name);
                return {status:"good", match:desperados[0]};
            }
            else {
                $aec.printf("found ambiguous corps of", _GREEN,$name);
                return {status:"ambiguous", matches:desperados};
            }
        }

        
        var ghostNOBJ = await GHOSTDATA.makeGhostNeuron(MEM.company, $name, NTYPE_INST);
        $aec.addCorp(ghostNOBJ);
        if ($companyTypeNOBJ!=null) {
            await GHOSTDATA.makeGhostRelon(TYPE_BE, ghostNOBJ, MEM.company_type.nid, TO_TYPE_ANNE, $companyTypeNOBJ.nid);
            ghostNOBJ._company_type = $companyTypeNOBJ.nid;
            $aec.printf("added new corp", _GREEN, $name, _WHITE, "of type", _BLUE_i,$companyTypeNOBJ.text);
        }
        else {
            $aec.printf("added new corp", _GREEN, $name);
        }
        return {status:"good", match:ghostNOBJ};
    }



    /**
     * Easy and quick way to get or make a new ghost corp.
     * @param {*} $name 
     * @returns 
     */
    getOrMakeIfNewGroup=async($aec, $name, $bCOMPANYOK=false)=> {
        if ($aec.hasGroup($name)==true) {
            return {status:"good", match:$aec.getGroup($name)};
        }
        var name = $name.toLowerCase();
        for (var i=0; i < MEM.group.ins.length; i++) {
            if (MEM.group.ins[i].type!=TYPE_BE) continue;
            if (MEM.group.ins[i].r!=MEM.inst.temp_nid) continue;
            var thisGroupNOBJ  = MEMG.getNeuronByTempNid( MEM.group.ins[i].f);
            if (thisGroupNOBJ==null) continue;
            if (thisGroupNOBJ.text.toLowerCase()==name) {
                $aec.printf("found existing group of", _YELLOW, $name);
                return {status:"good", match:thisGroupNOBJ};
            }
            if (thisGroupNOBJ.aka_lower!=null && thisGroupNOBJ.aka_lower.length>0) {
                if (thisGroupNOBJ.aka_lower.indexOf(name)!=-1) {
                    $aec.printf("found existing group (by alias) of", _YELLOW_i, $name);
                    return {status:"good", match:thisGroupNOBJ};
                }
            }
        }
        
        var NOBJS = await  CHASE.queryFoNeuronByClassAndRelon(MEM.group, $name, null, null, null);
        if (NOBJS.length>0) {
            if (NOBJS.length==1) {
                $aec.printf("found existing group of", _YELLOW, $name);
                return {status:"good", match:NOBJS[0]};
            }
            $aec.printf("ambiguous group for", _GREEN, $name);
            return {status:"ambiguous", matches:NOBJS};
        }

        
        //could be a company already! (like cfr)
        if ($bCOMPANYOK==true) {
             for (var i=0; i < MEM.company.ins.length; i++) {
                if (MEM.company.ins[i].type!=TYPE_BE) continue;
                if (MEM.company.ins[i].r!=MEM.inst.temp_nid) continue;
                var thisCompanyNOBJ  = MEMG.getNeuronByTempNid( MEM.company.ins[i].f);
                if (thisCompanyNOBJ==null) continue;
                 
                if (thisCompanyNOBJ.text.toLowerCase()==name) {
                    $aec.printf("found existing corp (for group) of", _YELLOW, $name);
                    return {status:"good", match:thisCompanyNOBJ};
                }
            }   
        }
        
        
        var ghostNOBJ = await GHOSTDATA.makeGhostNeuron(MEM.group, $name, NTYPE_INST);
        $aec.addGroup(ghostNOBJ);
        $aec.printf("added new group", _BLUE, $name);
        return {status:"good", match:ghostNOBJ};
    }

    
    /**
     * 
     * @param {*} $aec 
     * @param {*} $name 
     * @returns 
     */
    getOrMakeIfNewReligion=async($aec, $name)=> {

        //converting zionism in parses, if a religion..
        //to judaism.
        
        if (name=="zionsim") {
            console.warn("DO NOT KEEP CREATING THIS!!!!");
            name = "judaism";    
            return {status:"good", match:ANNE.MEM.judaism};
        }

        if ($aec.hasReligion($name)==true) {
            return {status:"good", match:$aec.getReligion($name)};
        }
        var name = $name.toLowerCase();
        for (var i=0; i < MEM.religion.ins.length; i++) {
            if (MEM.religion.ins[i].type!=TYPE_BE) continue;
            if (MEM.religion.ins[i].r!=MEM.inst.temp_nid) continue;
            var thisReligionNOBJ  = MEMG.getNeuronByTempNid( MEM.religion.ins[i].f);
            if (thisReligionNOBJ==null) continue;
            if (thisReligionNOBJ.text.toLowerCase()==name) {
                $aec.printf("found existing religion of", _YELLOW, name);
                return {status:"good", match:thisReligionNOBJ};
            }
            if (thisReligionNOBJ.aka_lower!=null && thisReligionNOBJ.aka_lower.length>0) {
                if (thisReligionNOBJ.aka_lower.indexOf(name)!=-1) {
                    $aec.printf("found existing religion (by alias) of", _YELLOW_i, name);
                    return {status:"good", match:thisReligionNOBJ};
                }
            }
        }
        
        var NOBJS = await  CHASE.queryFoNeuronByClassAndRelon(MEM.religion, $name, null, null, null);
        if (NOBJS.length>0) {
            if (NOBJS.length==1) {
                $aec.printf("found existing religion of", _YELLOW, name);
                return {status:"good", match:NOBJS[0]};
            }
            $aec.printf("ambiguous religion for", _GREEN, name);
            return {status:"ambiguous", matches:NOBJS};
        }
        return {status:"no-new", matches:[], match:null};

        var ghostNOBJ = await GHOSTDATA.makeGhostNeuron(MEM.religion, $name, NTYPE_INST);
        $aec.addReligion(ghostNOBJ);
        return {status:"good", match:ghostNOBJ};
    }

    
    
    /**
     * Make a group event.
     * If we have a year in the group event name, extract it (keep it in the name)
     * and use that for a year relon from the group event.
     * 
     * If $bSTRIPSPOOKSNUMB=true and we have a number < 10 strip it off the neuron name.  We don't want that in the name
     * as it is from wikispooks to split up the pages.
     * @param {*} $groupEventName 
     * @returns 
     */
    getOrMakeIfNewGroupEvent=async($aec, $name, $bSTRIPSPOOKSNUMB=true)=>{
        var parts = $name.split("/");
        if (parts.length==0) parts = $name.split(" ");
        var makeYrRelonForYear = 0;
        var name = $name;
        if (parts.length>1) {
            var yrtag = parts[ parts.length-1];
            var yr = parseInt(yrtag);
            if (Number.isInteger(yr)==true) {
                //this is a tag they use to split up the page.  Ignore it!
                if ($bSTRIPSPOOKSNUMB==true && yr<10) {
                    parts.pop();
                    name = parts.join(" ");
                }
                
                //this will need a yr relon!
                else {
                   // console.log("tack on a yr "+yr+"relon to this event -- or wait until it is queried??");
                    name = parts.join(" ");
                    makeYrRelonForYear=yr;
                }
            }
            else name = parts.join(" ");
        }

        var nameLower = name.toLowerCase();
        if ($aec.hasGroupEvent(nameLower)==true) {
            return {status:"good", match:$aec.getGroupEvent(nameLower)};
        }
        for (var i=0; i < MEM.group_event.ins.length; i++) {
            if (MEM.group_event.ins[i].type!=TYPE_BE) continue;
            if (MEM.group_event.ins[i].r!=MEM.inst.temp_nid) continue;
            var groupEventNOBJ  = MEMG.getNeuronByTempNid( MEM.group_event.ins[i].f);
            if (groupEventNOBJ==null) continue;
            if (groupEventNOBJ.text.toLowerCase()==nameLower) {
                $aec.printf("found existing group event of", _YELLOW, name);
                return {status:"good", match:groupEventNOBJ};
            }
            if (groupEventNOBJ.aka_lower!=null && groupEventNOBJ.aka_lower.length>0) {
                if (groupEventNOBJ.aka_lower.indexOf(nameLower)!=-1) {
                    $aec.printf("found existing group event (by alias) of", _YELLOW_i, name);
                    return {status:"good", match:groupEventNOBJ};
                }
            }
        }

        //ANY RESULT MEANS THIS ALREADY EXISTS.
        var NOBJS = await  CHASE.queryFoNeuronByClassAndRelon(MEM.group_event, name, null, null, null);
        if (NOBJS.length>0) {
            var NOBJSFILTERED=[];

            //if we have year, we can have a match with a non-year..
            //but not a match with a different year.
            if (makeYrRelonForYear>0) {

                //how can this ever be null?
                var yrNOBJ = await MEMG.getOrMakeIfNewInteger($aec, makeYrRelonForYear);
                NOBJSFILTERED = MEMG.getFilteredRelnToCANTCONTRADICT(NOBJS, [{reln:MEM.role_when.nid, to_s:yrNOBJ.nid}]);
            }
            else NOBJSFILTERED = NOBJS;
            
            if (NOBJSFILTERED.length==1) {
                $aec.printf("found existing group event of", _YELLOW, name);
                return {status:"good", match:NOBJSFILTERED[0]};
            }
            $aec.printf("ambiguous group event for", _GREEN, name);
            return {status:"ambiguous", matches:NOBJSFILTERED};
        }

        var ghostNOBJ = await GHOSTDATA.makeGhostNeuron(MEM.group_event, name, NTYPE_INST);
        //console.log("%cmade new group event %c"+ghostNOBJ.text+ "%c"+ghostNOBJ.nid, TALK.bggreen, TALK.bgblack, TALK.bggred);
        if (makeYrRelonForYear>0) {
            var yrNOBJ = await MEMG.getOrMakeIfNewInteger($aec, makeYrRelonForYear);
            if ((yrNOBJ instanceof anne_neuron) == true) {  
                await GHOSTDATA.makeGhostRelon(TYPE_ROLE, ghostNOBJ, MEM.role_when.nid, TO_TYPE_ANNE, yrNOBJ.nid);
            }
            else console.log("not a integer neuron");
        }
        $aec.addGroupEvent(ghostNOBJ);
        $aec.printf("added new group event", _BLUE, name);
        return {status:"good", match:ghostNOBJ};
    }


    //confirms a NOBJ doesn't contradict a value.  (no value is ok)
    //if non-contradicting confirming value exists, will return on first full match if flag is set.
    //example.. WEF MEETING 2012, WEF MEETING,  WEF MEETING 2013
    
    //we get 3 neurons  (all above) and are looking to confirm which has a yr relon pting to 2013.
    //2nd is a non-contradicting hit, but 3rd is a direct hit.
    getFilteredRelnToCANTCONTRADICT=function($NOBJS, $partRels, $bRETURNFIRSTMATCH=true) {
        var finalNOBJS = [];

        for (var n=0; n < $NOBJS.length; n++) {
            var nObj = $NOBJS[n];
            var bNOBJ_NO_GOOD = true;

            var found_direct = 0;
            //loke, role_when-> to a specific year nid.
            for (var p=0; p < $partRels.length; p++) {
                var pRel = $partRels[p];
                var bREL_CONTRADICTS=false;
                for (var r=0; r < nObj.outs.length; r++) {
                    if (nObj.outs[r].reln==pRel.reln) {
                        if (nObj.outs[r].to_s == pRel.to_s) {
                            bREL_CONTRADICTS=false;
                            found_direct+=1;
                            break;
                        }
                        else {
                            bREL_CONTRADICTS = true;
                            break;
                        }
                    }    
                }
                if (bREL_CONTRADICTS==true) {
                    bNOBJ_NO_GOOD = true;
                    break;
                }

                //continue checking any other prel requirements that can't contradict.
                else {
                    bNOBJ_NO_GOOD = false;
                }
            }

            if (bNOBJ_NO_GOOD==false) {
                if ($bRETURNFIRSTMATCH==true && found_direct==$partRels.length) {
                    return [nObj];
                }
                finalNOBJS.push(nObj);
            }
            continue;
        }
        return finalNOBJS;
    }
    

    
    /** 
     * No allowing for ambiguous occupations.
     * We shouldn't have an issue here.
     * 
     * Creating a class for occupation is a very silly idea.
     * Just use the generalized concept classified under EC class.
     * And wire it up in a more flat way from there.
     * 
     * This saves us loads of taxonomy dramas (same with locations and other classes)
     * 
     * FLAT LINEAGES are far superior in ANNE.
     * 
     * SHOULD NEVER HAVE CLASSIFIED ANYTHIGN AS OCCUPATION.  NO NO NO NO NO NO NO.
     * Lateral BE, ok.
     */
    getOrMakeIfNewOccupationClass=async($aec, $occupation)=> {
        if($aec.hasOccupation($occupation)==true) {
            return {status:"good", match:$aec.getOccupation($occupation)};
        }

        var occupation = $occupation.toLowerCase();
        
        var all = MEM.ec_living.ins;
        all = all.concat(MEM.ec_nonliving.ins);
        all = all.concat(MEM.ec_thing.ins);

        for (var i=0; i < all.length; i++) {
            if (all[i].type!=TYPE_BE) continue;
            if (all[i].r!=MEM.ec_is.temp_nid) continue;
            var livingThingClass = MEMG.getNeuronByTempNid( all[i].f);
            if (livingThingClass==null) continue;
            if (livingThingClass.text.toLowerCase()==occupation) {
                $aec.printf("found existing occupation of", _YELLOW, $occupation);
                return {status:"good", match:livingThingClass};
            }
            if (livingThingClass.aka_lower!=null && livingThingClass.aka_lower.length>0) {
                if (groupEventNOBJ.aka_lower.indexOf(nameLower)!=-1) {
                    $aec.printf("found existing occupation (by alias) of", _YELLOW_i, $occupation);
                    return {status:"good", match:livingThingClass};
                }
            }
        }

        //$classNObj, $text, $alt_be_reln, $alt_be_to
        var NOBJS = await CHASE.queryFoNeuronByAltBeTexAndBe(MEM.ec_living, $occupation, MEM.ec_is.nid, MEM.occupation.nid);
        if (NOBJS.length) {
            if (NOBJS.length==1) {
                $aec.printf("found existing occupation of", _YELLOW, $occupation);
                return {status:"good", match:NOBJS[0]};
            }
            $aec.printf("ambiguous occupation for", _GREEN, $occupation);
            return {status:"ambiguous", matches:NOBJS};
        }

        //this will make a first name + last name alias if there is no suffix
        var ghostNOBJ = await GHOSTDATA.makeNewOccupation($occupation);
        $aec.addOccupation(ghostNOBJ);
        $aec.printf("added new occupation", _BLUE, $occupation);
        return {status:"good", match:ghostNOBJ};
    }
    
    
    getOrMakeIfNewLocation=async($name, $po)=> {
    }

    getOrMakeIfNewEventWithYear=async($name, $year)=> {
    }

    getOrMakeIfNewEventWithStartDate=async($name, $startDate)=> {
    }

    getOrMakeIfNewEventWithEndDate=async($name, $endDate)=> {
    }

    //we need to pass an array of roles here.
    //then on the annode we process the roles into an array,
    //extract them..
    //then search for them in the order the come.
    //first role should be the most refining to give us the fewest hits.
    getOrMakeIfNewClumpWithRoles=async($roles)=>{
    }
    

    //alias function.
    getOrMakeNid = function($nid, $name="", $ntype=NTYPE_UNKNOWN, $fireWeight=.03) {
        return this.getOrMakeIfNew($nid, $name, $ntype, $fireWeight);
    }

    /**
     * Get a neuron by nid or make it if it doesn't exist.
     *
     * @author {Mr.Scatman} 
     * 
     */
    getOrMakeIfNew = function ($nid, $name="", $ntype=NTYPE_UNKNOWN, $fireWeight=.03) {
        if ($nid==null || $nid=="") return null;
        if (parseInt($nid) < 100000000) {
            console.warn("HIGHLY UNLIKELY THIS IS A NID");
        }
        var nObj = MEMG.getNeuronByNid($nid, $fireWeight);
        if (nObj==null) nObj = new anne_neuron($name, $ntype, $nid);
        return nObj;
    }


    getFutureTriggers=function($outs) {
        var rels = [];
        var h = ANNE.HISTORY.getGLKB();
        for (var r=0; r < $outs.length; r++) {
            if ($outs[r].type==TYPE_BRAIN120 && parseInt($outs[r].sys_ref_txid)>h) {
                rels.push($outs[r]);
            }
        }
        return rels;
    }

    getRelonsByType=function($outs, $type) {
        var rels = [];
        for (var r=0; r < $outs.length; r++) {
            if ($outs[r].type==$type) rels.push($outs[r]);
        }
        //ANNE.TALK.printRelons($outs);
        return rels;
    }

    getPatternRels = function($outs){
        var rels = [];
        for(var r=0; r < $outs.length; r++) {
            if ($outs[r].r!=MEM.ec_pattern.temp_nid) continue;
            rels.push($outs[r])
        }
        rels.sort(ANNE.UTILS.sortByDimension);
        return rels;
    }


    /** 
     * Wrapper to to geta quick parameter value.
     * 
     * @author {Mr.Scatman} 
     */
    getParamVal = function($outs) {
        var rel = MEMG.getParamNameRelon($outs);
        if (rel!=null) return rel.to_s;
        return "";
    }

    /** 
     * Wrapper to to geta quick parameter relon.
     * This was moved to the SYS dimension (no longer in the TYPE_HAS)
     * 
     * @author {Mr.Scatman} 
     */
    getParamNameRelon = function($outs) {
        return MEMG.getRelonFromWithRToType($outs, TYPE_SYS, MEM.PARAM_NAME.temp_nid, TO_TYPE_STRING);
    }

    /**
     * 
     * @param {*} $outs 
     * @param {*} $relnTnid 
     * @returns 
     */
    getParamRelon = function($outs, $relnTnid) {
        for (var r=0; r < $outs.length; r++) {
            if ($outs[r].r==$relnTnid && $outs[r].type==TYPE_PARAM) return $outs[r];
        }
        return null;
    }

    /**
     * 
     * @param {*} $outs 
     * @param {*} $relnTnid 
     * @returns 
     */
    getParamRelons = function($outs, $relnTnid) {
        var rels = [];
        for (var r=0; r < $outs.length; r++) {
            if ($outs[r].r==$relnTnid && $outs[r].type==TYPE_PARAM) rels.push($outs[r]);
        }
        return rels;
    }

    getAllParamRelons = function($outs) {
        var rels = [];
        for (var r=0; r < $outs.length; r++) {
            if ($outs[r].type==TYPE_PARAM) rels.push($outs[r]);
        }
        return rels;
    }


    /**
     * A quicker way to get any kinfolk relations..
     * as some of the relns for kinfolk are sub-classes of higher level generalized classes (like parent or child)
     * @param {*} $outs 
     * @returns 
     */
    getKinfolk=function($outs){
        var rels = [];
        for (var r=0; r < $outs.length; r++) {
            if (MEM.kinfolk_tnids.indexOf($outs[r].r)==-1) continue;
            rels.push($outs[r]);
        }
        return rels;
    }


    getHasTo = function($r, $to_s) {
        for (var r=0; r < ANNE.MEM._aRelons.length; r++) {
            if(ANNE.MEM._aRelons[r].r!=$r) continue;
            if (ANNE.MEM._aRelons[r].to_s!=$to_s) continue;
            return ANNE.MEM._aRelons[r];
        }
        return null;
    }
    

    /**
     * 
     * @param {*} $outs 
     * @param {*} $relnTnid 
     * @returns 
     */
    getHasRelon=function($outs, $relnTnid) { return this.getHas($outs, $relnTnid);}

    getEarliestHasRelon=function($outs, $relnTnid) { 
        var relon = null;    
        for (var r=0; r < $outs.length; r++) {
            if ($outs[r].r==$relnTnid && $outs[r].type==TYPE_HAS)  {
                if (relon!=null && $outs[r].time < relon.time) relon = $outs[r];
                relon = $outs[r];
            }
        }
        return relon;
    }


    /**
     * 
     * @param {*} $outs 
     * @param {*} $relnTnid 
     * @returns 
     */
    getHas=function($outs, $relnTnid) {
        for (var r=0; r < $outs.length; r++) {
            if ($outs[r].r==$relnTnid && $outs[r].type==TYPE_HAS) return $outs[r];
        }
        return null;
    }
    getRelon=function($outs, $type, $relnTnid) {
        for (var r=0; r < $outs.length; r++) {
            if ($outs[r].type==$type && $outs[r].r==$relnTnid && $outs[r].type==TYPE_HAS) return $outs[r];
        }
        return null;
    }
    getHasNObj=function($outs, $relnTnid) {
        var rel = this.getRelon($outs, TYPE_HAS, $relnTnid);
        if (rel==null) return null;
        if (rel.to_type!=TO_TYPE_ANNE) return null;
        return ANNE.MEMG.getNeuronByNid(rel.to_s);
    }
    getHasInt=function($outs, $relnTnid) {
        var rel = this.getRelon($outs, TYPE_HAS, $relnTnid);
        if (rel==null) return null;
        if (rel.to_type==TO_TYPE_ANNE) return null;
        return parseInt(rel.to_s);
    }
    

    /**
     * typically the $rels is the .ins of the $to_s, but not always.
     * @param {*} $rels 
     * @param {*} $relnTnid 
     * @param {*} $toS 
     * @returns 
     */
    getHasRelonTo=function($rels, $relnTnid, $toS) {
        for (var r=0; r < $rels.length; r++) {
            if ($rels[r].r==$relnTnid && $rels[r].type==TYPE_HAS && $rels[r].to_s==$toS) return $rels[r];
        }
        return null;
    }

    //typically the $rels is the .ins of the $to_s, but not always.
    getHasRelonsTo=function($rels, $relnTnid, $toS) {
        var rels = [];
        for (var r=0; r < $rels.length; r++) {
            if ($rels[r].r==$relnTnid && $rels[r].type==TYPE_HAS && $rels[r].to_s==$toS) rels.push($rels[r]);
        }
        return rels;
    }

    /**
     * 
     * @param {*} $outs 
     * @param {*} $relnTnid 
     * @returns 
     */
    getHasRelons=function($outs, $relnTnid) { 
        var matches = [];
        for (var r=0; r < $outs.length; r++) {
            if ($outs[r].r==$relnTnid && $outs[r].type==TYPE_HAS) matches.push($outs[r]);
        }
        return matches;
    }

    /**
     * 
     * @param {*} $outs 
     * @param {*} $relnTnid 
     * @returns 
     */
    getSysMsgRelon=function($outs, $relnTnid) { 
        for (var r=0; r < $outs.length; r++) {
            if ($outs[r].r==$relnTnid && $outs[r].type==TYPE_SYS_MSG) return $outs[r];
        }
        return null;
    }

    /**
     * 
     * @param {*} $outs 
     * @param {*} $relnTnid 
     * @returns 
     */
    getSysMsgRelon_HIGHEST=function($outs, $relnTnid) { 
        var highest_height = -1;
        var latest_rel = null;
        for (var r=0; r < $outs.length; r++) {
            if ($outs[r].r==$relnTnid && $outs[r].type==TYPE_SYS_MSG) {
                if ($outs[r].time==0) return $outs[r].time;
                if ($outs[r].time>highest_height) {
                    latest_rel = $outs[r];
                    highest_height = latest_rel.time;
                }
            }
        }
        return latest_rel;
    } 

    /**
     * 
     * @param {*} $outs 
     * @param {*} $relnTnid 
     * @returns 
     */
    getSysMsgRelons=function($outs, $relnTnid) { 
        var matches = [];
        for (var r=0; r < $outs.length; r++) {
            if ($outs[r].r==$relnTnid && $outs[r].type==TYPE_SYS_MSG) matches.push($outs[r]);
        }
        return matches;
    }

    
    /**
     * 
     * @param {*} $rels 
     * @returns 
     */
    getInternalPayments = function($rels) {
        var rels = [];
        for (var r=0; r < $rels.length; r++) {
            if ($rels[r].type==TYPE_INTERNAL_PAY) rels.push($rels[r]);
        }
        return rels;
    }


    /**
     * For streampays with an owner src --
     * The payment comes out of the main identity account but is tagged with a sysreftxid of 
     * relon that froze the fund. (and activated it)
     * @param {*} $rels 
     * @param {*} $sysreftxid 
     * @returns 
     */
    getInternalPaymentsOutWithSYSREFID = function($rels, $sysreftxid) {
        var rels = [];
        for (var r=0; r < $rels.length; r++) {
            if ($rels[r].type==TYPE_INTERNAL_PAY && $rels[r].sys_ref_txid==$sysreftxid) rels.push($rels[r]);
        }
        return rels;
    }
    

    /**
     * typically the $rels is the .ins of the $to_s, but not always.
     * @param {*} $rels 
     * @param {*} $relnTnid 
     * @param {*} $toS 
     * @returns 
     */
    getSysMsgRelonsTo=function($rels, $relnTnid, $toS) {
        var rels = [];
        for (var r=0; r < $rels.length; r++) {
            if ($rels[r].r==$relnTnid && $rels[r].type==TYPE_SYS_MSG && $rels[r].to_s==$toS) rels.push($rels[r]);
        }
        return rels;
    }

    /**
     * 
     * @param {*} $rels 
     * @param {*} $relnTnid 
     * @param {*} $toS 
     * @returns 
     */
    getSysMsgRelonTo=function($rels, $relnTnid, $toS) {
        for (var r=0; r < $rels.length; r++) {
            if ($rels[r].r==$relnTnid && $rels[r].type==TYPE_SYS_MSG && $rels[r].to_s==$toS) return $rels[r];
        }
        return null;
    }

    /**
     * 
     * @param {*} $outs 
     * @param {*} $relnTnid 
     * @returns 
     */
    getAwarenessRelons=function($outs, $relnTnid) { 
        var matches = [];
        for (var r=0; r < $outs.length; r++) {
            if ($outs[r].r==$relnTnid && $outs[r].type==TYPE_AWARENESS) matches.push($outs[r]);
        }
        return matches;
    }

    
    /**
     * Get the to value of a TYPE_HAS relon.
     * @param {array} - outs
     * @param {integer} - int of temp_nid for the reln  (in js it is just a number)
     */
    getHasValue=function($outs, $relnTnid) {
        var rel = MEMG.getRelonFromWithRToType($outs, TYPE_HAS, $relnTnid, TO_TYPE_ANNE);
        if (rel==null) return null;
        var val = this.__MASTER_DISPLAY_RELON_TO(rel);
        if (val=="") val=null;
        return val;
    }

    /**
     * 
     * @param {*} $altBe 
     */
    isAltBe=function($altBe){
        //if (this['be_'+$altBeNid]!=undefined && 
    }

    /**
     * 
     * @param {*} $outs 
     * @param {*} $toTnid 
     * @returns 
     */
    hasAltBe=function($outs, $toTnid) {
        var rels = MEMG.getRelonsFromWithRToType($outs, TYPE_BE, MEM.ec_is.temp_nid, TO_TYPE_ANNE);
        if (rels.length==0) return null;
        for (var r=0; r<rels.length; r++) { if (resl[r].t==$toTnid) return true; }
        return false;
    }


    /**
     * this is just the parent-line be-params.
     * This is going to have to CHASE data too.. (aaarg)  
     * We have no guarantee the user has the parent line relons in memory. 
     * We must query for them first (all the way on the way up). 
     * 
     * @author {Mr.Scatman} 
     */
     getParentLineParams=function($nObj, $relnMatching="", $bDOSELF=true) {
        var nObjs = MEMG.buildParentLine($nObj, $bDOSELF); //just the be line
        ANNE.TALK.printNeurons(nObjs);

        var allParamRelons = [];
        if (nObjs.length==0) return allParamRelons;
        for (var  n=0; n <nObjs.length; n++) {
            var nObj = nObjs[n];
            var aRelons = MEMG.getAllParamsOf(nObj.outs, $relnMatching);
            if (aRelons) {
                MEMG.concatUniqueRelnToPrioritize(allParamRelons, aRelons, $nObj.temp_nid);
            }
        }
        return allParamRelons;
    }


    /** 
     * Heavily used to build relon tables.
     * 
     * Parentline, inherit. (for searching to find this function since I keep forgetting the name)
     * 
     * @author {Mr.Scatman} 
     */
    getParentLineRelons = function($nObj, 
                                    $types=[TYPE_SYS, TYPE_BE, TYPE_PARAM, TYPE_HAS, TYPE_ROLE, TYPE_CLUMP, TYPE_BRAIN], 
                                    $ignoreRelnTnids=[],
                                    $bGETALLSELF=false,
                                    $bEXTRAPRETURN=false,
                                    $bFORINHERITANCE=false,
                                    $ignoreToTnids=[]) {
        
        if ($nObj==null) {
            console.log("nObj shouldn't be null here");
            return [];
        }
        
        var nObjs = MEMG.buildParentLine($nObj, true, false, null, $ignoreToTnids); 

        if ($bGETALLSELF==true) nObjs.unshift($nObj);
        
        var all = new Object();
        all.sys = [];
        all.bes = [];
        all.params = [];
        all.has = [];
        all.clumps = [];
        all.roles = [];
        all.brain = [];
        all.sys_msg = [];

        all.recurse = [];

        if (nObjs.length==0) return all;    //an array of arrays indexed by TYPE

        var bDOINGSYS = false;
        var bDOINGBE  = false;
        var bDOINGPARAM = false;
        var bDOINGHAS = false;
        var bDOINGCLUMPS = false;
        var bDOINGROLES = false;
        var bDOINGBRAIN = false;
        var bDOINGSYSMSG = false;

        if ($types.indexOf(TYPE_SYS)!=-1) bDOINGSYS=true;
        if ($types.indexOf(TYPE_BE)!=-1) bDOINGBE=true;
        if ($types.indexOf(TYPE_PARAM)!=-1) bDOINGPARAM=true;
        if ($types.indexOf(TYPE_HAS)!=-1) bDOINGHAS=true;
        if ($types.indexOf(TYPE_CLUMP)!=-1) bDOINGCLUMPS=true;
        if ($types.indexOf(TYPE_ROLE)!=-1) bDOINGROLES=true;
        if ($types.indexOf(TYPE_BRAIN)!=-1) bDOINGBRAIN=true;
        if ($types.indexOf(TYPE_SYS_MSG)!=-1) bDOINGSYSMSG=true;
        
        //we must get final garden first -- we inherit its params...
        //the ONLY time we inherit from a non-TYPE_BE relon's line.
        for (var  n=0; n <nObjs.length; n++) {
            var nObj = nObjs[n];
            if (bDOINGSYS==true) {
                MEMG.gplr_final_sys(all.sys, nObj, $ignoreRelnTnids, $nObj);
            }
        }

        var gt = $nObj._gt;

        //we need to snag the PARAMS of this known garden type.
        //we also need to snag any SYS relons that apply to those params  (like multiples ok)
        //they apply to the neuron and help users best manage their garden (by type)
        if (gt!=null) {
            var finalGardenNOBJ = MEMG.getNeuronByTempNid( gt.t );
            if (finalGardenNOBJ!=null) {
                var gardenParams = [];
                gardenParams = MEMG.getAllParamsOf(finalGardenNOBJ.outs);
                MEMG.concatUniqueRelnToPrioritize(all.params, gardenParams, gt.f);
                var gardenSys = MEMG.getAllSysOf(finalGardenNOBJ.outs);
                var finalGardenSys = [];

                //this sys rel references a param rel.
                for (var gs=0; gs < gardenSys.length; gs++) {
                    var gsrel=gardenSys[gs];
                    if (gsrel.to_type!=TO_TYPE_TXID) continue;
                    if (ANNE.UTILS.findValInObjnArr(gardenParams, "txid", gsrel.to_s)!=null) {
                        finalGardenSys.push(gsrel);
                    }
                }
                MEMG.concatUniqueRelnToPrioritize(all.sys, finalGardenSys, finalGardenNOBJ.temp_nid);
            }
        }

        //sys msg is only on self (not inherited any up) and it is RARE we want to 
        //even see them.
        if (bDOINGSYSMSG==true) {
            var aRelons8 = MEMG.getAllSysMsgOf($nObj.outs, $ignoreRelnTnids);
            if (aRelons8.length) MEMG.concatUniqueRelnToPrioritize(all.sys_msg, aRelons8, $nObj.temp_nid);
        }

        //snag then process the rest off the relons (all the non-SYS relons)
        //remember, our nObjs here are parent line neurons... so we have to get all
        //inherited info from them and tabulate it according to ANNE DATA PROTOCOL RULES.
        for (var  n=0; n <nObjs.length; n++) {
            var nObj = nObjs[n];
            //console.log("chasing upline "+nObj.text+" nid:"+nObj.nid);


            //we will have to further re-filter the bes after we get them all.
            if (bDOINGBE==true) {
                var aRelons2 = MEMG.getAllBesOf(nObj.outs, $ignoreRelnTnids);
                if (aRelons2.length) MEMG.concatUniqueRelnToPrioritize(all.bes, aRelons2, $nObj.temp_nid);
            }

            //we will have to further re-filter the bes after we get them all.
            if (bDOINGPARAM==true) {   
                var aRelons3 = MEMG.getAllParamsOf(nObj.outs, "", $ignoreRelnTnids);

                if (ANNE.MEM.ec_thing.nid == nObj.nid) {
                    //console.log(nObj.text);
                    //ANNE.TALK.printRelon(aRelons3);
                }
                
                if (aRelons3.length) MEMG.concatUniqueRelnToPrioritize(all.params, aRelons3, $nObj.temp_nid);
            }

            if (bDOINGHAS==true) {
                //we should skip this entirely if the nObj is 
                //not a type_be -> polity -> (here) or type_be -> MEM.BE -> (here)
                //or a special defined BE_CHILDREN
                //FOR NOW, skip it if not the main neuron.
                if (nObj.temp_nid==$nObj.temp_nid) {
                    if ($bFORINHERITANCE==true) MEMG.gplr_final_has(all.has, nObj, $ignoreRelnTnids, $nObj);
                    else  MEMG.gplr_final_has_FOR_CONTEXT(all.has, nObj, $ignoreRelnTnids, $nObj);
                }
            }

            if (bDOINGCLUMPS==true) {
                var aRelons5 = MEMG.getAllClumpsOf(nObj.outs, $ignoreRelnTnids);
                if (aRelons5.length) MEMG.concatUniqueRelnToPrioritize(all.clumps, aRelons5, $nObj.temp_nid);
            }

            //we do not inherit roles (makes no sense)
            //we DO inherit clumps.. HOWEVER, a CLUMP dimension (type) should be abandoned and 
            //HAS/BE/PARAM relns point to the clump with the desired reln.
            //this will help with easier handling since we have HAS/BE/PARAM shorthand.
            if (bDOINGROLES==true) {
                var aRelons6 = MEMG.getAllRolesOf(nObj.outs, $ignoreRelnTnids);
                if (aRelons6.length) MEMG.concatUniqueRelnToPrioritize(all.roles, aRelons6, $nObj.temp_nid, false);
            }

            if (bDOINGBRAIN==true) {
                var aRelons7 = MEMG.getAllBrainsOf(nObj.outs, $ignoreRelnTnids);
                if (aRelons7.length) MEMG.concatUniqueRelnToPrioritize(all.brain, aRelons7, $nObj.temp_nid);
            }
        }   

        //final pass filter to apply ANNE protocol tree/inheritance.
        if (bDOINGBE==true) {
            if ($bFORINHERITANCE==true) MEMG.gplr_final_bes(all, $nObj);
            //else do nothing if doing context (keep all bes)
        }
        if (bDOINGPARAM==true) MEMG.gplr_final_params(all, $nObj);


        //turn this off for now.
        if (all.recurse.length>0 && 2==1) {
            var recurse = all.recurse.concat();
            all.recurse = [];
            for (var r=0; r < recurse.length; r++) {
                var rtnidskips = MEM.delegation_reln_tnids.concat();
                rtnidskips.push(MEM.name.temp_nid);

                rtnidskips.push(MEM.constituent_of.temp_nid);
                rtnidskips.push(MEM.eval.temp_nid);
                rtnidskips.push(MEM.BE_CHILDREN.temp_nid);
                rtnidskips.push(MEM.BE_PARENT.temp_nid);
                rtnidskips.push(MEM.aka.temp_nid);
                rtnidskips.push(MEM.fka.temp_nid);

                //we want to recurse on this TYPE_BE ec_is alt class but we don't want to 
                //chase ANNE SYS CLASSES, GENERAL PROPS or SYSBRAIN heirarchies.
                //We want anything below those lvls, as they apply to alt be connections.
                var all2 = this.getParentLineRelons(recurse[r],[TYPE_PARAM], 
                    rtnidskips,
                    false,
                    false,
                    false,
                    [MEM.__ANNE_SYS_CLASS.temp_nid, MEM._GENERAL_PROP_CLASS.temp_nid, MEM.__SYSBRAIN.temp_nid]);

                //if (bDOINGSYS==true && all2.sys.length) MEMG.concatUniqueRelnToPrioritize(all.sys, all2.sys, $nObj.temp_nid, true);
                //if (bDOINGBE==true && all2.bes.length) MEMG.concatUniqueRelnToPrioritize(all.bes, all2.bes, $nObj.temp_nid, true);
                if (bDOINGPARAM==true && all2.params.length) MEMG.concatUniqueRelnToPrioritize(all.params, all2.params, $nObj.temp_nid, true);
                //if (bDOINGHAS==true && all2.has.length) final = MEMG.concatUniqueRelnToPrioritize(all.has, all2.has, $nObj.temp_nid, true);
                //if (bDOINGCLUMPS==true && all2.clumps.length) MEMG.concatUniqueRelnToPrioritize(all.clumps, all2.clumps, $nObj.temp_nid, true);
                //if (bDOINGROLES==true && all2.roles.length) MEMG.concatUniqueRelnToPrioritize(all.roles, all2.roles, $nObj.temp_nid, true);
                //if (bDOINGBRAIN==true && all2.brain.length) MEMG.concatUniqueRelnToPrioritize(all.brain, all2.brain, $nObj.temp_nid, true);
            }    
        }

        if ($bEXTRAPRETURN==true) {
            var final = [];
            if (bDOINGSYS==true) final = all.sys;
            if (bDOINGBE==true && all.bes.length) final = final.concat(all.bes);
            if (bDOINGPARAM==true && all.params.length) final = final.concat(all.params);
            if (bDOINGHAS==true && all.has.length) final = final.concat(all.has);
            if (bDOINGCLUMPS==true && all.clumps.length) final = final.concat(all.clumps);
            if (bDOINGROLES==true && all.roles.length) final = final.concat(all.roles);
            if (bDOINGBRAIN==true && all.brain.length) final = final.concat(all.brain);
            if (bDOINGSYSMSG==true && all.sys_msg.length) final = final.concat(all.sys_msg);
            return final;
        }

        
        return all;
    }

    getPrimaryParentRel = function($nObj) {
        for (var r=0; r < $nObj.outs.length; r++) {
            if ($nObj.outs[r].type!=TYPE_BE) continue;
            if ($nObj.outs[r].r!=MEM.class.temp_nid && $nObj.outs[r].r!=MEM.inst.temp_nid) continue;
            return $nObj.outs[r];
        }
        return null;
    }

    
    /**
     */
    getUserRevealsFor = async($pdnNOBJ)=>{
        var reveals = [];
        var lookups = [];
        var urels =[];

        //get reveals, look at the sys ref txid FROM to ascertain what PDN this was for.
        for(var u=0; u < USER._userNObj.outs.length; u++) {
            var urel=USER._userNObj.outs[u];
            if (urel.type!=TYPE_SYS_MSG) continue;
            if (urel.sys_ref_txid==undefined) continue;
            if (urel.r!=MEM.PDN_ANSWER.temp_nid) continue;
            var refRel = MEMG.lookupByTXID(urel.sys_ref_txid);
            
            if (refRel==null) {
                if (lookups.indexOf(urel.sys_ref_txid)==-1) {
                    lookups.push(urel.sys_ref_txid); 
                    urels.push(urel);
                }
                continue;
            }
            if (refRel.f!=$pdnNOBJ.temp_nid) continue;
            urel.sys_ref_relon = refRel;
            reveals.push(urel);
        }

        if (lookups.length) await CHASE.lookupTxids(lookups);
        for (var u=0; urels<urels.length; u++) {
            var urel=USER._userNObj.outs[u];
            var refRel = MEMG.lookupByTXID(urel.sys_ref_txid);
            if (refRel==null) continue;
            if (refRel.f!=$pdnNOBJ.temp_nid) continue;
            urel.sys_ref_relon = refRel;
            reveals.push(urel);
        }

        if (reveals.length) {
            return await USER.decryptPDNAnswerRelons(reveals);
        }
        return reveals;
    }


    /**
     * @author {Mr.Scatman} 
     */
    getVoteData=function($nid) {
        var nObj = MEMG.getNeuronByNid($nid);
        var votes = [];
        for (var r=0; r < MEM._aRelons.length; r++) {
            if (MEM._aRelons[r].r==nObj.temp_nid) { //&& MEM.valid_vote.indexOf(MEM._aRelons[r].t)!=-1
                var vNobj = MEMG.getNeuronByTempNid(MEM._aRelons[r].f);
                votes.push(vNobj);
            }
        }
        return votes;
    }


    /**
     * Critical final prep to params array of a neuron applying ANNE protocol rules.
     * @author {Mr.Scatman} 
     */
    gplr_final_params = function($allObj, $nObj) {

        //is temp_nid the parent of ANY of the tempNids?
        function matchAnyParent($temp_nid, $tempNids) {
            var tempNOBJ = MEMG.getNeuronByTempNid($temp_nid);
            
            //we want this relon to make it through!
            for (var t=0; t < $tempNids.length; t++) {
                var testNOBJ = MEMG.getNeuronByTempNid($tempNids[t]);
                if (testNOBJ==null) continue;
                if (testNOBJ.be_lvl==-1) continue;  //no parent info on this
                //our temp is a high lvl # (lower on the tree) than this tempNid  (whatever it is)..
                //so it cannot be an ancestor parent. 
                if (tempNOBJ.be_lvl>= testNOBJ.be_lvl) continue; 
                var bes = testNOBJ.bes;
                if (bes==null) continue;
                var bRETURNTRUE=false;
                while (bes) {
                    var be = bes[0];
                    if ($temp_nid==be) {
                        bRETURNTRUE=true;
                        break;
                    }
                    testNOBJ = MEMG.getNeuronByTempNid(be);
                    if (testNOBJ==null) break;
                    if (testNOBJ.be_lvl==0 || testNOBJ.be_lvl==-1) break;
                    bes = testNOBJ.bes;
                }
                if(bRETURNTRUE==true) return true;
            }
            return false;
        }

        var params = $allObj.params;
        var final_params = [];
        var param_tnids = [];
        for (var p=0; p < params.length; p++) {
            if (param_tnids.indexOf(params[p].r)==-1) param_tnids.push(params[p].r);
        }

        //is this param reln NOBJ a hierarchical parent of any of the others?
        //if so, skip it.  We will keep the lowest (most refined) specification.
        //example:  MEME vs neuron img vs flag.  (keep flag)
        for (var p=0; p < params.length; p++) {
            var paramRelon = params[p];
            //ANNE.TALK.printRelon(paramRelon);

            //this is a PARAM that depends on a TYPE_HAS being
            //created from ANOTHER PARAM.  THAT TYPE_HAS will specify
            //the actual TO of this PARAM.
            if (paramRelon.to_type==TO_TYPE_TXID) {
                var cdxRelon = MEMG.lookupByTXID(paramRelon.to_s);
                if (cdxRelon==null) continue;
                
                //cdx relons are like variables.. they point to a value
                //we are attempting to get from another relon.
                if (cdxRelon.type!=TYPE_SYS) continue;

                var cdx_to_s = cdxRelon.to_s;
            
                //get the PARAM which points to this same to_s;
                var otherRelon = MEMG.getRelonFromWith(params, TYPE_PARAM, cdx_to_s);
                if (otherRelon==null) continue;

                paramRelon.depends_on = otherRelon.txid;
                if (otherRelon.affects==undefined) otherRelon.affects=[paramRelon.txid];
                else if (otherRelon.affects.indexOf(paramRelon.txid)==-1) otherRelon.affects.push(paramRelon.txid);
            }

            if (paramRelon.r!=paramRelon.t && matchAnyParent(paramRelon.r, param_tnids)==true) continue;
            
            final_params.push(paramRelon);
        }

        $allObj.params = final_params; //alter the params array to be the final_params array.
    }


    /**
     * Critical final prep to BE array of a neuron applying ANNE protocol rules.
     * @author {Mr.Scatman} 
     */
    gplr_final_bes = function($allObj, $nObj) {
        var bes = $allObj.bes;
        var final_bes = [];
        var skips = [];
        var temp_bes = [];
        for (var b=0; b < bes.length; b++) {
            var beRelon = bes[b];

            //on a BE ec_is, we want to inherit EVERYTHING.
            //this is a true alt heirarchy.
            if (beRelon.r==MEM.ec_is.temp_nid) {
                var beNOBJ = MEMG.getNeuronByTempNid(beRelon.t);
                $allObj.recurse.push(beNOBJ);
            }
            
            //if this is an inherited be.. we have some skips.
            if (beRelon.f!=$nObj.temp_nid) {

                continue;   //for now, skip all bes if not from target nobj
                if (beRelon.r==MEM.constituent_of.temp_nid) continue;   //NEVER INHERIT THIS.
                if (beRelon.r==MEM.class.temp_nid) continue;            //NEVER INHERIT THIS.
                if (beRelon.r==MEM.name.temp_nid) continue;             //NEVER INHERIT THIS.
                if (beRelon.r==MEM.eval.temp_nid) continue;             //NEVER INHERIT THIS.
                if (beRelon.r==MEM.BE_CHILDREN.temp_nid) {
                    skips.push(beRelon.t);
                    continue;
                }
                if (beRelon.r==MEM.BE_PARENT.temp_nid) continue;
                if (beRelon.r==MEM.aka.temp_nid) continue;
                if (beRelon.r==MEM.fka.temp_nid) continue;
                if (beRelon.r==MEM.ec_is.temp_nid) continue;
            }
            temp_bes.push(beRelon);
        }

        //we don't want the BE_CHILDREN relon of a alt parent..
        //ie, the be->polity->country is only relevant to the neuron it is
        //on.  It is NOT inherited by locations with an alt be parent of a country.
        //They will get their own polity assigned (or have none).
        for (var b=0; b<temp_bes.length;b++) {
            var beRelon = temp_bes[b];
            if (beRelon.f!=$nObj.temp_nid) {
                if (skips.indexOf(beRelon.r)!==-1) continue;
            }
            final_bes.push(beRelon);
        }
        $allObj.bes = final_bes;    //alter the bes array to be the final_bes array.
    }


    /**
     * Critical final prep to HAS array of a neuron applying ANNE protocol rules.
     * @author {Mr.Scatman} 
     */
    gplr_final_has=function($arr, $nObj, $ignoreRelnTnids, $mainNObj) {
        var aRelons = MEMG.getAllHasOf($nObj.outs, $ignoreRelnTnids);
        for (var r=0; r < aRelons.length; r++) {
            var newRel = aRelons[r];
            if (newRel.f != $mainNObj.temp_nid) {                             //if not the priority neuron (ie, an inherited relon)
                //no has from alt bes unless reln of type_be was BE or BE_CHILDREN/BE_PARENT
                //continue;   
                
                if (newRel.r==MEM.SMART_SEARCH_ONLY.temp_nid) continue; //do not inherit smart search
                if (newRel.r==MEM.primaryNeuronImg.temp_nid) continue;  //do not inherit neuron img
                if (newRel.r==MEM.neuronImg.temp_nid) continue;  //do not inherit neuron img
                
            }
            if ($arr.length) {
                var bDUPE=false;
                for (var x=0; x < $arr.length; x++) {
                    var existingRel = $arr[x];
                    //we have an inherited dupe.. take the priority one!
                    if (existingRel.r==newRel.r && existingRel.to_s == newRel.to_s) {
                        if (existingRel.f==$mainNObj.temp_nid) {
                            bDUPE = true;
                            break;
                        }
                        else { //swap out the existing with this one!
                            $arr[x]=newRel;
                            bDUPE = true;
                            break;
                        }
                    }
                }
                if (bDUPE==false) $arr.push(newRel);
                else continue;
            }
            else $arr.push(newRel);
        }
    }


    gplr_final_has_FOR_CONTEXT=function($arr, $nObj, $ignoreRelnTnids, $mainNObj) {
        var aRelons = MEMG.getAllHasOf($nObj.outs, $ignoreRelnTnids);
        for (var r=0; r < aRelons.length; r++) {
            var newRel = aRelons[r];
            if ($arr.length) $arr.push(newRel);
            else $arr.push(newRel);
        }
    }



    /**
     * Critical final prep to SYS array of a neuron applying ANNE protocol rules.
     * 
     * NOTE: most SYS relons do NOT get inherited by children insts and classes.
     * SYS is not a semantic dimension to define conceptual information  --- it is
     * intended to govern the use of the neuron in ANNE.
     * 
     * As such, most SYS will not be inherited.
     * 
     * Those that ARE inherited:
     *      GARDEN TYPE (with caveats to override inheritance)
     *      DATA DELEGATION RIGHTS  (some varieties)
     *      wv_let, wv_dney
     *      SYS->_dimension
     * 
     * @author {Mr.Scatman} 
     */
    gplr_final_sys=function($arr, $fromNOBJ, $ignoreRelnTnids, $mainNObj) {
        var aRelons = MEMG.getAllSysOf($fromNOBJ.outs, $ignoreRelnTnids);
        //ANNE.TALK.printRelons(aRelons);
        //console.log("%c -------------------------------------------------------------------", TALK.bgyellow);
        for (var r=0; r < aRelons.length; r++) {
            var newRel = aRelons[r];

            //main object takes precedence
            if (newRel.f==$mainNObj.temp_nid) {            

                //this must be the gt.
                //NOTE: _gt is only inherited from clases and relevant to itself & its sub-classes.
                //remove any other inherited gt relons.
                if ($mainNObj.ntype==NTYPE_CLASS && newRel.r == MEM.garden_type.temp_nid) {
                    $arr = ANNE.UTILS.removeFromRelonsArray($arr, MEM.garden_type.temp_nid); 
                    if ($mainNObj._gti && $mainNObj._gt.txid!=newRel.txid) {
                        console.log($mainNObj.text+" garden type relon "+newRel.txid);
                        ANNE.TALK.printRelon($mainNObj._gt);
                        ANNE.TALK.printRelon(newRel._gt);
                        
                        alert("gt audit problem, this should have already been set MEMP");
                    }
                    $mainNObj.setGtRelon(newRel);
                }
                
                //inhert inst_garden_type all the way down the BE branch.
                else if (newRel.r == MEM.inst_garden_type.temp_nid) {
                    $arr = ANNE.UTILS.removeFromRelonsArray($arr, MEM.inst_garden_type.temp_nid); 
                    if ($mainNObj._gti && $mainNObj._gti.txid!=newRel.txid) {
                        console.log($mainNObj.text+" garden type relon "+newRel.txid);
                        ANNE.TALK.printRelon($mainNObj._gti);
                        ANNE.TALK.printRelon(newRel._gti);
                        alert("gti audit problem, this should have already been set in the MEMP");
                    }
                    $mainNObj.setGtiRelon(newRel);
                }
            }

            else {                    
                //gt inheritance 
                //last (lowest on tree, highest be_lvl) NON-ALT-BE value.
                if (newRel.r == MEM.garden_type.temp_nid) {
                    if ($mainNObj._gt==null) {
                        if (ANNE.SETTINGS.debug()==true) console.warn("why wasn't this already set?");
                        $mainNObj.setGtRelon(newRel);
                    }

                    //we have a gt already.  Is this more accurate?
                    else {
                        if ($mainNObj._gt.txid==newRel.txid) continue;  //already have it.
                        if ($mainNObj.getGtLvl() > $fromNOBJ.getGtLvl()) {
                            //console.log("new gt is higher up the tree (lower in lvl), not as accurate");
                            $arr = ANNE.UTILS.removeRelonByTxid($arr, newRel); //remove it from our $arr if it is in there
                            continue;   
                        }

                        //update gt.
                        else {
                            $mainNObj.setGtRelon(newRel);
                        }
                    } 
                }

                else if (newRel.r == MEM.inst_garden_type.temp_nid) {
                    if ($mainNObj._gti==null) {
                        if (ANNE.SETTINGS.debug()==true) console.warn("why wasn't this already set?");
                        $mainNObj.setGtiRelon(newRel);
                    }

                    //we have a gti already.  Is this more accurate?
                    else {
                        if ($mainNObj._gti.txid==newRel.txid) continue;  //already have it.
                        if ($mainNObj.getGtiLvl() > $fromNOBJ.getGtiLvl()) {
                            //console.log("new gti is higher up the tree (lower in lvl), not as accurate");
                            $arr = ANNE.UTILS.removeRelonByTxid($arr, newRel);   //remove it from our $arr if it is in there
                            continue;   
                        }

                        //update gti.
                        else {
                            $mainNObj.setGtiRelon(newRel);
                        }
                    } 
                }

                else if (MEM.delegation_reln_tnids.indexOf(newRel.r)!=-1) { 
                }

                //applies to an inherited param so we can inherit this too.
                else if (newRel.r==MEM._multiples_ok.temp_nid) {
                }

                //roles should be in the role dimension... not in the SYS
                //fix this.
                else if (MEM.role.children.indexOf(newRel.r)!=-1) {
                    ANNE.TALK.printRelon(newRel);
                    console.log(newRel);
                    console.log("%c debug", TALK.bgbigred);
                    alert("R_ROLE in SYS dimension");
                } 
                else continue;

                if (newRel.r==MEM.insts_only.temp_nid && newRel.to_type==TO_TYPE_TXID) {
                    var paramRel = MEMG.lookupRelonByTXID(newRel.to_s);
                    if (paramRel!=null) paramRel.insts_only=true;
                }
            }

            if ($arr.length) {
                var bDUPE=false;
                for (var x=0; x < $arr.length; x++) {
                    var existingRel = $arr[x];
                    //we have an inherited dupe.. take the priority one!
                    if (existingRel.r==newRel.r && existingRel.to_s == newRel.to_s) {
                        if (existingRel.f==$mainNObj.temp_nid) {
                            bDUPE = true;
                            break;
                        }
                        else { //swap out the existing with this one!
                            $arr[x]=newRel;
                            bDUPE = true;
                            break;
                        }
                    }
                }
                if (bDUPE==false) $arr.push(newRel);
                else continue;
            }
            else $arr.push(newRel);
        }

        return;
    }


    /**
     * Get the the neuron of a given eval (.value) and class.
     * 
     * Return the best string or shortest (if bSHORTIF is on)
     * 
     * @param {anne_neuron} - the parent
     * @param {int} - the eval we want to find for a matching child
     * @author {Mr.Scatman} 
     * 
     */
    getNeuronNameByClassAndValue=function($classNOBJ, $eval, $bSHORTIF=true) {
        var nObj = MEMG.getNeuronByClassAndValue($classNOBJ, $eval);
        if ((nObj instanceof anne_neuron) == true) {
            if ($bSHORTIF==true) return nObj.bestNameHTML();
            else return nObj.shortName();
        }
        else return $eval;
    }
    
    getNeuronByClassAndValue=function($classNOBJ, $eval) {
        var ins = $classNOBJ.ins;
        if (ins.length==0) return $eval;
        for (var i=0; i < ins.length; i++) {
            var fromNOBJ = MEMG.getNeuronByTempNid(ins[i].f);
            if (fromNOBJ==null) continue;
            if (fromNOBJ.value==null || fromNOBJ.value=="") {
                var val = fromNOBJ.bestValue(fromNOBJ);
                if (val=="") continue;
                if (fromNOBJ.value==$eval) return fromNOBJ;
                else continue;
            }
            else if(fromNOBJ.value==$eval) return fromNOBJ;
        }
        return $eval;
    }


    /**
     */
    getBrainRels = function($outs) {
        var rels = [];
        for (var r=0; r < $outs.length; r++) {
            var rel = $outs[r];
            if (rel.type==TYPE_BRAIN) rels.push(rel);
            else if (rel.type >=20 && rel.type<120) rels.push(rel);
        }
        return rels;
    }

    /**
     */
    getPats = function($nObj, $bGETPARENTPATS=true) {
        var patNOBJs = [];
        var pats = MEMG.getRelonsFromWith_fast($nObj.outs, TYPE_BRAIN, MEM.ec_pattern.temp_nid, TO_TYPE_ANNE);
        if (pats==null) return [];

        for (var p=0; p < pats.length; p++) {
            var patNOBJ = MEMG.getNeuronByTempNid(pats[p].t);
            patNOBJs.push(patNOBJ);
        }

        //We aren't chasing up here
        //this is intended for one gen down or same-gen pats.
        if ($bGETPARENTPATS==true) {
            if ($nObj.bes.length==0) return patNOBJs;
            var parentNOBJ=MEMG.getNeuronByTempNid($nObj.bes[0]);
            pats = MEMG.getRelonsFromWith_fast(parentNOBJ.outs, TYPE_BRAIN, MEM.ec_pattern.temp_nid, TO_TYPE_ANNE);
            if (pats==null) return patNOBJs
            for (var p=0; p < pats.length; p++) {
                var patNOBJ = MEMG.getNeuronByTempNid(pats[p].t);
                patNOBJs.push(patNOBJ);
            }
        }
        return patNOBJs;
    }

    /**
     */
    getTextListFromNObjs= function($nObjs, $sep=" :: ") {
        var list = [];
        for (var n=0; n < $nObjs.length; n++) list.push ($nObjs[n].text);
        return list;
    }

    /**
     */
    getTextListFromTnids= function($tnids, $sep=" :: ") {
        var list = [];
        for (var t=0; t < $tnids.length; t++) {
            var nObj = MEMG.getNeuronByTempNid($tnids[t]);
            if (nObj.text!="") list.push (nObj.text);
            else list.push(nObj.nid);
        }
        return list;
    }

    /**
     */
    getTextListStrFromTnids= function($tnids, $sep=" :: ") {
        return MEMG.getTextListFromTnids($tnids, $sep).join($sep);
    }

    /**
     */
    getTextListStrFromNObjs= function($nObjs, $sep=" :: ") {
        return MEMG.getTextListFromNObjs($nObjs, $sep).join($sep);
    }

    hasRoleRelon=function($outs, $reln_nid, $role_value) {
        for (var r=0; r <$outs.length; r++) {
            if ($outs[r].reln==$reln_nid) {
                if ($outs[r].to_s==$role_value) return true;
            }
        }
        return false;
    }

    /**
     */
    getRoleRelon=function($outs, $temp_reln_nid) {
        for (var r=0; r <$outs.length; r++) {
            if ($outs[r].r==$temp_reln_nid) {
                if ($outs[r].type==TYPE_ROLE) return $outs[r];
            }
        }
        return null;
    }
    getRoleRelons=function($outs, $temp_reln_nid) {
        var rels = [];
        for (var r=0; r <$outs.length; r++) {
            if ($outs[r].r==$temp_reln_nid) {
                if ($outs[r].type==TYPE_ROLE) rels.push($outs[r]);
            }
        }
        return rels;
    }


    /**
     * This function probably exists in 10 other places.
     * @param {*} $outs 
     * @param {*} $temp_reln_nid 
     * @param {*} $type 
     * @returns 
     */
    getRelonByTypeAndR=function($outs, $temp_reln_nid, $type) {
        for (var r=0; r <$outs.length; r++) {
            if ($outs[r].r==$temp_reln_nid) {
                if ($outs[r].type!=$type) continue;
                return $outs[r];
            }
        }
        return null;
    }


    /**
     * Look for an in with a specific reln (unknown from)
     * @param {*} $ins 
     * @param {*} $temp_reln_nid 
     * @param {*} $excludeTypes 
     * @returns 
     */
    getRelonInByTempR=function($ins, $temp_reln_nid, $excludeTypes=[]) {
        for (var r=0; r <$ins.length; r++) {
            if ($ins[r].r==$temp_reln_nid) {
                if ($excludeTypes.length && $excludeTypes.indexOf($outs[r].type)!=-1) continue;
                return $outs[r];
            }
        }
        return null;
    }


    /**
     * Snag a quick relon by its reln.
     * 
     * @param {array} - the array of outs to limit the search to
     * @param {string} - the temp_nid of the reln
     * @author {Mr.Scatman} 
     * 
     */
     getRelonByTempR=function($outs, $temp_reln_nid, $excludeTypes=[]) {
        for (var r=0; r <$outs.length; r++) {
            if ($outs[r].r==$temp_reln_nid) {
                if ($excludeTypes.length && $excludeTypes.indexOf($outs[r].type)!=-1) continue;
                return $outs[r];
            }
        }
        return null;
    }
    getRelonByTempRTo=function($outs, $temp_reln_nid, $to_s, $excludeTypes=[]) {
        for (var r=0; r <$outs.length; r++) {
            if ($outs[r].r==$temp_reln_nid) {
                if ($outs[r].to_s!=$to_s) continue;
                if ($excludeTypes.length && $excludeTypes.indexOf($outs[r].type)!=-1) continue;
                return $outs[r];
            }
        }
        return null;
    }


    getRelonsByTempR=function($outs, $temp_reln_nid, $excludeTypes=[]) {
        if ($outs==undefined || $outs==null) return [];
        var rels=[];
        for (var r=0; r <$outs.length; r++) {
            if ($outs[r].r==$temp_reln_nid) {
                if ($excludeTypes.length && $excludeTypes.indexOf($outs[r].type)!=-1) continue;
                rels.push($outs[r]);
            }
        }
        return rels;
    }

    //find an out of a given type that has a relon that falls within a lineage.
    //we can look "up" the tree line to see if we hit hte parentLineTempNid.
    getRelonByTempRBeLine=function($outs, $types, $parentLineTempNid, $skipTnids=[]) {
        for (var r=0; r < $outs.length; r++) {  
            var relon = $outs[r];
            if ($types.indexOf(relon.type)==-1) continue;
            if (relon.r==$parentLineTempNid) return relon;
            var relNOBJ = MEMG.getNeuronByTempNid(relon.r);
            if ($skipTnids.length && $skipTnids.indexOf(relon.r)!=-1) continue;
            if (MEMG.besOf(relNOBJ, $parentLineTempNid)==true) return relon;
        }
        return null;
    }

    _getFuncObj=function($params) {
        var str = "autoget";
        var params=[];
        if ($params[0].type!=undefined) {
            str="Type";
            params.push($params[0].type);
        }
        if ($params[0].from_nid!=undefined) {
            str=str+"From";
            params.push($params[0].from_nid);
        }
        if ($params[0].reln!=undefined) {
            str=str+"Reln";
            params.push($params[0].reln);
        }
        if ($params[0].to_type!=undefined) {
            str=str+"ToType";
            params.push($params[0].to_type);
        }
        if ($params[0].to_s!=undefined) {
            str=str+"ToS";
            params.push($params[0].to_s);
        }
        return {functName:str, params:params};
    }


    get=function($outs, ...$objs) {
        var functObj = this._getFuncObj($objs);
        console.log(functObj);
        //return this[functObj.funcName]($outs, params);
    }

    gets=function($outs, $getObj){
    }


    getRelonFromTo=function($outs, $type, $to_s) {
        for (var r=0; r <$outs.length; r++) {
            if ($outs[r].type!=$type) continue;
            if ($outs[r].to_s==$to_s) return $outs[r];
        }
        return null;
    }
    getRelonsFromTo=function($outs, $type, $to_s) {
        var relons = [];
        for (var r=0; r <$outs.length; r++) {
            if ($outs[r].type!=$type) continue;
            if ($outs[r].to_s==$to_s) relons.push($outs[r]);
        }
        return relons;
    }
    
   /**
    * Get a relon downline.
    * 
    * For an array of outs, and a reln_nid -- get the first to_s value that
    * matches any downloine of the reln_nid in the reln.  
    * IE, looking for a thumbnail image of a certain class or subclass.
    *  
    * This is essentially looking for any qualifying reln (property) value 
    * that is a subclass of the actual value we were expecting.
    * 
    * note: do not use insts here.
    * 
    * @author {Mr.Scatman} 
    */
    getRelnByRelonAndValueAnyDownline=function($outs, $reln_nid) {
        var childrenDownline = [$reln_nid];
        var relnNOBJ = MEMG.getNeuronByTempNid($reln_nid);
        var bDOINSTS = false;
        relnNOBJ.getAllDownlineChildren(childrenDownline, 0, bDOINSTS); //this should get all subs, all children of subs.. (all insts of)
        for (var r=0; r <$outs.length; r++) {
            console.log($outs[r].r+" vs "+$reln_nid);
            if (childrenDownline.indexOf($outs[r].r)!=-1) return $outs[r].to_s;
        }
        return "";
    }

    /**
     */
    getAnyRelonWithR = function($outs, $r) {
        if (ANNE.UTILS.isset($outs)==false) return null;
        for (var r=0; r < $outs.length; r++) {
            var rObj = $outs[r];
            if (rObj.r==$r) return rObj;
        }
        return null;
    }


    /**
     * 
     * @param {*} $outs 
     * @param {*} $type 
     * @param {*} $r 
     * @author {Mr.Scatman}
     */
    getRelonFromWithR = function ($outs, $type, $r) {
        if (ANNE.UTILS.isset($outs)==false) return null;
        for (var r=0; r < $outs.length; r++) {
            var rObj = $outs[r];
            if (rObj.r==$r && rObj.type==$type) return rObj;
        }
        return null;
    }

    /** 
     * Get a relon by type, reln and to_type
     * 
     * @param {array} - The array of outs to look in
     * @param {int} - The dimension/TYPE we want.
     * @param {int} - The temp_nid or the reln.
     * @param {int} - The TO_TYPE
     * 
     * @author {Mr.Scatman}  
     */
     getRelonFromWithRToType = function ($outs, $type, $r, $to_type) {
        if (ANNE.UTILS.isset($outs)==false) return null;
        for (var r=0; r < $outs.length; r++) {
            var rObj = $outs[r];
            if (rObj.r==$r && rObj.type==$type && rObj.to_type==$to_type) return rObj;
        }
        return null;
    }
    getRelonsFromWithRToType = function ($outs, $type, $r, $to_type) {
        if (ANNE.UTILS.isset($outs)==false) return [];
        var matches = [];
        for (var r=0; r < $outs.length; r++) {
            var rObj = $outs[r];
            if (rObj.r==$r && rObj.type==$type && rObj.to_type==$to_type) matches.push(rObj);
        }
        return matches;
    }

    /**
     * @param {array} - an array of relons to search
     * @param {int} - the dimension (TYPE) of the relon
     * @param {string} - nide longstring of the reln
     * 
     * @author {Mr.Scatman} 
     */
    getRelonFromWith = function ($outs, $type, $reln) {
        if (ANNE.UTILS.isset($outs)==false) return null;
        for (var r=0; r < $outs.length; r++) {
            var rObj = $outs[r];
            if (rObj.reln==$reln && rObj.type==$type) return rObj;
        }
        return null;
    }


    /**
     * @param {array} - an array of relons to search
     * @param {int} - the dimension (TYPE) of the relon
     * @param {int} - temp_nid of the neuron you want in the reln slot of the relon.
     * @param {string} - string of what to expect in the to_s (nidlongstring or any value)
     * 
     * @author {Mr.Scatman} 
     */
    getRelonFromWithTo = function ($outs, $type, $reln, $to_s) {
        if (ANNE.UTILS.isset($outs)==false) return null;
        for (var r=0; r < $outs.length; r++) {
            var rObj = $outs[r];
            if (rObj.type!=$type) continue;
            if (rObj.reln!=$reln) continue;
            if (rObj.to_s!=$to_s) continue;
            return rObj;
        }
        return null;
    }

    getRelonFromWithTo_orParentLine1 = function ($outs, $type, $reln, $to_s) {
        if (ANNE.UTILS.isset($outs)==false) return null;
        var relNOBJ = ANNE.MEMG.getNeuronByNid($reln);
        var parentRELN = relNOBJ.getParent();
        for (var r=0; r < $outs.length; r++) {
            var rObj = $outs[r];
            if (rObj.type!=$type) continue;
            if (rObj.reln!=$reln && rObj.reln!=parentRELN.nid) continue;
            if (rObj.to_s!=$to_s) continue;
            return rObj;
        }
        return null;
    }

    hasRelon = function ($outs, $r, $to_s) {
        if (ANNE.UTILS.isset($outs)==false) return null;
        if ($r > 100000000) {
            console.warn("r should NOT be a nid, it should be a temp_nid! (index in the aNeuronsHash tbl)");
        }

        for (var r=0; r < $outs.length; r++) {
            var rObj = $outs[r];
            if (rObj.r!=$r) continue;
            if (rObj.to_s!=$to_s) continue;
            return rObj;
        }
        return null;
    }

    //used for known relon patterns to pre-encoded values
    //ie, data import from wiki company of "founders" pointing to a "string" for a person
    getRelonFromWithToText = function ($outs, $type, $reln, $text) {
        for (var r=0; r < $outs.length; r++) {
            var rObj = $outs[r];
            if (rObj.type!=$type) continue;
            if (rObj.reln!=$reln) continue;
            
            if (rObj.to_type==TO_TYPE_ANNE) {
                var nObj = MEMG.getNeuronByTempNid(rObj.t);
                if (nObj.text!=$text) continue;
            }
            else continue;
            return rObj;
        }
        return null;
    }
    getRelonsFromWithTo = function ($outs, $type, $r, $to_s) {
        var relons = [];
        if (ANNE.UTILS.isset($outs)==false) return relons;
        if ($r > 100000000) {
            console.warn("r should NOT be a nid, it should be a temp_nid! (index in the aNeuronsHash tbl)");
        }
        for (var r=0; r < $outs.length; r++) {
            var rObj = $outs[r];
            if (rObj.type!=$type) continue;
            if (rObj.r!=$r) continue;
            if (rObj.to_s!=$to_s) continue;
            relons.push(rObj);
        }
        return relons;
    }

    /**
     * @param {array} - an array of relons to search
     * @param {int} - the dimension (TYPE) of the relon
     * @param {string} - nide longstring of the reln
     * 
     * @author {Mr.Scatman} 
     */
    getRelonsFromWith = function ($outs, $type=null, $reln) {
        var relons = [];
        if (ANNE.UTILS.isset($outs)==false) return relons;
        for (var r=0; r < $outs.length; r++) {
            var rObj = $outs[r];
            if (rObj.reln!=$reln) continue;
            if ($type!=null && rObj.type!=$type) continue;
            relons.push(rObj);
        }
        return relons;
    }

    
    getRelonsFromWiths = function ($outs, $types, $relns) {
        var relons = [];
        for (var r=0; r < $outs.length; r++) {
            var rObj = $outs[r];
            if ($relns.indexOf(rObj.r)!=-1 && $types.indexOf(rObj.type)!=-1) {
                relons.push(rObj);
            }
        }
        return relons;
    }


    getRelonsTo = function ($ins, $type, $to_type, $to_s) {
        var relons = [];
        for (var r=0; r < $ins.length; r++) {
            var rObj = $ins[r];
            if (rObj.type!=$type) continue;
            if ($rObj.to_type!=to_type) continue;
            if ($rObj.to_s!=$to_s) continue;
            relons.push($rObj);
        }
        return relons;
    }

    /** 
     * Brutal search through all relons.. can be avoided if we create
     * an emulated neuron for any txid that shows up in the to_s.
     * Then it would be a neuron that could have ins that are easily searched
     * by the getRelonsTo function above.
     * @author {Mr.Scatman} 
     */
     getRelonsToNaked = function ($type, $to_type, $to_s) {
        var relons = [];
        for (var r=0; r < MEM._aRelons.length; r++) {
            var rObj = $ins[r];
            if (rObj.type!=$type) continue;
            if ($rObj.to_type!=to_type) continue;
            if ($rObj.to_s!=$to_s) continue;
            relons.push($rObj);
        }
        return relons;
    }


    /** 
     * @author {Mr.Scatman} 
     */
    getSysRelon=function($outs, $relnTnid) {
        for (var r=0; r < $outs.length; r++) {
            if ($outs[r].r==$relnTnid && $outs[r].type==TYPE_SYS) return $outs[r];
        }
        return null;
    }

    getSysRelonWithNoSysRefTxid=function($outs, $relnTnid) {
        for (var r=0; r < $outs.length; r++) {
            if ($outs[r].r==$relnTnid && $outs[r].type==TYPE_SYS) {
                if ($outs[r].sys_ref_txid==null || $outs[r].sys_ref_txid=="") return $outs[r];
            }
        }
        return null;
    }

    /** 
     * @author {Mr.Scatman} 
     */
    getSysRelons=function($outs, $relnTnid) {
        var rels = [];
        for (var r=0; r < $outs.length; r++) {
            if ($outs[r].r==$relnTnid && $outs[r].type==TYPE_SYS) rels.push($outs[r]);
        }
        return rels;
    }


    /** 
     * @author {Mr.Scatman} 
     */
    getSysToTypes=function() {
        return MEM._SYS_TO_TYPE_CODES;
    }
    getSysTypes=function() {
        return MEM._SYS_TYPE_CODES;
    }

    //


    /** 
     * 
     * @author {Mr.Scatman} 
     */
    getTerminatingType=function($nObj) {
        if ($nObj==null) return null;
        if ($nObj.SYS_ENUM_VAL!=undefined) return $nObj;
        if ($nObj.be_lvl==-1) return null;
        var bes = $nObj.bes;
        if (bes.length==0) return null;
        var beObj = MEMG.getNeuronByTempNid(bes[0]);
        var safety = 20;
        while (beObj) {
            safety=safety-1;
            if (safety<=0) return null;
            if (beObj.SYS_ENUM_VAL!=undefined) return beObj;
            if (beObj.bes.length==0) return null;   //not a terminating type.
            if (beObj.be_lvl==1) return null;       //safety check.
            if (beObj.temp_nid==beObj.bes[0]) {
                console.warn("catastrophic self-reference in the BE dimension!!!");
                return null;
            }
            beObj = MEMG.getNeuronByTempNid(beObj.bes[0]);
            if (beObj.be_lvl==0) return null;       //safety check.
        }
        return null;
    }


    /** 
     * @author {Mr.Scatman} 
     */  
    getToNObjPropFromRelon=function($fulfillmenRelon, $prop="SYS_ENUM_VAL") {
        if ($fulfillmenRelon==null) return "";
        if ($fulfillmenRelon.t==undefined || $fulfillmenRelon.t==-1) return "";
        var nOBJ = MEMG.getNeuronByTempNid($fulfillmenRelon.t);
        if (nOBJ==null) return "";
        if (nOBJ[$prop]==undefined) return "";
        return nOBJ[$prop];
    }
    

    /**
     * Sometimes i need some help.. remembering function names.
     * @param {*} $nObjs 
     * @returns 
     */
    getTnidList=function($nObjs) {
        return this.getTnidsFromNObjs($nObjs);
    }

    
    /** 
     * @author {Mr.Scatman} 
     */    
     getTnidsFromNObjs=function($nObjs) {
        var tnids = [];
        for (var n=0; n<$nObjs.length;n++) { tnids.push($nObjs[n].temp_nid); }
        return tnids;
    }

    getTnidsFromNids=function($nids) {
        var tnids = [];
        for (var n=0; n<$nids.length;n++) { 
            var nObj = ANNE.MEMG.getOrMakeIfNew($nids[n]);
            tnids.push(nObj.temp_nid); 
        }
        return tnids;
    }
    
    
    /**
     * 
     * @param {*} $relons 
     * @param {*} $r 
     * @returns 
     */
    getFromArrayMap=async($relons, $r=-1)=>{
        var am = new arraymap();
        var chase_froms = [];

        for (var r=0; r < $relons.length; r++) {
            var rel = $relons[r];
            if ($r!=-1 && rel.r!=$r) continue;

            if (rel.to_type!=TO_TYPE_ANNE) continue;
            var fromNOBJ = MEMG.getNeuronByTempNid(rel.f);
            if (fromNOBJ.text=="") {
                if (chase_froms.indexOf(rel.from_nid)==-1) chase_froms.push(rel.from_nid);
            }
            am.addUnique(fromNOBJ, fromNOBJ.nid);
        }

        if (chase_froms.length) {
            await ANNE.API.getNames(chase_froms);
        }

        return am;
    }


    getNObjsFromRels=function($rels) {
        return this.getToNObjsFromRelon($rels);
    }
    /**
     * 
     * @param {*} $rels 
     * @returns 
     */
    getToNObjsFromRelon=function($rels) {
        var nObjs = [];
        for (var r=0; r < $rels.length; r++) {
            if ($rels[r].to_type!=TO_TYPE_ANNE) continue;
            var toNOBJ = ANNE.MEMG.getNeuronByNid($rels[r].to_s);
            nObjs.push(toNOBJ);
        }
        return nObjs;
    }


    /**
     * 
     * @param {*} $countryNOBJ 
     * @param {*} $bdoIDB 
     * @returns 
     */
    getNationalityFromNation=async($countryNOBJ, $bdoIDB=true)=> {
        if ($countryNOBJ.nid==ANNE.MEM.usa.nid) return ANNE.MEM.american.nid;
        
        //onetime pull of the ins of this country.
        if ($bdoIDB==true) await ANNE.IDB.loadIDBNidIns_single($countryNOBJ.nid);

        for (var r=0; r < $countryNOBJ.ins.length; r++) {
            var rel = $countryNOBJ.ins[r];
            if (rel.type!=TYPE_BE) continue;
            if (rel.reln!=ANNE.MEM.country.nid) continue;
            return rel.to_s;
        }

        return "";
    }


    /**
     * 
     * @param {*} $nObj 
     * @param {*} $reln 
     * @param {*} $bCHASEIDB 
     * @returns 
     */
    getToNObjsByReln=async($nObj=null, $reln="", $bCHASEIDB=false)=>{
        if ($nObj==null) return [];
        if ($reln=="" || $reln==null) return [];
        var nObjs = [];
        var from_nids = [];
        
        if ($reln!="") {
            var relnNOBJ = ANNE.MEMG.getNeuronByNid($reln);
            console.log("looking for relnNOBJ "+relnNOBJ.text+" on "+$nObj.text);
        }
        
        //ANNE.TALK.printRelons($nObj.outs);

        await ANNE.IDB.getNid(null, $nObj.nid);

        ANNE.TALK.printRelons($nObj.outs);
            
        for (var r=0; r < $nObj.outs.length; r++) {
            var rel = $nObj.outs[r];
            if (rel.reln!=$reln) continue;
            var nObj = MEMG.getNeuronByNid(rel.to_s);
            nObjs.push(nObj);
            if (from_nids.indexOf(nObj.nid)!=-1) {
                from_nids.push(nObj.nid);
            }
        }

        if ($bCHASEIDB==true) {
            var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.lookupNids", from_nids.join(""));
		    await ANNE.IDB.lookupNids(phObj, from_nids, [0,1,2,3,4,5,6,7,8,9,10])
        }

        return nObjs;
    }


    getBirthDeath=function($nObj) {
        var birthday = null;
        var deathday = null;
        for (var r=0; r < $nObj.outs.length; r++) {
            if ($nObj.outs[r].type!=TYPE_BE && $nObj.outs[r].type!=TYPE_HAS) continue;
            var rel = $nObj.outs[r];
            if (rel.r==ANNE.MEM.birthday.temp_nid) {
                birthday=rel.to_s;
            }
            else if (rel.r==ANNE.MEM.deathday.temp_nid) {
                deathday=rel.to_s;
            }
        }
        
        return {date1:birthday, date2:deathday};
    }
    

    /**
     * We could build an auto alt be parent/child heirarchy here, but meh.
     * It is only for one use in the threejs app.
     */
    getTribesArr=async()=>{
        
        var tribal_nids = [];
        for (var r=0; r < MEM._aRelons.length; r++) {
            if (MEM._aRelons[r].to_type!=TO_TYPE_ANNE) continue;
            if (MEM._aRelons[r].type!=TYPE_BE) continue;

            if (MEM._aRelons[r].r==MEM.ec_is.temp_nid
                && MEM._aRelons[r].t==MEM.tribal.temp_nid) {
                if (tribal_nids.indexOf(MEM._aRelons[r].from_nid)==-1) {
                    tribal_nids.push(MEM._aRelons[r].from_nid);
                }
            }
            
            else if (MEM._aRelons[r].r==MEM.tribal.temp_nid) {
                if (tribal_nids.indexOf(MEM._aRelons[r].to_s)==-1) {
                    tribal_nids.push(MEM._aRelons[r].to_s);
                } 
            }
        }
        
        //religions
        for (var i=0; i < MEM.religion.ins.length; i++) {
            if (MEM.religion.ins[i].type!=TYPE_BE) continue;
            if (MEM.religion.ins[i].r!=MEM.inst.temp_nid) continue;
            if (tribal_nids.indexOf(MEM.religion.ins[i].from_nid)==-1) {
                tribal_nids.push(MEM.religion.ins[i].from_nid);
            }
        }

        //political parties.
        for (var i=0; i < MEM.political_party.ins.length; i++) {
            if (MEM.political_party.ins[i].type!=TYPE_BE) continue;
            if (MEM.political_party.ins[i].r!=MEM.inst.temp_nid) continue;
            if (tribal_nids.indexOf(MEM.political_party.ins[i].from_nid)==-1) {
                tribal_nids.push(MEM.political_party.ins[i].from_nid);
            }
        }

        //awards/groups/alma maters?  (some identify with those as their primary identification)
        //and it is relevant.  (we have the data already in the hypergraph,  TO DO this later.
        if (tribal_nids.length>0) return this.getNObjsFromNidList(tribal_nids);
        return [];
    }


    getNeuronsFromTnids=function($tnids) { 
        return this.getNObjsFromTnids($tnids);
    }

    //lets write another one since I can never find things.
    getNObjsFromTnids=function($tnids) {
        var nObjs = [];
        for (var t=0; t<$tnids.length; t++) { 
            var nObj = MEMG.getNeuronByTempNid($tnids[t]);
            nObjs.push(nObj); 
        }
        return nObjs;
    }

    getNidsListFromTnidsList=function($tnids) {
        var nids = [];
        for (var t=0; t<$tnids.length; t++) { 
            var nObj = MEMG.getNeuronByTempNid($tnids[t]);
            nids.push(nObj.nid); 
        }
        return nids;
    }
 

    //probably already did this, as usual.. doing it again.
    getNidsListFromNObjs = function($nObjs) {
        var nids = [];
        for (var n=0; n < $nObjs.length; n++) {
            if (nids.indexOf($nObjs[n].nid)==-1) nids.push($nObjs[n].nid);
        }
        return nids;
    }

    getNObjsFromList = function($nids) {
        var nObjs = [];
        for (var n=0; n < $nids.length; n++) {
            var nObj = MEMG.getNeuronByNid($nids[n]);
            if (nObj==null) continue;
            nObjs.push(nObj);
        }
        return nObjs;
    }
    

   /** 
    * Lookup up a neuron in our hash table.
    * 
    * In ANNE chain the neurons are already .nid strings and they 
    * ARE the hash.  Previous implementations had longer strings
    * and needed to hash them into a table to prevent slowdowns.
    * 
    * ANNE chain neurons are max 20 chars long and they the associative
    * key in the hash table pointing to the the temp_nid which is 
    * the index of the neuron in numeric order in the _aNeurons table.
    * 
    * .nid = the full id (in string form of a signed long) as it exists on the blockchain.
    * .temp_nid = the numeric index into the _aNeurons.
    * 
    * @author {Mr.Scatman} 
    */    
    __hashNeuronLookup=function($nid, $maxFireWeight=0.03) {
        if ($nid.length == 0) return null;
        if ($nid==undefined || $nid==null) return null;          
        if (typeof $nid === "object") {
            return null;
        }
        var temp_nid = ANNE.MEM._aNeurons_hashtbl[$nid];
        if (temp_nid!=undefined) {
            if (ANNE.BRAIN!=null && $maxFireWeight!=0) {
                ANNE.BRAIN.fireNeuron(ANNE.MEM._aNeurons[temp_nid], $maxFireWeight);
            }
            return ANNE.MEM._aNeurons[temp_nid];
        }
        return null;
    }

    /**
     * Lookup relon (Transaction) by txid using our hash table.
     * For use when you are looking up a relon by txid. 
     * Get the rid index in the hash table, and use it to snag the relon!
     *                                                          
     *
     * @param {string}  - This is a JAVA Long as a string for the TransactionId
     * @author Mr.Scatman
     */
    __hashRelonLookup=function($txid) {
        if ($txid==undefined || $txid==null || typeof $txid!=="string") {
            console.log("this should never happen"); 
            return null;
        }

        $txid = $txid.trim();

        if ($txid.length == 0 || $txid.length>21) {
            console.log("this should never happen"); 
            return null;
        }
        if (typeof $txid !== "string") return null;
        var rid = MEM._aRelons_hashtbl[$txid];
        if (rid!=undefined) return MEM._aRelons[rid];
        return null;
    }


    /**
     * Get alt ec_is TYPE_BE relon to the temp_t 
     */
     isAltBeOf = function($outs, $temp_t) {
        for (var r=0; r <$outs.length; r++) {
            if ($outs[r].type!=TYPE_BE) continue;
            if ($outs[r].to_type!=TO_TYPE_ANNE) continue;
            if ($outs[r].t!=$temp_t) continue;
            return true;
        }
        return false;
    }
    
    /** 
     * Lookup a relon by TXID.
     * 
     * tired of mispelling the other one.
     * 
     * @author {Mr.Scatman} 
     */
    lookupByTXID = function ($txid, $arr=null) { 
        var rel =  MEMG.lookupRelonByTXID($txid, $arr);
        return rel;
    }

    lookupByTXID_chase = async ($txid, $arr=null)=> { 
        var rel =  MEMG.lookupRelonByTXID($txid, $arr);
        if (rel==null) return await CHASE.lookupTxid($txid);
        return rel;
    }

    lookupTXID = function($txid, $arr=null) {
        return this.lookupRelonByTXID($txid, $arr);
    }

    /**
     */
    lookupRelonByTXID = function($txid, $arr=null) {
         var arr = null;
         
         //if array is passed in use it the old fashioned looper way
         if ($arr!=null) arr = $arr;
 
         //if no array, we are searching the entire relon space. Use our hash table method.
         else return MEMG.__hashRelonLookup($txid);
 
         //if $arr, then just loop it for our txid.
         for (var r=0; r < arr.length; r++) {
             var rObj = arr[r];
             if (rObj.txid==$txid) return rObj;
         }
         return null;
     }


     lookupRelonByRid = function($rid) {
        var relon = MEM._aRelons[$rid];
        return relon;
    }

    
    /**    
     * Display the to_s value of a relon the best we can.
     * If a decrypted value exists, display it.
     * 
     * TODO: Should have clear ways to show some of the other TO_TYPEs..
     * (formatters)...
     * 
     * @author {Mr.Scatman} 
     */
     __MASTER_DISPLAY_RELON_TO = function($relon, $to_class="") {
        var to_s = $relon.to_s;
        var to_type = $relon.to_type;
        var pre_ico_add = "";

        if (to_type>=TO_TYPE_ENCR_ANNE) {
            if ($relon.decrypted!=undefined) {
                to_s = $relon.decrypted;
                to_type = parseInt(to_type)-30;
            }

            else if ($relon.ghost==true) {
                var fNOBJ = MEMG.getNeuronByTempNid($relon.f);

                //non encrypted value is in the to_s still since we 
                //do not do encryption until we have a real FROM NOBJ
                if (fNOBJ.ghost==false) to_type = parseInt(to_type)-20;

                //for ghost relons FROM REAL NEURONS we will have the encryption
                //already done.
            }
            else {
                pre_ico_add = '<span title="encrypted" style="filter: grayscale(100%); font-size:.8rem">🔒</span>';
            }
            //too nasty to alter all the calls to await this funct..
            //each session the encryped to will remain encrypted until
            //decrypted.  That app session it will then be available.
            //else {
                //await USER.ascertainEncryptionAndDecrypt($relon);
            //}
        }

        if (to_type==TO_TYPE_ANNE) {  
            var toNOBJ = null;
            if ($relon.t!=undefined && $relon.t!=-1) toNOBJ = MEMG.getNeuronByTempNid($relon.t);
            else toNOBJ = MEMG.getNeuronByNid(to_s);

            if (toNOBJ!=null) {
                if (toNOBJ.text!="") return pre_ico_add+toNOBJ.text;
                return pre_ico_add+toNOBJ.nid;
            }
            return pre_ico_add+to_s;
        }

        else if (to_type==TO_TYPE_NUMBER) {
            var to_s_str = to_s+"";
            var post = this.doPostANNIESHackFix($relon);
            if (post.length>0) {
                return pre_ico_add+to_s+post;
            }
            else {
                if (to_s_str.indexOf(".")!=-1) return pre_ico_add+to_s;
                else if (parseInt(to_s)>=1000) return pre_ico_add+ANNE.UTILS.commas(to_s);
                return pre_ico_add+to_s;
            }

        }

        else if (to_type==TO_TYPE_STRING) {
            var relNOBJ = MEMG.getNeuronByTempNid($relon.r);

            //if this is a url part with a url base, blow it out full format.
            if (relNOBJ && relNOBJ.is(MEM.url_part)==true) {
                var base_rel = MEMG.getHasRelon(relNOBJ.outs, MEM.base_url.temp_nid);
                if (base_rel!=null) {
                    var parts = to_s.split(":::");//anne protocol for src:::display.
                    var disp = "";
                    var url = base_rel.to_s+parts[0];
                    if (parts.length>1) disp = parts[1];
                    else disp = url;
                   
                    return pre_ico_add+'<a title="'+url+'" href="'+url+'" target="_blank">'+disp+'</a>';
                }
                else return pre_ico_add+to_s;
            }

            var post = this.doPostANNIESHackFix($relon);
            if ($to_class!="") {
                return  pre_ico_add+"<span class='"+$to_class+"'>"+to_s+"</span>"+post;
            }
            return pre_ico_add+to_s+post;
        }

        else if (to_type==TO_TYPE_BOOLEAN) {
            var val = "";
            if (to_s==0 || to_s=="0") val = false;
            else if (to_s==1 || to_s=="1") val = true;
            else val = to_s;
            return pre_ico_add+val;
        }

        else if (to_type==TO_TYPE_URL) {
            var relNOBJ = MEMG.getNeuronByTempNid($relon.r);

            //if this is a url part with a url base, blow it out full format.
            if (relNOBJ && relNOBJ.is(MEM.url_part)==true) {
                var base_rel = MEMG.getHasRelon(relNOBJ.outs, MEM.base_url.temp_nid);
                if (base_rel==null) {
                    return pre_ico_add+val;
                }
                else {
                    var parts = to_s.split(":::");//anne protocol for src:::display.
                    var disp = "";
                    if (parts.length>1) disp = parts[1];
                    else disp = to_s;
                    
                    //https://commons.wikimedia.org/wiki/
                    var url = base_rel.to_s+parts[0];
                    
                    //if (base_rel.to_s=="https://commons.wikimedia.org/wiki/") {
                        //url = base_rel.to_s+"File:"+parts[0];   
                    //}
                    return pre_ico_add+'<a class="external" title="'+url+'" href="'+url+'" target="_blank">'+disp+'</a>';
                } 
            }

            var parts = to_s.split(":::");//anne protocol for src vs display.
            var disp = "";
            if (parts.length>1) disp = parts[1];
            else {
                if (to_s.length<40) disp = parts[0];
                else disp = parts[0];
            }
            return pre_ico_add+'<a class="external" title="'+parts[0]+'" href="'+parts[0]+'" target="_blank">'+disp+'</a>';
        }

        //anything else
        var val = to_s;
        var relnNOBJ = MEMG.getNeuronByTempNid($relon.r);
        var TTOBJ = MEMG.getTerminatingType(relnNOBJ);
        if (TTOBJ!=null) {
            var to_sNOBJ = null;
            if ($relon.t!=undefined && $relon.t!=-1) to_sNOBJ = MEMG.getNeuronByTempNid($relon.t);
            if (TTOBJ.formatter!=undefined) {
                if (to_sNOBJ!=null) return pre_ico_add+TTOBJ.formatter(to_sNOBJ);
                else return pre_ico_add+TTOBJ.formatter(val);
            }
            else return pre_ico_add+val;
        }
        else return pre_ico_add+val;
    }


    doPostANNIESHackFix = function($relon) {
        var post = "";
        var val = parseInt(parseInt($relon.to_s)/100);
        if ($relon.r==ANNE.MEM.ASDF_RISK_FUNDED.temp_nid) post = " ("+val+" annecoin)";
        else if ($relon.r==ANNE.MEM.ASDF_RISK_REFUNDED.temp_nid) post = " ("+val+" annecoin)";
        else if ($relon.r==ANNE.MEM.ASDF_RISK_REMAINING.temp_nid) post = " ("+val+" annecoin)";
        else if ($relon.r==ANNE.MEM.min_streampay_payment.temp_nid) post = " ("+val+" annecoin)";
        else if ($relon.r==ANNE.MEM.keep_min_balance.temp_nid) post = " ("+val+" annecoin)";
        else if ($relon.r==ANNE.MEM.annies.temp_nid) post = " ("+val+" annecoin)";
        else if ($relon.r==ANNE.MEM.distro_quantity.temp_nid) {
            var fNOBJ = MEMG.getNeuronByTempNid($relon.f);
            
            //a temp hack..
            if (fNOBJ.bes[0]==ANNE.MEM.streampay.temp_nid) {
                var rel_qt = MEMG.getHasRelon(fNOBJ.outs, MEM.distro_quantity_type.temp_nid);
                if (rel_qt!=null && rel_qt.t==ANNE.MEM.distro_qt_specific.temp_nid) {
                    post = " ("+ANNE.UTILS.commas(val)+" annecoin)";
                }
            }
        }
        
        return post;
    }


    /**
     * Set the my_sponsored array.
     *  
     * We can't get these on initial mem load.. since USer is not logged in.
     * I don't want to do another full loop of relon mem just for this var
     * so we do it on-demand.
     * 
     * Run-time after mem load this will be set properly as the relons come in
     * to the mem processor.
     * 
     * @author {Mr.Scatman} 
     */
    setMySponsored = function($nid) {
        var userNOBJ = MEMG.getNeuronByNid($nid);
        if (userNOBJ.my_sponsored==undefined) userNOBJ.my_sponsored=[];
        for (var r=0; r<ANNE.MEM._aRelons.length; r++) {
            var rObj = ANNE.MEM._aRelons[r];
            if (rObj.sponsored_by!="" && rObj.sponsored_by==$nid) {
                var fNOBJ = MEMG.getNeuronByTempNid(rObj.f);
                if (userNOBJ.my_sponsored.indexOf(fNOBJ.temp_nid)==-1) {
                    userNOBJ.my_sponsored.push(fNOBJ.temp_nid);
                }
            }
        }
    }

    getRelPat = function($prop, $val) {
        return {prop:$prop, val:$val};
    }

    
    /** May be able to switch a BULK of these functions to simply doing this 
            var relPatArr = [{prop:'type', val:TYPE_PARAM}, 
                            {prop:'r', val:$relon_pat.r}, 
                            {prop:'t', val:to_t}]; 
    */
    getRelByPat = function($outs, $relPatArr) {
        for (var r=0; r < $outs.length; r++) {
            var rel = $outs[r];
            var bNO = false;
            for (var rp=0; rp < $relPatArr.length; rp++) {
                var pat = $relPatArr[rp];
                if (rel[ pat.prop] != pat.val) {
                    bNO=true;
                    break;
                }
            }
            if (bNO==false) return rel;
        }
    }

    getRelsByPat = function ($outs, $relPatArr) {
        var rels = [];
        for (var r=0; r < $outs.length; r++) {
            var rel = $outs[r];
            var bNO = false;
            for (var rp=0; rp < $relPatArr.length; rp++) {
                var pat = $relPatArr[rp];
                if (rel[ pat.prop] != pat.val) {
                    bNO=true;
                    break;
                }
            }
            if (bNO==false) rels.push(rel);
        }
        return rels;
    }
    
    
    getFreezeRel = function($outs) {
        for (var r=0; r < $outs.length; r++) {
            var rel = $outs[r];
            if (rel.r == ANNE.MEM.CMD_FREEZE.temp_nid) {
                return rel;
            }
        }
        return null;
    }

    nidsToTnidsList=function($tnids) {
        var nids = [];
        for (var t=0; t < $tnids.length; t++) {
            nids.push( MEMG.getNeuronByTempNid($tnids[t]).nid);
        }
        return nids;
    }



}


var MEMG = new mem_gets();
//freeze this
