class tracker_map {
    constructor() {
        this.tracker = {locations:{}, corps:{}, people:{},
                 groups:{}, groupEvents:{}, religions:{},
                occupations:{}};
    }

    //generic method by class nid (not a named prop)
    hasClassVal = function($val, $classNid) {
        if (this.tracker[$classNid]==undefined) return false;
        var obj = this.tracker[$classNid];
        if (obj[$val.toLowerCase()]==undefined) return false;
        return true;
    }
    getClassVal = function($val, $classNid) {
        var obj = this.tracker[$classNid];
        return obj[$val.toLowerCase()];
    }
    addClassVal = function($nObj, $classNid) {
        if (this.tracker[$classNid]==undefined) {
            this.tracker[$classNid] = [$nObj.text.toLowerCase()];
            return;
        }
        var obj = this.tracker[$classNid];
        obj[$nObj.text.toLowerCase()] = $nObj;
    }
}
