var ANNET = {};
ANNET._tabpguis = [];
ANNET.lc_links = [];
ANNET.pgui = null;
ANNET.m_pos;
ANNET.el_resize = null;


/**
* @author {Mr.Scatman}  
*/
ANNET.doGraphEMBED=async($temp_nid, $el, $sizeObj, $bSHOWINBOUNDS=false)=> {
    console.log("(doGraphEMBED) temp_nid:"+$temp_nid);
    //we will check the inner flags to repair this upon close of the graph.
    var nObj = MEMG.getNeuronByTempNid($temp_nid);
    ANNE.NN.launchNNExplorerEMBED(nObj, $el, $sizeObj, $bSHOWINBOUNDS);
 }

 ANNET.resize=function(e){
    var parent = ANNET.el_resize.parentNode;
    var dx = ANNET.m_pos - e.x;
    ANNET.m_pos = e.x;
    parent.style.width = (parseInt(getComputedStyle(parent, '').width) + dx) + "px";
}

/**
 * ONE-TIME INIT OF ANNET OBJECT AS LONG AS IT IS IN THE DOM... 
 * ANY NEURON THAT WANTS TO BE VIEWED WITH ANNET WILL COME THROUGH HERE.
 */
ANNET.init = async($pgui)=> {
    ANNET.pgui = $pgui;
    var pObj = $pgui.pObj;
    ANNE.A.show('loading');
    var nOBJ = MEMG.getNeuronByTempNid(pObj.p1);
    await CHASE.chaseNewInfo(nOBJ, [0,1,2,3,4,5,6,7]);

    ANNET.el_resize = document.getElementById("resize");

    ANNET.el_resize.addEventListener("mousedown", 
        function(e){
            ANNET.m_pos = e.x;
            document.addEventListener("mousemove", ANNET.resize, false);
        }
        , false);

    document.addEventListener("mouseup", 
        function(){
            document.removeEventListener("mousemove", ANNET.resize, false);
        }
        , false);

    var parentClassText = "";
    var parentNObj = null;
    if (nOBJ!="" && nOBJ!=null && nOBJ.bes!=undefined) {
        parentNObj = MEMG.getNeuronByTempNid(nOBJ.bes[0]);
        if (parentNObj!=null) {
            parentClassText = parentNObj.text;
        }
        if (parentClassText!="") targetText = nOBJ.text + " ("+parentClassText+")";
        else targetText = nOBJ.text;
    }

    //one-time init.  left col-7 of annet.html
    var sizeObj = {};
    sizeObj.h = ANNET._maxDisplayHeight();
    sizeObj.w = window.innerWidth-200;

    var bSHOWINBOUNDS = true;
    await ANNET.doGraphEMBED(nOBJ.temp_nid, "annet_graph_display", sizeObj, bSHOWINBOUNDS);
    ANNE.A.hide('loading');
    
    var ic = document.getElementById('ANNET_nd_isolate_check');
    if (ic!=null) {
        ic.addEventListener("change", $e=> { 
            if (ic.checked) GRAPH_E.isolateCurrentNode(true);
            else GRAPH_E.isolateCurrentNode(false);
        });
    }


    var stc = document.getElementById('ANNET_nd_show_text_check');
    if (stc!=null) {
        stc.addEventListener("change", $e=> { GRAPH_E.toggleText(this.checked); });
    }

    var sic = document.getElementById('ANNET_nd_show_imgs_check');
    if (sic!=null) {
        sic.addEventListener("change", $e=> { GRAPH_E.toggleImages(this.checked); });
    }


    //var types = GRAPH_E.getActiveSchemas();
}

ANNET._maxDisplayHeight=function(){
    return window.innerHeight - 68;
}


ANNET.cheap_events_receiver=async($pgui, $eventObj)=> {
    if ($eventObj.event=="RESIZE_WINDOW") {
        var sizeObj = {};
        sizeObj.h = ANNET._maxDisplayHeight();
        sizeObj.w = window.innerWidth*(2/3);
        //var bSHOWINBOUNDS = true;

        var el = document.getElementById("annet_graph_display");
        var canvas = el.querySelector("canvas");

        console.log(canvas.style);
        console.log(sizeObj);

        canvas.style.width = sizeObj.w+"px";
        canvas.style.height = sizeObj.h+"px";
        //canvas

        //ANNE.A.empty("annet_graph_display");
        //GRAPH_E._lastClickedNOBJ
        //await ANNE.doGraphEMBED(GRAPH_E._lastClickedNOBJ.temp_nid, "annet_graph_display", sizeObj, bSHOWINBOUNDS);
    }
    return;
}


ANNET.addToClickedDisplay = function ($nObj, $bREMOVEFIRST=false) {
    var lc = document.getElementById('annet_last_clicked');
    if ($nObj!=null) nid = $nObj.nid;
    else nid = "";

    //ANNET.lc_links.unshift();
}


ANNET.loadForNeuron=async ($nObj)=> {
    console.warn("load ANNET for neuron:"+$nObj);
    if  (ANNET._tabpguis.length==0) return;
    await ANNET.initInfoTabData($nObj, ANNET._tabpguis[0]);
}


ANNET.redoInfoTbl = function($nObj, $types) {
    console.warn("(redoInfoTbl) active types:"+$types);
    console.log($nObj);
    
    //loop the data array -- set active = true or false based on type.
    //reapply any filters.
    var info_tab_pgui = ANNET._tabpguis[0];
    console.log(info_tab_pgui);

    var relonpgui = info_tab_pgui.getChildPguiByDivid("RELONTBL");
    if (relonpgui==null) {
        alert("couldn't find relon pgui for RELONTBL on the info_tab_pgui");
        return;
    }

    var tbl_el = relonpgui.tbl_el;
    if (tbl_el==undefined) {
        alert("couldn't find tbl_el ptr set on this pgui. This should have been set in the anne_relon_table.js");
        return;
    }
    RELONTBL.externalDataChange(tbl_el, $types);
}


  
/*** timelineLoaded ************************************** 0x/xx/20xx ***
******************************************************** Mr.Scatman ****/
ANNET.timelineLoaded = function($pObj, $pgui) {
    ANNET._tabpguis[1] = $pgui;
    console.warn("timeline tab loaded");
    ANNE.A.hide($pObj.p2);
}


ANNET.feedbackLoaded = function($pObj, $pgui) {
    ANNET._tabpguis[3] = $pgui;
    console.warn("feedback tab loaded");
    ANNE.A.hide($pObj.p2);
}

ANNET.toolsLoaded = function($pObj, $pgui) {
    ANNET._tabpguis[4] = $pgui;
    console.warn("tools tab loaded");
    ANNE.A.hide($pObj.p2);
}


/**
 * 
 */
ANNET.closeANNET_nd=function() {
    ANNE.A.fadeOut('ANNET_nd');
}



/**
 * 
 */
ANNET.doFeelz = async($parentClassTexxt, $targetText, $nObj)=> {
    var msg = 'Apply feelz and stars directly to the <em>'+$parentClassTexxt+'</em>&nbsp;<b>'+$targetText+'</b>&nbsp;neuron (wherever it is used in ANNE)';
    var titleLeft = $('#annet-feedback-title-right');
    titleLeft.html(msg);

    var titleRight = $('#annet-feedback-title-right');
    STARS_GUI.doRightColStars(titleRight, "hobojobo", MEM.star10ratingsystem.temp_nid, $nObj.temp_nid);

    var feedback_body = $('#annet_nd_feedback_body');
    feedback_body.empty();
    await ANNET.buildFeelzDisplay(null, feedback_body, "blahblahblah", $nObj);
    return;
}


/**
 * 
 */
ANNET.buildFeelzDisplay = async($obj, $div, $ID, $realNOBJ=null, $txid="", $feelzRow=null)=> {
    var realNOBJ = null;
    if ($realNOBJ!=null) realNOBJ = $realNOBJ;
    else if ($obj!=null) realNOBJ = $obj.resolved_nObj;
    else return;
    var feelzRow = $feelzRow;
    if (feelzRow==null) {
        feelzRow = document.createElement("div");
        feelzRow.classList=["anne-row", "row-feedback"];//<div class="row row-feedback"></div>');
        $div.append(feelzRow);
    }
    var leftCol = document.createElement("div");
    leftCol.classList="left_dyno_w";
    var rightCol = document.createElement("div");
    rightCol.classList = "feedback";
    feelzRow.append(leftCol);
    feelzRow.append(rightCol);
   
    var link = "";
    if (realNOBJ.sponsored_by!=undefined && realNOBJ.sponsored_by!="") {
        var sponsorNOBJ = MEMG.getOrMakeIfNew(realNOBJ.sponsored_by);
        link = GUI_STUFF.makeANNEUserLinkSmart(sponsorNOBJ);    
    }
    else if (realNOBJ.owned_by!="") {
        var ownedByNOBJ = MEMG.getOrMakeIfNew(realNOBJ.owned_by);
        link = GUI_STUFF.makeANNEUserLinkSmart(ownedByNOBJ);
    }
    leftCol.append('<span class="span-sponsor"><b>sponsored by</b><BR>'+link+'</span>');
    await ANNET.doFeedback(rightCol, realNOBJ, $ID, "", $txid);
    return;
}


/**
 * 
 */
ANNET.doFeedback = async ($el, $thing, $ID, $logo_path="", $txid="")=> {
    var topUniqueId = $ID+$txid;    //if txid exists we tack it on to our unique ID for the original thing.
    alert("redo this");
}