class maker_streampay_gui extends maker_gui {
    constructor($pgui, $ANNKH) {
        super($pgui);
        this.main_class = new service_streampay($pgui);
        this.initTbl($ANNKH);
        ANNE.A.hide(this.el_my_section);
        this.main_class.el_input.focus();
    }

    initTbl = function($ANNKH) {
        this.nObjs = [];
        ANNE.A.hide("tbl_chks");

        //streampay are only self-owned FUND neurons (keyless)
        //probably want to show inbound and outbound streampays here.
        var bOWNED = true;
        var bGHOSTSOK = true;
        this.nObjs = MEMG.getMyStuffByClass(USER._userNObj.nid, bOWNED, false, false, bGHOSTSOK, [MEM.streampay.temp_nid]);

        if (this.nObjs.length==0) {
            ANNE.A.ezEl(this.el_my_section, "div", "", "You have no owned streampays");
            ANNE.A.show(this.el_my_section);
            this.setOverrideMsg("You have no owned streampays.");
            return;
        }

        else {
            this.nObjs.sort(ANNE.UTILS.sortByTextNoCase);
        
            var tableObj = new neuron_table(this.pgui);
            tableObj.bCOLORSQARES=true;
            tableObj.makerViewAllCols(this.nObjs);
            tableObj.neuron_heading_row_class = "neuron-tbl-heading-green";
            ANNE.A.empty(this.el_my_section);
            tableObj.buildDOMTable(this.el_my_section);
            ANNE.A.show(this.el_my_section);
            ANNE.A.smartScroll("maker_inject");
            ANNE.A.show(this.el_my_section);
        }
    }

    checkChg = function($ANNKH) {}
}