

//make this a singleton.
class anne_master {
    constructor(){

        this._annodeDetails = null;

        this.EVENT_SOUND_CHANGE = "SOUND_CHANGE";
        this.EVENT_LOAD_HYPERGRAPH = "LOAD_HYPERGRAPH";

        //this.trusted_ANNODE_3 = "http://148.251.136.43:9116"; 
        //this.trusted_ANNODE_4 = "http://116.203.230.116:9116";
        //this.trusted_ANNODE_5 = "http://148.251.136.43:8116"; 
        
        //this session's no-good dirty rotten disconnected nodes.  :)
        this._disconnected = [];

        var annodesObj = localStorage.getItem('ANNODES');
        if (annodesObj==null) this.annodesLS = null;
        else this._annodesLS = JSON.parse(annodesObj);  //we will set currentANNODE after we extract info for user from LS
            
        //if not annodes ls stored, store it.
        if (this._annodesLS==null) {
            var thisuri = {
                nid:"",
                nickname:window.origin,
                uri:window.origin,
                pubkey:""
            }
            var annodes = [
                thisuri
            ]

            this._annodesLS = {annodes:annodes, last_uri:window.origin, last_nid:""};
            localStorage.setItem('ANNODES', JSON.stringify(this._annodesLS));    
        }

        this._annodeBlockexplorer = this._annodesLS.last_uri+"/blockexploer/blocks.html"
        
        //going to sunset these variables. EVERYTHING (other than awareness/feelz)
        //first makes ghosts (drafts) that can be reviewed.
        //Only when ready are they submit to ANNE data chain.
        this._txMode = TXMODE_ANNE;     
        this._neuronMakeMode = NEWNEURONMODE_KEYLESS;

        this.A = null;
        this.A2A = null;
        this.ACE = null;
        this.ANNTH = null;
        this.API = null;
        this.CLUMPS = null;
        this.DB = {supported:false, bSUPPORTED:false};    //default to false, wait for it to update.
        this.DB_local = {supported:false, bSUPPORTED:false};

        this._userAccts = [];

        this.ACCOUNTS = null;
        this.ACHAT = null;
        this.AQL = null;
        this.AFILES = null;
        this.ANNDLE = null;
        this.ANNEID = null;
        this.ANNEX = null;
        this.ANX = null;    //an app.
        this.ANNODE = null;
        this.AWARE = null;
        this.BRAIN = null;
        this.CHAIN = null;
        this.CHASE = null;
        this.CIRCUIT = null;
        this.CTP = null;
        this.EXT_BTNS = null;
        this.GHOSTDATA = null;
        this.GRAPH_E = null;
        this.gsap = null;               //will set manually if loaded elsewhere
        this.GUI_STUFF = null;
        this.HANAI = null;
        this.HISTORY = null;
        this.HISTORY_LOCAL = null;
        this.IDB = null;
        this.IMAGES = null;
        this.LNOTS = null;
        this.LOCALONLYDATA = null;
        this.LOGIN_SOLO = null;
        this.MEM = null;
        this.MEM_UDF =null;
        this.MEMG = null;               //will be init from MEM
        this.MEMP = null;               //will be init from MEM
        this.MEMS = null;
        this.MEMZ = null;               //will be init from MEM
        this.MSGS = null;
        this.NET = null;
        this.NN = null;
        this.PAGES = null;
        this.RECEIVE_FUNDS = null;
        this.RELONTBL = null;
        this.SENDER = null;
        this.SENDQ = null;
        this.SEND_FUNDS = null;
        this.SETTINGS = null;
        this.TALK = null;
        this.TXB = null;
        this.UNIT_TESTS = null;
        this.USER = null;
        this.UTILS = null;
        this.u3js = null;
        this.UNLOCK = null;
        this.SIGNA = {sig:null, crypto:null, contracts:null, http:null, monitor:null, util:null};
        this.WIKIDATA = null;

        this.loadVars = new Object();

        this._bFIRST_TIME_LOGIN = false;

        //this._mode = "mocknet";     //mocknet/testnet/mainnet
        this._mode = "testnet";   //mocknet/testnet/mainnet
        //this._mode = "mainnet";   //mocknet/testnet/mainnet

        //THIS WILL BE DEFAULT TO A PUBLIC ANNODE and can be overriden by the app dev
        //this._auth_endpoint_base = "https://www.anne.network:3001";
        this.___root = "";                  //in localmode this is altered to the repo root
        this.___root_local_app = "";        //in localmode this is altered to the local app root.  I use winamp and it is jacked for paths.
        this.___logo_path = "../imgs/anne_yellow_arch_on_black.png";
        this.___logo_localpath = "../imgs/anne_yellow_arch_on_black.png";
        this.___anneico_path = "../imgs/anne_ico_small.png";
        this.___annelogo_path = "../imgs/anne_logo_small.png";
        this.___annieico_path = "../imgs/annies_ico_small.png";
        this._explorerAddressHref = "./blockexplorer.html";

        this.ico = "<img title='ANNE' class='annelogo-small' src='"+this.___annelogo_path+"'></img>";

        this.ANNE_TO_ANNIES = 100;
       

        var rt = [];
        rt[TO_TYPE_SEED]=200;
        rt[TO_TYPE_ANNE]=100;
        rt[TO_TYPE_TXID]=100;
        rt[TO_TYPE_URL]=300;
        rt[TO_TYPE_NUMBER]=100;
        rt[TO_TYPE_DATE]=100;
        rt[TO_TYPE_DATETIME]=100;
        rt[TO_TYPE_STRING]=200;
        rt[TO_TYPE_BLOB]=400;
        rt[TO_TYPE_TIME]=100;
        rt[TO_TYPE_BOOLEAN]=100;
        rt[TO_TYPE_FILEHASH]=200;
        rt[TO_TYPE_IPV4]=200;
        rt[TO_TYPE_IPV6]=200;
        rt[TO_TYPE_ENCR_ANNE]=400;
        rt[TO_TYPE_ENCR_TXID]=400;
        rt[TO_TYPE_ENCR_URL]=400;
        rt[TO_TYPE_ENCR_NUMBER]=400;
        rt[TO_TYPE_ENCR_DATE]=400;
        rt[TO_TYPE_ENCR_DATETIME]=400;
        rt[TO_TYPE_ENCR_STRING]=400;
        rt[TO_TYPE_ENCR_BLOB]=400;
        rt[TO_TYPE_ENCR_TIME]=400;
        rt[TO_TYPE_ENCR_BOOLEAN]=400;
        rt[TO_TYPE_ENCR_FILEHASH]=400;
        rt[TO_TYPE_ENCR_IPV4]=400;
        rt[TO_TYPE_ENCR_IPV6]=400;

        //estimated time represented by blocks.
        this.blocks_time = {
            minute:0.5,
            hour:30,
            day:720,
            week:5040,
            lunar_cycle:21240
        }

        this.fees = {
            add_admin:1000,               //10 coins add an admin to a neuron (paid to admin)
            anorg_votecall:1000,          //call vote, creates vote neuron and sends out lnots.
            boosties:0,                   //no relon fee.     
            bounty_claim:2000,            //20 coins to claim a bounty and invoke an ACHAT.
            relon_child:400,              //standard pay to reln/to.
            relon_self:400,               //standard pay to reln/to.
            relon_anjucator_invite:900,   //invite anjucator
            make_custodial:900,           //custodial
            make_keyed:800,               //standard pay to reln/to +40000 fee to annode
            make_global:800,              //no reln/to fire, 80000 fee to annode
            make_global_location:1000,    //heavy load
            make_keyless:900,             //standard pay to reln/to +500 annies fee to annode.
            annvoice:1000,                //standard pay to reln/to +600 annies fee to annode.
            collab_req:600,               //standard pay to reln/to +200 annies to the andy admin
            hanai_req:200,                //200 annies to andy admin, NO FIRE FEE
            collab_hanai_req:700,         //standard pay to reln/to + +300 to the supe andy admin for collab+hanai
            collab_req_reject:0,          //no fee to reject (submitter paid it)
            collab_req_accept:0,          //no fee to accept (submitter paid it)
            make_pdn:2000,                //potential for revenue is HIGH.  20 coins up front, not a share of the UDF price.
            get_pdn:600,                  //will cost the annode 8coins to send an encrypted return msg to the chain.
            node_cmd:0,                   //a cmd to a node by a node owner, no fee.
            relon:rt
        }

        this.bFRESHLOGIN = false;
		this.bJUSTLOGGEDIN = true;
		
		this._errors_to_send = [];
        this.block_pats = new Object();

        //intended to safeguard the Q send of TXs to the annode so
        //it doesn't get interrupted by platform MSG pulls that work on 
        //a timer.
        this.__DO_NOT_INTERRUPT = false;

        this.el_superconsole = null;
        this.el_superconsole_close = null;

        this.bug_hunter = {rejected_broadcasts:[], ambig_conceptualizations:[]};
    }

    hasPostMortem = function() {
        if (this.bug_hunter.rejected_broadcasts.length) return true;
        return false;
    }

    bugHunterRejectedBroadcast=function($cmdObj, $innerRezObj) {
        this.bug_hunter.rejected_broadcasts.push({cmdObj:$cmdObj, innerRez:$innerRezObj});
    }

    bugHunterAC=function($matches, $orig_txt) {
        this.bug_hunter.ambig_conceptualizations.push({original_text:$orig_txt, nObjs:$matches})
    }

    displayAmbigs=function() {
        if (this.bug_hunter.ambig_conceptualizations.length==0) return;
        //TODO.
        //pop these in the LUKAT display window of results with support for merge.
        //also need a more robust way to review these items side by side.. a compare of sorts.
        //we can invoke that from lukat in the checks area..  YET AGAIN, another TODO.
    }


	//quick console error print for easy visibility.
	consoleError=function($msg) {
		console.log("%c ERROR %c"+$msg, ANNE.TALK.bgbigred, ANNE.TALK.bgred);
	}
	
	
    /**
     * 
     */
    activateSimpleWorker=function($task) {
		//$task.ANNE = ANNE;
		var worker = new Worker(URL.createObjectURL(new Blob([`(${ANNE.workerFunction.toString()})()`], { type: 'application/javascript' })));
        worker.onmessage = function(event) {
            const result = event.data;
            console.log('Background processing result:', result);
        };
        worker.postMessage($task);
    }


    /**
     * The only help we could get here would be something getting and processing data.
     * This would need access to the API/NET and it could return raw relons.
     */
    workerFunction=function() {
        self.onmessage = async(event)=> {
            var taskObj = event.data;
            console.log(taskObj);
			//do work here.
            self.postMessage({status:"good"});
        };
    }


    /**
     * 
     */
    testOnThisDay=async()=> {
        //2012-07-06
        var dibd = new dosint_dig_date("16942363368065940924");
        await dibd.onThisDatePart();
        console.log("testonthisday complete");
    }


    deactivateServerSideLogging=function() {
        if (this.SETTINGS) this.SETTINGS.bSERVERSIDE_ERROR_LOGGING = false;
    }

    activateServerSideLogging=function(){
        return;

        if (this.SETTINGS) this.SETTINGS.bSERVERSIDE_ERROR_LOGGING = true;

        window.onerror = function($message, $source, $lineno, $colno, $error) {
            console.error('Error Message: ' + $message);
            console.error('Error Source: ' + $source);
            console.error('Error Line Number: ' + $lineno);
            console.error('Error Column Number: ' + $colno);
            console.error($error.stack);

            if (this.SETTINGS.bSERVERSIDE_ERROR_LOGGING==false) return;

			ANNE._errors_to_send.push({
				message:$message, 
				source:$source, 
				lineno:$lineno, 
				colono:$colno, 
				error:$error
			});
        };
    }


    /**
    */
    tryNextTrustedAnnode=async()=> {
        var annodes = this._annodesLS.annodes;
        this._disconnected.push(this._annodesLS.last_uri);
        for(var a=0; a < annodes.length; a++) {
            var annode = annodes[a];
            if (this._disconnected.indexOf(annode.uri)!=-1) continue;
            this._annodesLS.last_uri=annode.uri;
            localStorage.setItem("ANNODES", JSON.stringify(this._annodesLS));
            return true;
        }

        return false;
    }


    /**
     * Set annode by URI
     * during bootup we extract our login LS info and set the annode to the 
     * last anndoe we were using.
     * @param {*} $uri 
     */
    setAnnodeByURI = function($uri="") {
        if ($uri=="") $uri=window.origin;
        this._annodesLS.last_uri = $uri;
        for (var a=0; a < this._annodesLS.annodes.length; a++) {
            var annode = this._annodesLS.annodes[a];
            if (annode.uri==$uri) {
                this._annodesLS.last_nid=annode.nid;
                this._annodeBlockexplorer = $uri+"/blockexploer/blocks.html"
                return $uri;
            }
        }

        //we have a problem!  missing annode in annodes.  LS annodes obj could have been deleted.
        var newAnnode = {nid:"", nickname:"unk", uri:$uri, pubkey:""};
        this._annodesLS.annodes.push(newAnnode);
        this._annodesLS.last_nid = "";
        this._annodeBlockexplorer =  $uri+"/blockexploer/blocks.html";
        localStorage.setItem("ANNODES", JSON.stringify(this._annodesLS));
        return $uri;
    }

    
    /**
     * 
     */
    extractURLVars = function() {
        const urlParams = new URLSearchParams(window.location.search);
        this.loadVars = {};
        this.loadVars.userfrenly = "";

        var page = urlParams.get('page');
        if (page!=null && page!=undefined) {
            this.loadVars.page = page;
            urlParams.delete('page');
            this.loadVars.userfrenly = page;
        }

        var nid = urlParams.get('nid');
        if (nid!=null && nid!=undefined) {
            this.loadVars.nid = nid;
            urlParams.delete('nid');
            
            //if nid provided, we default to dossier page.
            if (this.loadVars.page==undefined) {
                this.loadVars.page="dossier";
                this.loadVars.userfrenly +="dossier nid="+nid;;
            }

            else this.loadVars.userfrenly += " nid="+nid;
        }

        this.loadVars.userfrenly.trim();
        
        let newURL = window.location.origin + window.location.pathname;
        console.log(newURL);
        history.replaceState(null, '', newURL);
    }
   


    /**
     * Get miner fee by the to type.
     * 
     * ANNE discourages blob and text use by charging more for non-conceptual
     * and text-based data types.   CODIFY IT!  ENCODE IT!   TURN IT INTO A NEURON!
     * REUSE IT!  .. and in the future.. all text, including paragraphs, will
     * be parsed, conceptualized and stored in neurons/relons.
     * 
     * I've done it before -- so I know what it takes to do such things.
     * ANNE can do such things.
     * 
     * @author {Mr.Scatman} 
     */
    getMinerFeeByToType = function($to_type) { 
        var fee= ANNE.fees.relon[$to_type]; 
        if (fee==undefined) console.log("to type not handled:: "+$to_type);
        return fee;
    }


    nodeConnected = function($connected){
        console.log("node connect "+$connected);
    }


    /**
     * init all the ANNE objects used in this ext
     */
    pre_boot_setvars=async()=> {

        //console.log("(ANNE.pre_boot)");
        if (typeof A != "undefined") ANNE.A = A;
        if (typeof A2A != "undefined") ANNE.A2A = A2A;
        if (typeof AFILES != "undefined") ANNE.AFILES = AFILES;
        if (typeof ACCOUNTS != "undefined") ANNE.ACCOUNTS = ACCOUNTS;
        if (typeof ACE!="undefined") ANNE.ACE=ACE;
        if (typeof ACHAT != "undefined") ANNE.ACHAT = ACHAT;
        if (typeof ANNDLE != "undefined") ANNE.ANNDLE = ANNDLE;
        
        if (typeof ANNEID != "undefined") {
            ANNE.ANNEID = ANNEID;
        }

        if (typeof ANNEX != "undefined") ANNE.ANNEX = ANNEX;

        //default the api to use the uri and port that this app is being used on.
        //if the user has specified otherwise, we will override this default with their preference (chosen) annode
        if (typeof ANNODE_API != "undefined") {
            const origin = window.origin;
            const ANNE_API = new ANNODE_API (origin);     
            ANNE.API = ANNE_API;
            ANNE.API.setNodeConnectedCallback = this.nodeConnected;
        }

        if (typeof AQL != "undefined") ANNE.AQL = AQL;

        if (typeof IDB != "undefined") ANNE.IDB = IDB;

        if (typeof ANNTH != "undefined") ANNE.ANNTH = ANNTH;
        if (typeof ANNODE != "undefined") ANNE.ANNODE = ANNODE;
        if (typeof AWARE != "undefined") ANNE.AWARE = AWARE;
        
        if (typeof BRAIN != "undefined") {
            ANNE.BRAIN = BRAIN;
        }

        //init this via the MEM_UDF extended if it is wanted.
        if (typeof CHAIN != "undefined") ANNE.CHAIN = CHAIN;
        if (typeof CHASE != "undefined") ANNE.CHASE = CHASE;
        if (typeof CLUMPS != "undefined") ANNE.CLUMPS = CLUMPS;
        if (typeof CTP != "undefined") ANNE.CTP = CTP;
        if (typeof DB_local != "undefined") ANNE.DB_local = DB_local;


        if (typeof EXT_BTNS != "undefined") ANNE.EXT_BTNS = EXT_BTNS;
        if (typeof GHOSTDATA != "undefined") {
            ANNE.GHOSTDATA = GHOSTDATA;
        }
        if (typeof GUI_STUFF != "undefined") ANNE.GUI_STUFF = GUI_STUFF;
        if (typeof GRAPH_E != "undefined") ANNE.GRAPH_E = GRAPH_E;
        
        if (gsap!=null) ANNE.gsap = gsap;

        if (typeof HANAI != "undefined") ANNE.HANAI = HANAI;
        if (typeof HISTORY != "undefined") ANNE.HISTORY = HISTORY;
        if (typeof HISTORY_LOCAL != "undefined") ANNE.HISTORY_LOCAL = HISTORY_LOCAL;
        if (typeof IMAGES != "undefined") ANNE.IMAGES = IMAGES;
        if (typeof LNOTS != "undefined") ANNE.LNOTS = LNOTS;
        if (typeof LOCALONLYDATA != "undefined") ANNE.LOCALONLYDATA = LOCALONLYDATA;
        if (typeof LOGIN_SOLO != "undefined") ANNE.LOGIN_SOLO=LOGIN_SOLO;
        if (typeof MEM_UDF != "undefined") ANNE.MEM_UDF = MEM_UDF;
        if (typeof MSGS != "undefined") ANNE.MSGS = MSGS;
        if (typeof NET != "undefined") ANNE.NET = NET;
        if (typeof NN != "undefined") ANNE.NN = NN;
        if (typeof PAGES != "undefined") ANNE.PAGES = PAGES;
        if (typeof RECEIVE_FUNDS != "undefined") ANNE.RECEIVE_FUNDS = RECEIVE_FUNDS;
        if (typeof RELONTBL != "undefined") ANNE.RELONTBL = RELONTBL;
        if (typeof SEARCH != "undefined") ANNE.SEARCH = SEARCH;
        if (typeof SETTINGS != "undefined") ANNE.SETTINGS = SETTINGS;
        
        //TODO: extract the few things we want/need from here and don't include the entire
        //libs in the js.  They do things we actually don't want as it will be-breaking (generating errors)..
        //The tech is not compatible at this pt (by design).
        //if (typeof sig$ != "undefined") ANNE.SIGNA.sig = {Address:sig$.Address};    
        //if (typeof sig$crypto != "undefined") ANNE.SIGNA.crypto = sig$crypto;
        
        if (typeof sig$ != "undefined") ANNE.SIGNA.sig = sig$;
        if (typeof sig$crypto != "undefined") ANNE.SIGNA.crypto = sig$crypto;
        if (typeof sig$http != "undefined") ANNE.SIGNA.http = sig$http;
        if (typeof sig$util != "undefined") ANNE.SIGNA.util = sig$util;
    
        if (typeof SENDER != "undefined") ANNE.SENDER = SENDER;
        
        if (typeof SENDQ != "undefined") ANNE.SENDQ = SENDQ;
        if (typeof SEND_FUNDS != "undefined") ANNE.SEND_FUNDS = SEND_FUNDS;
        
        if (typeof SS != "undefined") {
            ANNE.SS = SS; //search settings. should go in SEARCH.
            if (ANNE.SEARCH!=null) ANNE.SEARCH.init(ANNE.SS);
        }
        if (typeof TALK != "undefined") ANNE.TALK = TALK;
        if (typeof TXB != "undefined") ANNE.TXB = TXB;
        if (typeof UNIT_TESTS != "undefined") ANNE.UNIT_TESTS = UNIT_TESTS;
        if (typeof UNLOCK != "undefined") ANNE.UNLOCK = UNLOCK;
        if (typeof USER!= "undefined") ANNE.USER = USER;
        if (typeof UTILS!= "undefined") ANNE.UTILS = UTILS;
        if (typeof u3js!= "undefined") ANNE.u3js = u3js;
        

        if (typeof MEM != "undefined") {
            ANNE.MEM = MEM;
            if (ANNE.BRAIN!=null) ANNE.BRAIN.setMem(MEM);
        }

        if (typeof WIKIDATA!= "undefined") ANNE.WIKIDATA = WIKIDATA;
        
        ANNE.other = {};
        ANNE.other.qrcode = null;
        if (typeof qrcode != "undefined") ANNE.other.qrcode = qrcode;
    
        ANNE.other.sha256 = null;
        if (ANNE.SIGNA.crypto!=null && typeof ANNE.SIGNA.crypto.hashSHA256 != "undefined") {
            ANNE.other.sha256 = ANNE.SIGNA.crypto.hashSHA256;
        }

        if (!('indexedDB' in window)) {
            if (ANNE.SETTINGS.debug()==true) console.log('This browser does not support IndexedDB');
            ANNE.DB.bSUPPORTED=false;
            ANNE.DB=null;
        }
        else {	
            if (ANNE.SETTINGS && ANNE.SETTINGS.debug()==true) console.log("this browser supports IndexedDB");
            ANNE.DB.bSUPPORTED=true;
        }


		
        //must know the network we are on!
        this._annodeDetails = await ANNE.API.annodeDetails();
		
        return;
    }

    
    /**
     * Bootup ANNE memory.
     *
     * @author {Mr.Scatman} 
     */
     mem_boot_up = async($bootupCompleteCallback=null)=> {
        await ANNE.MEM.boot_up(ANNE, $bootupCompleteCallback);  
    }

    
    /**
     * Master TX Success Processor.
     * 
     * We want to do this for EVERY successful TX send.                    
     * We also want to do anything "more" for EVERY successful TX sned by   
     * calling the MEM_UDF version.  If it doesn't exist, only call the     
     * callback.  If it does exist we can call the final callback there.
     *    
     * @author {Mr.Scatman} 
     * 
     */
     ___masterTXSuccessProcessor=async($rez, $callback=null)=> {
        
        this.__DO_NOT_INTERRUPT = false;    //make sure this is no longer on.

        await GHOSTDATA.deleteTempOnlys();

        var aRelons_new = [];
        var nuke_ghost_txids = [];
        var delete_ghost_tbl_relon_txids = [];
        var txids = [];
        var znidMap = {};
        if ($rez.seed!=undefined) delete $rez.seed;

        var bREFRESHNEEDED = false;

        var awarez_tos = [];
        var awarez_tos_map = [];

        for (var c=0; c <$rez.relons.length; c++) {
            var rObj = $rez.relons[c];

            if (rObj.type!=TYPE_AWARENESS && rObj.type!=TYPE_SYS_MSG && rObj.type!=TYPE_SYS) {
                bREFRESHNEEDED=true;
            }

            //gather our relons for a smart update of aplex_sum so the screen can refresh
            //without taxing the annode just to get data we know exists because we just submit it.
            if (rObj.type==TYPE_AWARENESS) {
                if (awarez_tos_map[rObj.to_s]==undefined) {
                    var awobj = {relons:[rObj], toNOBJ:this.MEMG.getNeuronByNid(rObj.to_s)};
                    awarez_tos.push(awobj);
                    awarez_tos_map[rObj.to_s]=awobj;
                }
                else {
                    awarez_tos_map[rObj.to_s].relons.push(rObj);
                }
            }
            
            if (rObj.gui_extras!=undefined) delete rObj.gui_extras;

            if (rObj.warning!=undefined) delete rObj.warning;

            //frienly nickname update in the wallet if it isn't set..
            if (rObj.f==USER._userNObj.temp_nid && rObj.type==TYPE_BE && rObj.r==MEM.name.temp_nid) {
                await USER.updateLSNickname(USER._userNObj);
            }

            var bNUKETXID = false;

            if (rObj.pending_from!=undefined) {
                bNUKETXID = true;
                var oldznid = rObj.pending_from.split("_")[1];
                if ($rez.ghostsToDelete.indexOf(oldznid)==-1) {
                    $rez.ghostsToDelete.push(oldznid);
                    var oldNOBJ = MEMG.getNeuronByNid(oldznid);
                    if (oldNOBJ!=null) {
                        oldNOBJ.new_nid = rObj.from_nid;
                        if ((rObj.text==undefined || rObj.text=="") && oldNOBJ.text.length>0) {
							rObj.text = oldNOBJ.text;
						}
                        if (oldNOBJ.bes.length && rObj.be==undefined) {
                            var beNOBJ = MEMG.getNeuronByTempNid(oldNOBJ.bes[0]);
                            rObj.be = beNOBJ.nid;
                        } 
                    }
                }

                //used to refresh the graph after an update.
                //circuit graph is too complicated to try and update piecemeal or selectively.
                //for now, just refresh the whole thing to get new nObjs and the right colorizations.
                if (oldznid!=undefined && znidMap[ oldznid ] ==undefined) {
                    znidMap[oldznid] = rObj.from_nid;
                    var _nOBJ = MEMG.getOrMakeIfNew(rObj.from_nid);
                    if (rObj.be!=null && _nOBJ.bes.length==0) {
                        var BENOBJ = MEMG.getNeuronByNid(rObj.be);
                        if (BENOBJ) _nOBJ.setBeTempNid(BENOBJ.temp_nid);
                        else {

                        }
                    }
                    if (ANNE.SETTINGS.debug()==true) console.log(rObj);
                }
                delete rObj.pending_from;
            }
            
            if (rObj.pending_reln!=undefined) {
                bNUKETXID = true;
                var oldznid = rObj.pending_reln.split("_")[1];
                if ($rez.ghostsToDelete.indexOf(oldznid)==-1) {
                    $rez.ghostsToDelete.push(oldznid);
                    var oldNOBJ = MEMG.getNeuronByNid(oldznid);
                    if (oldNOBJ!=null) {
                        oldNOBJ.new_nid = rObj.pending_reln;
                        if ((rObj.text==undefined || rObj.text=="") && oldNOBJ.text.length>0) {
							rObj.text = oldNOBJ.text;
						}
                        if (oldNOBJ.bes.length && rObj.be==undefined) {
                            var beNOBJ = MEMG.getNeuronByTempNid(oldNOBJ.bes[0]);
                            rObj.be = beNOBJ.nid;
                        } 
                    }
                }
                delete rObj.pending_reln;
            }
            if (rObj.pending_to_s!=undefined) {
                bNUKETXID = true;
                var oldznid = rObj.pending_to_s.split("_")[1];
                if ($rez.ghostsToDelete.indexOf(oldznid)==-1) {
                    $rez.ghostsToDelete.push(oldznid);
                    var oldNOBJ = MEMG.getNeuronByNid(oldznid);
                    if (oldNOBJ!=null) {
                        oldNOBJ.new_nid = rObj.to_s;
                        if ((rObj.text==undefined || rObj.text=="") && oldNOBJ.text.length>0) {
							rObj.text = oldNOBJ.text;
						}
                        if (oldNOBJ.bes.length && rObj.be==undefined) {
                            var beNOBJ = MEMG.getNeuronByTempNid(oldNOBJ.bes[0]);
                            rObj.be = beNOBJ.nid;
                        } 
                    }
                }
                
                if (znidMap[ oldznid ] ==undefined) {
                    //what class was this new object??  It would be solid to set the parent here
                    znidMap[oldznid]=rObj.to_s;
                    console.log(rObj);
                }

                delete rObj.pending_to_s;
            }
            if (rObj.msg!=undefined) delete rObj.msg;

            //if this was a local ghost, unghost it, (make sure to update ghost db)
            if (rObj.old_txid!=undefined) {
                if (rObj.ghost_owner) delete rObj.ghost_owner;
                if (rObj.ghost_order) delete rObj.ghost_order; 
 
                rObj.temp = false;  //hash update should have covered this already
                rObj.ghost = false; //hash update should have covered this already

                if (bNUKETXID==true) {
                    nuke_ghost_txids.push(rObj.old_txid);
                }
                else {
                    delete_ghost_tbl_relon_txids.push(rObj.old_txid);
                }

                if ($rez.alreadydones.indexOf(rObj.txid)==-1) {
                    if (txids.indexOf(rObj.txid)==-1) {
                        rObj.bMUSTINSERT=true;
                        rObj.force_update=true;
                        txids.push(rObj.txid);
                        aRelons_new.push(rObj);     //did we already do this in the TXB?
                    }
                }
            }

            else {
                if ($rez.alreadydones.indexOf(rObj.txid)==-1) {
                    if (txids.indexOf(rObj.txid)==-1) {
                        rObj.bMUSTINSERT=true;
                        rObj.force_update=true;
                        txids.push(rObj.txid);
                        aRelons_new.push(rObj);     //did we already do this in the TXB?
                    }
                }
            }

            delete rObj.pending_from_debug;
            delete rObj.gui_extras;
            
            //this should be picked up in the mem processor (a .freeze change)
            //challenge:  ALL THE OUTS (in the db and mem) need to update their freeze ptr.
            //drag those in to the array here and reprocess.
            //NOTE, we may consider this as well for other indexed neuron fields. 
            //(owned by, sponsored by, ntype etc)
            if (rObj.reln==MEM.CMD_FREEZE.nid) {
                var fromNOBJ = MEMG.getNeuronByNid(rObj.from_nid);
                fromNOBJ.freeze = rObj.to_s;    //why to_s here and not 1?
                rObj.freeze = rObj.to_s;        //why to_s here and not 1?
                for (var o=0; o < fromNOBJ.outs.length; o++) {
                    var orel = fromNOBJ.outs[o];
                    if (txids.indexOf(orel.txid)!=-1) {
                        orel.freeze = 1;
                        continue;
                    }
                    orel.freeze = rObj.to_s;    //why to_s here and not 1?    
                    
                    if ($rez.alreadydones.indexOf(rObj.txid)==-1) {
                        if (txids.indexOf(rObj.txid)==-1) {
                            rObj.bMUSTINSERT=true;
                            rObj.force_update=true;
                            txids.push(rObj.txid);
                            aRelons_new.push(rObj);     //did we already do this in the TXB?
                        }
                    }
                    txids.push(rObj.txid);
                }
            }
        }

                
        //znids that were updated to real nids.. 
        //must destroy the old neuron entirely.
        if ($rez.ghostsToDelete.length) {
            await this.GHOSTDATA.deleteZNIDS($rez.ghostsToDelete);
        }

        //these are temp rels that were ghosts so they persist in DB until the user submitted something.
        //they are no longer needed (and were skipped on the GHOST send.. since the annode creates them)
        //they were helpful when the neuron was a ghost but now we join them up w/ the other goodies in the 
        //nuke_ghost_txids array so we can nuke the out.
        if ($rez.auxGhostRelsToDelete.length) {
            for (var d=0; d <$rez.auxGhostRelsToDelete.length; d++) {
                if (delete_ghost_tbl_relon_txids.indexOf($rez.auxGhostRelsToDelete[d])==-1) {
                    delete_ghost_tbl_relon_txids.push($rez.auxGhostRelsToDelete[d]);
                }
            }
        }

        //handle the ghosts (delete them)
        //they are no longer ghosts anymore
        //the znids may not capture these if they are solo ghosts on a known neurons
        //and not a ghost neuron that was updated (thus is in the ghosttoDelete via the znid_was)
        if (nuke_ghost_txids.length || delete_ghost_tbl_relon_txids.length) {
            //need to nuke the txids from their .out/.in arrays.
            //we will replace these with our processing of aRelons_new.
            //The circuit display will redo these values.
            if (ANNE.DB_local!=null) {
                if (nuke_ghost_txids.length) {
                    await this.GHOSTDATA.deleteGhostTxidsFull(nuke_ghost_txids);
                }

                //let's go full delete here. no reason to not clean up RAM.
                if (delete_ghost_tbl_relon_txids) { 
                    await this.GHOSTDATA.deleteGhostTxidsFull(delete_ghost_tbl_relon_txids);
                }    
            }
        }

        //process our new relons through the proper memory processor.
        //insert any new relons into DB local relons mem
        //we already updated oldtxid to new so we didn't have to lose our relon objects
        //in the .ins/.outs arrays.
        if (aRelons_new.length) {
            console.warn("MARK IN THE SAND, DO WE HAVE INSERT ERRORS YET?");
            console.log(" about to process aRelons_new.length "+aRelons_new.length);
            await ANNE.MEMP.processNeuronsFromRelons(aRelons_new, false, true, "relons", "mastTXSuccessProcessor");
            console.warn("END MARK");
        }

        if (awarez_tos.length) {
            for (var at=0; at < awarez_tos.length; at++) {
                var awareto = awarez_tos[at];
                var toNOBJ = awareto.toNOBJ;
                if (toNOBJ._aplex_sum!=undefined && toNOBJ._aplex_sum!=null) {
                    toNOBJ._aplex_sum.updateFromLiveSend(awareto.relons);
                }
            }
        }

        //we need to refresh our circuts on screen.
        //we redo all the circuits in MEM on any update.

        //WE NEED TO RELOOK AT WHEN WE HAVE TO ACTUALLY DO THIS.
        //IT IS OVERKILL IF NOTHING WAS CHANGED THAT AFFECTS THE DISPLAYED TGENS
        //If only a ghost relon to real relon type of update, we should be able to get that in the gui
        //when the tgen opens/closes.  Try to minimize this refresh drama...
        //We do want to keep the 3js present because the user will be flipping back n forth to administrate,
        //create, search, build, etc.. and won't want to constantly have to keep reloading it.

        //NOTE This is sloppy.  We should handle this within the ACE return callbacks, not here in the global ANNE object.
        if (ANNE.ACE!=null && bREFRESHNEEDED==true && Object.keys(znidMap).length>0) {
            ANNE.ACE.setRefreshers(znidMap);
        }
         
        //$callback can be async or not, it doesn't matter here as this is the 
        //end of this thread (see SENDQ.sendSuccess).
        await ANNE.UTILS.sleep(500);
        if ($callback !=null) $callback($rez.relons, znidMap);
        return;
    }


    /** 
     * @author {Mr.Scatman}
     */
     toggleBrain = async($temp_nid)=> {
        //alert("toggle brain! "+$temp_nid);
        var nObj = MEMG.getNeuronByTempNid($temp_nid);
        if (nObj==null) return;

        if (nObj.rememberz!=undefined) {
            ANNE.turnOffBrains(nObj);

            //if rememberz is a ghost, just delete it.
            //else, make arbor prune.
            await USER._userNObj._makeArborPrune(nObj.rememberz.txid);     //should auto submit que here.
            nObj.rememberz = null;
        }
        else {
            var relon = MEM.makeTempRelon(USER._userNObj, TYPE_AWARENESS, MEM.rememberz.nid, TO_TYPE_ANNE, nObj.nid, true);
            MEMZ.ez_setNARRPtrsForNew(relon);   
            await GHOSTDATA.localGhostTheRelons([relon]);
            nObj.rememberz = relon; 
            ANNE.turnOnBrains(nObj); 
        }
    }


    /** 
     * @author {Mr.Scatman}
     */
    turnOffBrains = function($nObj) {
        var els = document.querySelectorAll(".smart_"+$nObj.temp_nid);
        for (var e=0; e < els.length; e++) {
            ANNE.A.addRemoveClassIf(els[e], "brain-off", "brain-on");
            ANNE.A.setAttribute("title", "rememberz this neuron");
        }
    }


    /** 
     * @author {Mr.Scatman}
     */
    turnOnBrains=function($nObj) {
        var els = document.querySelectorAll(".smart_"+$nObj.temp_nid);
        for (var e=0; e < els.length; e++) {
            ANNE.A.addRemoveClassIf(els[e], "brain-on", "brain-off");
            ANNE.A.setAttribute("title", "forgetz this neuron");
        }
    }

    

    /**
     * We've deleted a nid.  use the tnid and .smart_tnid class to delete all gui occurances.
     */
    removeSmartTnid = function ($temp_nid) {
        var els = document.querySelectorAll(".smart_"+$temp_nid);
        for (var e=0; e < els.length; e++) {
            els[e].parentNode.removeChild(els[e]);
        }
    }


    /**
     * Delete a relon.
     */
    _deleteRelon=async($e)=>{
        var target = $e.target;
        if (target==null) return;
        var txid = target.getAttribute("txid");
        if (txid==undefined || txid==null) {
            var safety=10;
            while(target.parentNode!=null) {
                target = target.parentNode;
                safety--;
                txid = target.getAttribute("txid");
                if (txid!==undefined && txid!=null && txid.length) break;
                if (safety<=0) break;
            }
            if (txid==undefined || txid==null) return;
        }

        var relon = MEMG.lookupByTXID(txid);
        if (relon==null) {
            alert("(deleteRelon) "+txid+" doesn't exist");
            return;
        }

        //spans/divs are set with class .removeable if they have a delete relon button in
        //them.  This denotes the el we want to remove if the operation proceeds and succeeds.
        var parentEl = ANNE.A.getFirstParentOf(target, "removeable", true);

        //some helpful cleanup.
        if (this.MEM.isRoleR(relon.r)==true) {
            var fromNOBJ = MEMG.getNeuronByTempNid(relon.f);
            var relNOBJ = MEMG.getNeuronByTempNid(relon.r);
            fromNOBJ.removeRole(relNOBJ.text, relon);
        }

        if (relon.temp==true || relon.ghost==true) {            
            if (parentEl!=null) ANNE.A.removeSelf(parentEl);
            var annihilated_txids = [];
            MEMP.annihilateRelon_RAM(relon, annihilated_txids);                       //remove from ram..
            if (annihilated.length) {
                await DB_local.___delete(annihilated_txids, "ghost_relons");          //remove from ghost db..
            }
        }
        else {
            await ANNE.arborPruneRelonConfirm(relon, parentEl);
        }

    }

    
    /**   
     * 
     * THIS DOESN"T APPEAR TO BE IMPLEMENTED/FINISHED
     * 
     * 
     * Delete a relon with confirm.  
     * 
     * This is a real relon and requires an arbor prune relon in order to delete it.
     * 
     * TO DO -- 
     * 
     * NOTE: we only need to do the speed bump if this is a real relon.
     *         
     * @author {Mr.Scatman} 
     * 
     */
     arborPruneRelonConfirm = async($rObj, $removeEl=null)=> {
        var msg = "";
        var p3 = null;
        var bMINE = false;
        var actionNid = 0;

        //lookup the relon. This should NOT be needed
        //at this point tho
        if ($rObj==null) console.log("to do, lookup relon");
        if ($rObj.from_nid==USER.public_nid) bMINE = true;  
        else  bMINE = USER.isUsOrOwnedByUs($rObj.f);

        //check the fromNOBJ;
        var fromNOBJ = MEMG.getNeuronByTempNid($rObj.f);
        if (fromNOBJ.emulated==true) {
            alert("This is an emulated neuron.  The app shouldn't have let you try to delete this.  Sorry!");
            return;
        }

        //doinig arbor prune (nuke)
        if (bMINE==true) {
            msg = "Do arbor prune to destroy this edge from ANNE.";
            p3 =  ANNE.A.ezIcoSpan("", "", 'ai-info-circle', "An arbor prune will result in complete deletion of the relon"); 
            actionNid = MEM.arbor_prune.nid;
        }
        //doing inhibit 
        else {
            msg = "Do inhibit relon to block this edge from your worldview.";
            p3 =  ANNE.A.ezIcoSpan("", "", 'ai-info-circle', "An inhibit does not delete the relon, it makes it as if it doesn't exist, for your worldview.");
            actionNid = MEM.inhibit_relon.nid;
        }
        var delete_relons = [];
        var p1 = '<span class="ai-exclamation-triangle ai-2x red-alert"></span>&nbsp;&nbsp;<b>delete</b>&nbsp;'+ANNE.TALK.simpleRelonTags(rObj)+'?';
        var p2 = msg;
        alert(p1);
    }
    


    /**
     * TODO -- fix this for data mode vs live mode.
     * We need the functional block (block of post-LIVE not the block to get the right lunar cycle)
     * @param {*} $block 
     * @returns 
     */
    block_cycle = function($block) {
		return Math.floor($block/ANNE.blocks_time.lunar_cycle);
    }

    
    /**
     * 
     * TODO: UPDATE THIS WITH FINAL LEVELS.
     * ALSO UPDATE IT WITH RESET INFO WHEN RESET OCCURS, ELSE IT WILL BE WRONG.
     * 
     * ANNE data chain block rewards fund the mining reward with the bulk percent.
     * They also fund the Signa TRT fund (2.5%) and the ANNE DEV FUND (starting at 27.5%).
     * The ANNE DEV FUND % diminishes over time (each lunar cycle it decreases by .1%).
     * The MINER's reward increases by that .1% until the ANNE DEV FEE tables at 14.7% of the block 
     * reward.  ANNE DEV FEES are to be used by the ANNE DEV FUND entirely at the ANNE DEV FUND
     * discretion to pay bounties, faucets, marketing, founders, or any other chosen uses.
     * 2.5% of the reward is forever allocated to SIGNA's TRT fund as a "thank you" for allowing 
     * ANNE to use the base SIGNA code and not have to reinvent "blockchain" wheels.
     * 
     * The ultimate goal is to build ANNE CHAIN without the use of VC money or any registered 
     * CORPORATIONS in any jurisdictions.   The intent is for the protocol and platform to remain
     * entirely decentralized running on P2P data annodes.   One can argue the "dev" is centralized.
     * Sure.  That's a fair argument.  Anyone can contribute and help build use-cases and tools.
     * As soon as ANNE releases the DEF FUND will be looking to shell out ANNE coin to get help.
     * 
     * @param {*} $reward 
     * @param {*} $block 
     * @param {*} $fees 
     * @returns {Object}
     */
    reward = function($reward, $block, $fees) {
        var block_reward_lunar_cycle = this.block_cycle($block);
		//147 first lunar cycles the dev fee decreases..
		//the block reward % increases each cycle.
		//stays consistent when it reaches 14.7%.
		var startANNEDF = 275;
		var newANNEDF = 275;
		newANNEDF = startANNEDF - (block_reward_lunar_cycle);
        
		if (newANNEDF < 122) newANNEDF = 122;	//safety check, 12.2 min to ADF w/ 2.5trt = 14.7    
        var ADFP = (newANNEDF/1000);            //anne dev fund percent
        var STRTP = .025;
        var MRP = (1-ADFP)-STRTP;               //mining reward percent
        var mining_reward = $reward * MRP;      //mining reward (in annies)
        var anne_dev_fund = $reward * ADFP;     //anne dev fund (in annies)
        
        return {
                total_reward:$reward, 
                fees:$fees,
                block:$block, 
                anne_dev_fund:anne_dev_fund, 
                mining_reward:mining_reward, 
                ADFP:ADFP,
                MRP:MRP,
                STRTP:STRTP,
                signa_trt_fund:(STRTP*$reward)
            };
    }


    /**
     * @param {*} $rels 
     */
    printRelons = function($rels) {
        ANNE.TALK.printRelons($rels);
    }


    /**
     * We want an instant vote that sends the bounty funds
     * to the to_who_nid.  ONLY a dictatorship can do this and 
     * it will be rejected if any other attempts are made.
     * 
     * It will not work if there is already a pending distro
     * or pending vote.  This is intended for simply bounties where 
     * a single anjucator (dictator) wishes to payout the bounty with no
     * drama, distro, or voting process.
     * @param {*} $nid 
     * @param {*} $to_who_nid 
     */
    instantVoteYes = async($nid, $to_who_nid)=>{
        //NOTE: the annies will be calculatd from the bounty definition of the first NID_ANNIES relon.
        //(subsequent fundings of a bounty will not alter its definition.. only add funds to it)
        //This payout is a CMD to do the payout upon the mining/apply period of this transaction.
        //It is rollback safu.
        var bountyNOBJ = MEMG.getNeuronByNid($nid);
        if (bountyNOBJ==null) return;
        var ghost_rel = await GHOSTDATA.makeGhostRelon(TYPE_SYS_MSG, bountyNOBJ, MEM.CMD_KEYLESS_PAYOUT.nid, TO_TYPE_ANNE, $to_who_nid);
        await SENDQ.addRelonToSendQ(ghost_rel, true, TXB.TXTYPE_CHILD_RELON, ()=>{
            ANNE.PAGES.openNeuronDossierView($nid);
        }); 
    }


    /**
     * Call a vote for distro.
     * MAKES A DITRO NEURON
     * 
     * @param {*} $nid 
     * @param {*} $distro_to_who_nid 
     * @returns 
     */
    callVote = async($nid, $distro_to_who_nid)=>{
        if (ANNE.PAGES==null) {
            console.warn("minimum modules not loaded. PAGES missing.");
            return;
        }
        var nObjDistroFrom = MEMG.getNeuronByNid($nid);
        if (nObjDistroFrom==null) return;

        var toWHO = MEMG.getNeuronByNid($distro_to_who_nid);
        if (toWHO==null) return;

        //check if this neuron is capable of accepting distro votes.
        if(nObjDistroFrom.origin!=ORIGIN_GLOBAL && nObjDistroFrom.origin!=ORIGIN_KEYLESS) {
            console.log("this neuron can't take a distro, must be keyless neuron");
            return;
        }

        if (nObjDistroFrom.ghost==true) {
            console.log("ghosts can't do distro neurons.  Make it real first!");
            return;
        }

        //TO DO:  if no gov is set OR if the gov is set to dictator,
        //we can send simple request.

        //get annies amount of the nObjDistroFrom
        var rel_annies = MEMG.getHasRelon(nObjDistroFrom.outs, MEM.annies.temp_nid);
        if (rel_annies==null) return;
        var annies = rel_annies.to_s;

        var ghostNOBJ = await GHOSTDATA.makeGhostNeuron(MEM.specific_d_vote_by_list, "bounty distro for "+nObjDistroFrom.text, NTYPE_INST);
       
        await GHOSTDATA.makeGhostRelon(TYPE_HAS, ghostNOBJ, MEM.distro_quantity.nid, TO_TYPE_NUMBER, annies);
        await GHOSTDATA.makeGhostRelon(TYPE_HAS, ghostNOBJ, MEM.distro_to_whom.nid, TO_TYPE_ANNE, toWHO.nid);
        await GHOSTDATA.makeGhostRelon(TYPE_HAS, ghostNOBJ, MEM.distro_src.nid, TO_TYPE_ANNE, nObjDistroFrom.nid);
    
        //Convert ghosts to real and send them.
        var ghost_to_anneOBJ = new ghost_to_anne(ghostNOBJ);
        var bSKIPBES=false;
        
        await ghost_to_anneOBJ.update(ghostNOBJ, 0, bSKIPBES, false);

        //save an annoying step to the user -- trigger the vote -- but make sure this
        //is tied with a sysrefid.
        //freeze neuron (must be the last GHOSTNOBJ CMD SENT OTHERWISE THE OTHERS will FAIL.
        //we don't typically do this on ghost upgrades.
        //Typically it is manual and decided by the user when they are ready.
        //Distros cannot have an official annorgdv vote triggered (vote call) until the neuron
        //is frozen so we freeze them auto when we gen them via the gui (to prevent another step).
        //A more advanced gui by other use cases could distribute partial bounties etc.. as they saw fit.
        //They could set amount and all that stuff via their gui.
        var freezeRel = await GHOSTDATA.makeGhostRelon(TYPE_SYS_MSG, ghostNOBJ, MEM.CMD_FREEZE.nid, TO_TYPE_ANNE, ghostNOBJ.nid);
        freezeRel.from_nid = null;
        freezeRel.to_s = null;
        freezeRel.pending_from = "new_"+ghostNOBJ.nid;
        freezeRel.pending_to_s = "new_"+ghostNOBJ.nid;
        freezeRel.pending_from_debug = ghostNOBJ.text;
        freezeRel.pending_to_debug = ghostNOBJ.text;

        var cmdObjFREEZE = await SENDQ.addRelonToSendQ(freezeRel, false, TXB.TXTYPE_CHILD_RELON);
        cmdObjFREEZE.gui_extras = {ref_txid:"txid_"+freezeRel.txid};
        cmdObjFREEZE.PENDING_DATA=true; 
        cmdObjFREEZE.add_special(TXB.CMD_POPULATE_RELON_WITH_VARS);
        cmdObjFREEZE.wtfdavidblane = true;

        //this is a call for a distro vote..
        //idstro vote calls point to the proposed distro neuron (which has details on the potential distribution)
        var triggerRel = await GHOSTDATA.makeGhostRelon(TYPE_SYS_MSG, USER._userNObj, MEM.distro_vote.nid, TO_TYPE_ANNE, ghostNOBJ.nid);
        if (ANNE.SETTINGS.bCONSOLE_DEBUG==true)console.log(triggerRel);

        var cmdObj = await SENDQ.addRelonToSendQ(triggerRel, false, TXB.TXTYPE_ANORG_VOTECALL);
        cmdObj.PENDING_DATA=true; 
        cmdObj.add_special(TXB.CMD_POPULATE_RELON_WITH_VARS);
        ANNE.SENDQ.setPrevAffect(cmdObj);
        triggerRel.pending_sys_ref_txid = "txid_"+freezeRel.txid;
        triggerRel.pending_to_s = "new_"+ghostNOBJ.nid;
        
        ANNE.playSound("success");

        await ANNE.SENDQ.___sendQueue(
            async($obj, $znids)=> {

                var keys = Object.keys($znids);
                if (keys.length) {

                    //go to the first new neuron we had (should be distro unless multiple send, then .. whatever)
                    ANNE.PAGES.openNeuronDossierView(keys[0]);
                }
            }
        );
        return;
    }


    /**
     * check for sound preferences (TO DO, MOVE PREFS TO MEM_UDF NOT GUI_STUFF.)
     */
    playSound = function($sound){
        if (ANNE.SETTINGS!=null && ANNE.SETTINGS.soundOk()==false) return;
        ANNE.A.play($sound);
    }


    /**
     * 
     * @param {*} $num 
     * @returns 
     */
    _validate_block_height_is_future = function($num) {
        var num = parseInt($num);
        if (num < HISTORY._GREATEST_LAST_KNOWN_BLOCK) {
            return {valid:false, msg:"must be greater than the greatest last known block "+HISTORY._GREATEST_LAST_KNOWN_BLOCK};
        }
        else return {valid:true};
    }


    /**
     * ?? app_main? where?
     * @param {*} $bDEFOCUS 
     * @returns 
     */
    smartDefocus = async($bDEFOCUS=true)=> {
        if ($bDEFOCUS==true) {
            var el = ANNE.A.addClass("app_main", "defocus");
            if (el==null) return;
            el.setAttribute("disabled",true);
        }
        else {
            var el = ANNE.A.removeClass("app_main", "defocus");
            if (el==null) return;
            el.removeAttribute("disabled",false);
        }
    }


    /**
     * We are going to use a different annode.
     * update last_nid, uri and update the ANNODES LS object in browser mem.
     * @param {*} $annode_nid 
     */
    setNewAnnodeURI = async($annode_nid, $uri)=> {
        this._annodesLS.last_nid = $annode_nid;
        for (var a=0; a < this._annodesLS.annodes.length; a++) {
            if (this._annodesLS.annodes[a].nid==$annode_nid && this._annodesLS.annodes[a].uri==$uri) {
               this._annodesLS.last_uri = $uri;
               break;
            }
        }  

        //if logged in, this is a switch of annodes and potentially known account in localStorage.
        if (USER._userNObj!=null && USER._userNObj.nid!=0) {
            var LSACCT = await this.USER.getAcctByUri(this._annodesLS.last_uri, USER._userNObj.nid);
            console.log(LSACCT);
            if (LSACCT==null) {

                //this will make another LSACCT for this user/seed/ ready to connect.
                await USER.setUserSeed(USER.seedObj.seed, USER.unlock_pw, USER.pubKey);
            }

            //we already have this acct (used this nid with this annode.. let's refresh the AAUTH)
            else {
                var ok = await USER.refreshAAUTH(USER.seedObj.seed, LSACCT);
            }
            if (ok==true) ANNE.playSound("success");
        }

        localStorage.setItem("ANNODES", JSON.stringify(this._annodesLS));
    }


    /**
     * 
     * @param {*} $el 
     */
    displayURI=function($el) {
        ANNE.A.setHTML($el, ANNE._annodesLS.last_uri);
    }

    
    /**
     * Load the unlocked user's ghosts from the memory pull.
     * Go to the anneid page.
     * 
     * Lock/unlock (even with no change of user) is a way to reset the RAM ptrs
     * and force update of some runtime-helper objects.
     */
    unlocked = async()=>{
        MEM_UDF.unlocked_pre(false, "unlocked");
    }


    /**
     * 
     * @param {*} $nid 
     */
    removeAcctOption = async($nid)=>{
        for (var a=0; a < ANNE._userAccts.length; a++) {
            var acct = ANNE._userAccts[a];
            if (acct.public_nid==$nid) {
                ANNE.A.destroySelf(acct.gui_id);
                ANNE._userAccts.splice(a, 1);
                break;
            }
        }
    }

    
    /**
     * For any given month, day, year, era, get the ANNE EPOCH day for this.
     * We use the ANNE EPOCH number for more efficient querying of date calcs.
     * @param {*} $real_month_int 
     * @param {*} $day 
     * @param {*} $year 
     * @param {*} $era 
     * @returns 
     */
    calcANNE_EPOCH=function($real_month_int, $day, $year, $era="AD") {
        const JAN1YEAR0001AD = 3944619;

        $day = parseInt($day);
        $real_month_int = parseInt($real_month_int);
        
        //4655179
        
        if ($era === "BC") {
            var localEpoch0 = moment({ year: -10800, month: 0, day: 1 });
            var locaThisDate = moment({ year: -$year, month: $real_month_int-1, day: $day });
            console.log(locaThisDate);

            const daysBetween_BC = locaThisDate.diff(localEpoch0, 'days');

            //var locaThisDate = new Date(-$year, $month - 1, $day);
            //var daysBetween_BC = Math.floor((locaThisDate - localEpoch0) / (1000 * 60 * 60 * 24));
            return daysBetween_BC;
        } 
        else {
            var Jan1Year0001AD = new moment({ year: 1, month: 0, day: 1 });
            var locaThisDate = new moment({ year: $year, month: $real_month_int-1, day: $day });
            var daysBetween_AD = locaThisDate.diff(Jan1Year0001AD, 'days');
            return daysBetween_AD + JAN1YEAR0001AD;
        }
    }


    /**
     * 
     * @param {*} $nid 
     * @returns 
     */
    isANNE = function($nid) {
        if (MEM.ANNE_SUPERS.indexOf($nid)==-1) return false;
        return true;
    }

    isLocation = function($nid) {
        var nOBJ = MEMG.getNeuronByNid($nid);
        if (nOBJ==null) return false;
        if (nOBJ.owned_by!=ANNE.ANNE_ACCTID && ANNE.USER!=null && ANNE.USER._userNObj!=null && nOBJ.owned_by!=ANNE.USER._userNObj.nid) return false
        return nOBJ.is(MEM.location);      
    }

    //????????????????????????? this should be lateral be
    isCountry = function($nid) {
        var nOBJ = MEMG.getNeuronByNid($nid);
        if (nOBJ==null) return false;
        if (nOBJ.owned_by!=ANNE.ANNE_ACCTID && ANNE.USER!=null && ANNE.USER._userNObj!=null && nOBJ.owned_by!=ANNE.USER._userNObj.nid) return false
        return nOBJ.is(MEM.country);      
    }


    //????????????????????????? this should be lateral be
    isState = function($nid) {
        var nOBJ = MEMG.getNeuronByNid($nid);
        if (nOBJ==null) return false;
        if (nOBJ.owned_by!=ANNE.ANNE_ACCTID && ANNE.USER!=null && ANNE.USER._userNObj!=null && nOBJ.owned_by!=ANNE.USER._userNObj.nid) return false
        return nOBJ.is(MEM.state);      
    }

	isInteger = function($nid) {
        var nOBJ = MEMG.getNeuronByNid($nid);
        if (nOBJ==null) return false;
        if (nOBJ.owned_by!=ANNE.ANNE_ACCTID && ANNE.USER!=null && ANNE.USER._userNObj!=null && nOBJ.owned_by!=ANNE.USER._userNObj.nid) return false
        return nOBJ.is(MEM.integer);      
    }
	
    //gregorian date, monthyear or daymonth
    isDateAny=function($nid) {
        var nOBJ = MEMG.getNeuronByNid($nid);
        if (nOBJ==null) return false;
        if (nOBJ.owned_by!=ANNE.ANNE_ACCTID && ANNE.USER!=null && ANNE.USER._userNObj!=null && nOBJ.owned_by!=ANNE.USER._userNObj.nid) return false
        if (ANNE.MEM.date_any.indexOf(nOBJ.bes[0])!=-1) return true;
        return false;
    }

    isIdentity = function($nid) {
        var nOBJ = MEMG.getNeuronByNid($nid);
        if (nOBJ==null) return;
        return nOBJ.is(MEM.identity);
    }
    

    makeArborPruneByTXID=async($txid)=>{
        var rel = MEMG.lookupByTXID($txid);
        if (rel==null) return;
        var fromNOBJ = MEMG.getNeuronByTempNid(rel.f);
        if (fromNOBJ==null) return;
        fromNOBJ._makeArborPrune($txid);
    }

    /**
     * Quick and dirty explore.
     * @param {*} $txt 
     * @param {*} $trackerMap 
     * @param {array} $preloaded_extras
     * @returns 
     */
    exploreWiki=async($txt, $trackerMap=null, $preloaded_extras=null, $printf=null)=> {
		if ($txt==null || $txt==undefined) {
			alert("fix this jackass");
			return null;
		}

        var printf = $printf;
        if (printf==null) printf = ANNE.printToConsole;

        var we = new wikipediaExplore($txt, $trackerMap, printf);
        await we.exploreFull($preloaded_extras);        
        return we;
    }


    /**
     * 
     */
    forceChaseWIKIPEDIA=async($nObj, $trackerMap=null)=>{
        const elbtn = ANNE.A.show("btn_wikipedia");
        ANNE.A.hide(elbtn);
        var rel = ANNE.MEMG.getSysRelon($nObj.outs, ANNE.MEM.wikipart.temp_nid);
        var query = "";
        
        if(rel!=null) query = rel.to_s;
        else query = $nObj.text.replaceAll(" ", "_");
        
        ANNE.showSuperBlocker();
        ANNE.A.playSound("processing");

        const THIS = this;

        //person - tested
        if ($nObj.bes[0]==MEM.person.temp_nid) {
            var wiki = new wikipediaMakePerson(query, $nObj, $trackerMap, ANNE.superConsolePrint);
            await wiki.resolveAndGet();
            ANNE.A.stopSound("processing");
            ANNE.hideSuperBlocker();
            if (ANNE.PAGES!=null) {
                ANNE.PAGES.launchNeuron($nObj.nid, "dossier", null, {btn_wikipedia:false});
            }
        }

        else if ($nObj.bes[0]==MEM.service_term.temp_nid) {
            var props = ["service_term"];
            for (var i=1; i <=18; i++) {
                props.push("service_term"+i);
            }

            var targetNOBJ = null;
            await $nObj.processAsClumpNeuron();
            if ($nObj["role_actor"]==undefined) {
                console.warn("we can't do a target search without role_actor");
                return;
            }

            targetNOBJ = ANNE.MEMG.getNeuronByNid($nObj["role_actor"][0].to_s);
            
            var targets = {props:props, only_one:true, actual_nOBJ:$nObj, found:false};

            //we query the ACTOR of the service term...
            //this will set the proper search string to get the info from wikipedia.

            var rel_sys = ANNE.MEMG.getSysRelon(targetNOBJ.outs, ANNE.MEM.wikipart.temp_nid);
            var query = "";
            if (rel_sys!=null) query=rel_sys.to_s;
            else query = targetNOBJ.text;
            
            var wiki = new wikipediaMakePerson(query, targetNOBJ, null, ANNE.superConsolePrint);
            await wiki.resolveAndGet([], targets);

            ANNE.A.stopSound("processing");
            ANNE.hideSuperBlocker();
            
            PAGES.launchNeuron($nObj.nid, "dossier", null, {btn_wikipedia:false});
        }

        //company - untested/building
        else if ($nObj.bes[0]==MEM.company.temp_nid) {
            var wiki = new wikipediaMakeCompany(query, $nObj,$trackerMap, ANNE.superConsolePrint);
            await wiki.resolveAndGet();
            ANNE.A.stopSound("processing");
            ANNE.hideSuperBlocker();
            PAGES.launchNeuron($nObj.nid, "dossier", null, {btn_wikipedia:false});
        }

        //location - untested/unbuilt
        else if ($nObj.bes[0]==MEM.location.temp_nid) {
            var wiki = new wikipediaMakeLocation(query, $nObj, $trackerMap, ANNE.superConsolePrint);
            var dataObj = await wiki.resolveAndGet();
            

            //hmmm.
            if (dataObj.result_type == "disambig") {
                console.log(dataObj);

                //if a US city in a US state, look for $nObj.text, state in disambig
                //otherwise, look for $nObj.text, country
                var consituentOfNOBJ = $nObj.getConstituentOf();
                if (ANNE.isState(consituentOfNOBJ)==true) {
                    var pagename = WIKIDATA.findPage(dataObj.pages, consituentOfNOBJ.text);
                    if (pagename!=null) {
                        wiki = new wikipediaMakeLocation(pagename, $nObj, $trackerMap, ANNE.superConsolePrint);
                        dataObj = await wiki.resolveAndGet();
                    }
                }
                else if (ANNE.isCountry(consituentOfNOBJ)==true) {
                    var pagename = WIKIDATA.findPage(dataObj.pages, consituentOfNOBJ.text);
                    if (pagename!=null) {
                        wiki = new wikipediaMakeLocation(pagename, $nObj, $trackerMap, ANNE.superConsolePrint);
                        dataObj = await wiki.resolveAndGet();
                    }
                }

                //just do whatever, next-level-constituent.
                //we may consider doing next level constituent AGAIN!
                //ie, someknownplace, somehigherorder local, somehigherorder local
                else {
                    var pagename = WIKIDATA.findPage(dataObj.pages, consituentOfNOBJ.text);
                    if (pagename!=null) {
                        wiki = new wikipediaMakeLocation(pagename, $nObj, $trackerMap, ANNE.superConsolePrint);
                        dataObj = await wiki.resolveAndGet();
                    }
                }
            }
            
            ANNE.A.stopSound("processing");
            ANNE.hideSuperBlocker();
            PAGES.launchNeuron($nObj.nid, "dossier", null, {btn_wikipedia:false});
        }

        //group - untested/unbuilt
        else if ($nObj.bes[0]==MEM.group.temp_nid) {
            var wiki = new wikipediaMakeGroup(query, $nObj, $trackerMap, ANNE.superConsolePrint);
            await wiki.resolveAndGet();
            ANNE.A.stopSound("processing");
            ANNE.hideSuperBlocker();
            PAGES.launchNeuron($nObj.nid, "dossier", null, {btn_wikipedia:false});
        }

        //group event - untested/unbuilt
        else if ($nObj.bes[0]==MEM.group_event.temp_nid) {
            var wiki = new wikipediaMakeGroupEvent(quer,$nObj, $trackerMap, ANNE.superConsolePrint);
            await wiki.resolveAndGet();
            ANNE.A.stopSound("processing");
            ANNE.hideSuperBlocker();
            PAGES.launchNeuron($nObj.nid, "dossier", null, {btn_wikipedia:false});
        }

        //name
        else if ($nObj.bes[0]==MEM.name.temp_nid) {
            var wiki = new wikipediaMakeName(query,$nObj, $trackerMap, ANNE.superConsolePrint);
            await wiki.resolveAndGet();
            ANNE.A.stopSound("processing");
            ANNE.hideSuperBlocker();
            PAGES.launchNeuron($nObj.nid, "dossier", null, {btn_wikipedia:false});
        }

        

        else {
            console.log("??");
        }
        //generic event ?
    }




    testAQL = async()=>{
        //var tests = ["get all jewish politicans"];
        var tests = ["get all people born before 1900"];
        //var tests = ["get all people who died after 2010"];
        //var tests = ["get jews born between 1900 and 2000"];
        //var tests = ["get all judges in america"]
                   
        for (var t=0; t < tests.length; t++) {
            var aql = new anne_query_lang(tests[t]);
            await aql.parseAQL(tests[t]);
            console.log(aql);
            return;
        }
        return;
    }

	testPhrases = async($index=-1)=> {
		var tests = ["United States Court of Appeals for the District of Columbia Circuit",
					"Associate Justice of the Supreme Court of the United States",
					"Chair of the Equal Employment Opportunity Commission",
					"Assistant Secretary of Education for the Office for Civil Rights",
					"49th Lieutenant Governor of California"];
		for (var t=0; t < tests.length; t++) {
			await ANNE.wikiThemeModPhraseParse(tests[t]);
		}
	}

	//this is intended to parse a single phrase as a THEME and MOD.
	//it is used for wikipedia titles, service neurons, etc.
	wikiThemeModPhraseParse = async($text, $links=[])=>{
        var strings = ["United States Court of Appeals", "house of representatives", 
            "senator", "president", "governor", "mayor", "judge", "Associate Justice",
            "lieutenant governor", "member", "associate justice", "supreme court", "Office for Civil Rights",
         "united states of america", "District of Columbia", "Equal Employment Opportunity Commission"];
        
        var arr = [];
        if ($links.length) {
            for (var l=0; l < $links.length; l++) {
                var link = $links[l].data.page;
                arr.push(link);
            }
        }

        //seeding the context pool to help us.
        ANNE.BRAIN.fireStrings(strings.concat(arr));

        var parseOBJ = await ANNE.BRAIN.manuallyStartASOA($text,[], SOA_MODE_CONCEPTUALIZE);
        console.log(parseOBJ);
        var oparts = parseOBJ._nlpP.ph_parts[0].ordered_parts;
        var THEME_THINGS_MODS = [];
        var THEME_THINGS = [];
		if (oparts.length==1) {
			oparts = oparts[0].ordered_parts;
		}
		var real = 0;
        for (var op=0; op < oparts.length; op++) {
            var opart = oparts[op];
			if (opart.isSigPart==true) continue;
			real+=1;
			console.log(opart);
			if (opart.starts_with_sig!=null && opart.starts_with_sig==true) {
	            if (real>1) {
					if (THEME_THINGS_MODS.length) THEME_THINGS_MODS[THEME_THINGS_MODS.length-1]+=" "+opart.l1str.trim();
                    else THEME_THINGS_MODS.push(opart.l1str.trim());
				}
				else THEME_THINGS_MODS.push(opart.l1str_nosignal.trim());
			}
			else {
				if (op==0) THEME_THINGS.push(opart.l1str);
				else {
		            if (real>1) {
						if (THEME_THINGS_MODS.length) THEME_THINGS_MODS[THEME_THINGS_MODS.length-1]+=" "+opart.l1str.trim();
                        else THEME_THINGS_MODS.push(opart.l1str_nosignal.trim());
					}
					else THEME_THINGS_MODS.push(opart.l1str_nosignal.trim());
				}
			}
        }

        if (THEME_THINGS_MODS.length) {
            for (var i=0; i < THEME_THINGS_MODS.length; i++) {
                console.log("[THEME_THING_MOD] "+THEME_THINGS_MODS[i]);
            }
        }
        for (var i=0; i < THEME_THINGS.length; i++) {
            console.log("[THEME_THINGS] "+THEME_THINGS[i]);
        }
        return {mods:THEME_THINGS_MODS, theme:THEME_THINGS};
	}

	
    /**
     * quickly disambig between ambiguious matches using our live context pool 
     * and seeds to help contextualize what is desired.
     * @param {*} $matches 
     * @param {*} $seeds 
     * @param {*} $title 
     * @returns 
     */
    disambig = function($matches, $seeds, $title="dismabig pool") {
        var dp = new simple_disambig_pool($title, ANNE.BRAIN.ctp_light);
        var winnerNOBJ = dp.disambiguate($matches, $seeds);
        console.log("winner: "+winnerNOBJ.printDisambig(true));
        return winnerNOBJ;
    }


    /**
     * lovely mojos.
     */
    testSimpleDisambig = function() {
        var judge1 = MEMG.getOrMakeIfNew("15647303133913074804");
        var judge2 = MEMG.getOrMakeIfNew("11286563740955259900");
        var dp = new simple_disambig_pool("judge disambig test", ANNE.BRAIN.ctp_light);
        var winnerNOBJ = dp.disambiguate([judge1, judge2], [ANNE.MEM.role_actor, ANNE.MEM.name]);
        console.log("winner: "+winnerNOBJ.printDisambig(true));
        var dp = new simple_disambig_pool("judge disambig test2", ANNE.BRAIN.ctp_light);
        var winnerNOBJ = dp.disambiguate([judge1, judge2], [ANNE.MEM.role_actor, ANNE.MEM.career, ANNE.MEM.position]);
        console.log("winner: "+winnerNOBJ.printDisambig(true));
    }


    /**
     * 
     * @param {*} $city 
     * @returns 
     */
    getQuickCity=async($city)=> {
        var matches = await ANNE.CHASE.nakedSearch($city, true, true);
        var matches2 = [];
        for (var m=0; m < matches.length; m++) {
            if (matches[m]["be_"+this.MEM.polity.temp_nid]!=undefined) {
                if (this.MEM.city.temp_nid==matches[m]["be_"+this.MEM.polity.temp_nid]) matches2.push(matches[m]);
            }
        }
        return matches2;
    }
    

    getQuickWeight=function($tnid, $factor) {
        if ($tnid==MEM.ec_opposite.temp_nid || $tnid==MEM.__NOTACTIVE.temp_nid) {
            return $factor*-1;
        }
        else if ($tnid==MEM.__throttlemin.temp_nid) {
            return $factor*-.33;  
        }
        else if ($tnid==MEM.__throttlemax.temp_nid) {
            return $factor*-1;
        }
        else if ($tnid==MEM.brain_assoc.temp_nid) {
            return $factor*1.3;
        }
        else if ($tnid==MEM.brain_assoc_strong.temp_nid) {
            return $factor*2.5;
        }
        else return $factor;
    }


    /**
     * Don't let anything be clicked during super blocker mode.
     */
    __superBlockerHandler = function($e) {
        $e.stopPropagation();
        $e.preventDefault();
    }

	
    autoHideConsole = function() {
        ANNE.__DO_NOT_INTERRUPT=false;    
        ANNE.A.hide("superblocker");
        document.removeEventListener('click', this.__superBlockerHandler);
    }


    /**
     * Super block mode - reserved for external data pulls.
     */
    showSuperBlocker = function() {
        if (ANNE.el_superconsole==undefined || ANNE.el_superconsole==null) {
            ANNE.el_superconsole = document.getElementById("SB_console_print");
        }
        if (ANNE.el_superconsole_close==undefined || ANNE.el_superconsole_close==null) {
            ANNE.el_superconsole_close = document.getElementById("console_close_SB");
            ANNE.el_superconsole_close.addEventListener("click", function($e){
                $e.stopPropagation();
                $e.preventDefault();
                ANNE.A.show("msgs_alerts");
                ANNE.A.show("logowithoverlay");
                ANNE.__DO_NOT_INTERRUPT=false;    
				ANNE.A.hide("superblocker");
		        document.removeEventListener('click', this.__superBlockerHandler);

		        //fire up the msgs again, if we had any they can start showing again.
		        //we turned them off while we did the super blocker parse.
		        if (ANNE.MSGS!=null) ANNE.MSGS.showNextMessage();
            })
        } 

        ANNE.A.hide(ANNE.el_superconsole_close);
        ANNE.A.empty(ANNE.el_superconsole);

        ANNE.A.show("superblocker");
        document.addEventListener('click', this.__superBlockerHandler);
        ANNE.A.hide("msgs_alerts");
        ANNE.A.hide("logowithoverlay");
        ANNE.__DO_NOT_INTERRUPT=true;
    }

	
    hideSuperBlocker = function() {
        //when code calls hide, we allow super console X to show.
        //we can have a setting to auto close here (to do, later, I want to see the msgs.)
        ANNE.A.show(ANNE.el_superconsole_close);
		ANNE.el_superconsole_close.style.display="relative";
    }
    superConsolePrintPF = function(...$args) {
        var msg = ANNE.TALK.printf(...$args);
		ANNE.superConsolePrint(msg);
    }
    printToConsole=function($msg) {
        ANNE.superConsolePrint($msg);
    }
    superConsolePrint = function($msg) {
		if ($msg==undefined || $msg==null) {
			console.log("fix this");
			return;
		}

        var pel = document.createElement("p");
		pel.classList.add("SB-pT");
        pel.innerHTML = $msg;

        if (ANNE.el_superconsole==null) {
           ANNE.el_superconsole = document.getElementById("SB_console_print");
        }
        ANNE.el_superconsole.appendChild(pel);
        ANNE.el_superconsole.scrollTop = ANNE.el_superconsole.scrollHeight;
    }


    /**
     * 
     */
    setHackBlockingPats = function() {
        this.block_pats = new Object();
    
        //be person -> has -> constituent (ERROR IN DATA APP)
        //persons do not has any constituents.
        this.addBlockingPat(ANNE.MEM.person, TYPE_HAS, ANNE.MEM.constituent, "group events don't HAS constituents, they have kinfolk");

        //persons can BE constituent_of, not constituent
        this.addBlockingPat(ANNE.MEM.person, TYPE_BE, ANNE.MEM.constituent, "persons don't BE constituents");
        
        //pesons are not HAS participants
        this.addBlockingPat(ANNE.MEM.person, TYPE_HAS, ANNE.MEM.participant, "persons are not HAS participant");
        this.addBlockingPat(ANNE.MEM.person, TYPE_BE, ANNE.MEM.participant, "persons are not BE participants, they are BE participatns of");
        this.addBlockingPat(ANNE.MEM.person, TYPE_HAS, ANNE.MEM.member, "persons are not HAS members");
        this.addBlockingPat(ANNE.MEM.person, TYPE_BE, ANNE.MEM.member, "persons are not BE members, they are BE members of");
        
        //nothing TYPE_HAS member_of
        this.addBlockingPat(null, TYPE_HAS, ANNE.MEM.member_of, "member_of does not go with TYPE_HAS, ever");
        this.addBlockingPat(null, TYPE_HAS, ANNE.MEM.participant_of, "participant_of does not go with TYPE_HAS, ever");
        this.addBlockingPat(null, TYPE_HAS, ANNE.MEM.founder_of, "founder_of does not go with TYPE_HAS, ever");
        this.addBlockingPat(null, TYPE_HAS, ANNE.MEM.corpSponsor_of, "corpSponsor_of does not go with TYPE_HAS, ever");
        this.addBlockingPat(null, TYPE_HAS, ANNE.MEM.subsidary_of, "subsidary_of does not go with TYPE_HAS, ever");
        this.addBlockingPat(null, TYPE_HAS, ANNE.MEM.division_of, "division_of does not go with TYPE_HAS, ever");
        this.addBlockingPat(null, TYPE_HAS, ANNE.MEM.constituent_of, "constituent_of does not go with TYPE_HAS, ever");
  
        this.addBlockingPat(null, TYPE_BE, ANNE.MEM.member, "member does not go with TYPE_BE, ever");
        this.addBlockingPat(null, TYPE_BE, ANNE.MEM.participant, "participant does not go with TYPE_BE, ever");
        this.addBlockingPat(null, TYPE_BE, ANNE.MEM.founder, "founder does not go with TYPE_BE, ever");
        this.addBlockingPat(null, TYPE_BE, ANNE.MEM.corpSponsor, "corpSponsor does not go with TYPE_BE, ever");
        this.addBlockingPat(null, TYPE_BE, ANNE.MEM.subsidary, "subsidary does not go with TYPE_BE, ever");
        this.addBlockingPat(null, TYPE_BE, ANNE.MEM.division, "division does not go with TYPE_BE, ever");
        this.addBlockingPat(null, TYPE_BE, ANNE.MEM.constituent, "constituent does not go with TYPE_BE, ever");
  
        //group event's do not have BE CONSTITUENT of anything.  These are terrible relons.
        this.addBlockingPat(ANNE.MEM.group_event, TYPE_BE, ANNE.MEM.constituent, "group events don't BE constituents, they have participants");
	
        //be group event -> has -> constituent (ERROR IN DATA APP)
        //group events have participants.
        this.addBlockingPat(ANNE.MEM.group_event, TYPE_HAS, ANNE.MEM.constituent_of, "group events don't HAS constituents of, they have participants");
    
        //persons don't has tribal.. his is a BE -- put it in the BE dimension smokey.
        this.addBlockingPat(ANNE.MEM.person, TYPE_HAS, ANNE.MEM.tribal, "persons don't HAS tribal, they BE tribal");
    
        //never put a foundedOn on a person.  lolz.
        this.addBlockingPat(ANNE.MEM.person, TYPE_HAS, ANNE.MEM.foundedOn, "persons don't HAS founded on relns");

        this.addBlockingPat(ANNE.MEM.person, TYPE_HAS, ANNE.MEM.deathday, "persons don't HAS deathday, we store this as TYPE_BE");
        this.addBlockingPat(ANNE.MEM.person, TYPE_HAS, ANNE.MEM.birthday, "persons don't HAS birthday, we store this as TYPE_HAS");
    
        this.addBlockingPat(null, TYPE_HAS, ANNE.MEM.aka, "no neuron has an AKA.  All AKAs are TYPE_BE.");


        this.addBlockingPat(null, TYPE_HAS, ANNE.MEM.wikispooks_respart, "store this in TYPE_SYS dimension.");
        this.addBlockingPat(null, TYPE_HAS, ANNE.MEM.dbpedia_respart, "store this in TYPE_SYS dimension.");
        this.addBlockingPat(null, TYPE_HAS, ANNE.MEM.wikipart, "store this in TYPE_SYS dimension.");
    }



    /**
     * Blocking some annoying mistakes/errors made in external data pulls.
     * @param {*} $beInstFromNOBJ 
     * @param {*} $type 
     * @param {*} $relnNOBJ 
     * @param {*} $msg  
    */
    addBlockingPat=function($beInstFromNOBJ, $type, $relnNOBJ, $msg="") {
        if (this.block_pats[$type]==undefined) {
            this.block_pats[$type]=[{beFROM:$beInstFromNOBJ, reln:$relnNOBJ.nid, msg:$msg}];
        }
        else {
            this.block_pats[$type].push({beFROM:$beInstFromNOBJ, reln:$relnNOBJ.nid, msg:$msg});
        }
    }


    /**
     * 
     * @param {*} $fromNid 
     * @param {*} $type 
     * @param {*} $relnNid 
     * @returns 
     */
    testPatIsOk=function($fromNOBJ, $type, $relnNid) {
        var arr = this.block_pats[$type];
        if (arr==undefined) return {ok:true};

        for (var b=0; b < arr.length; b++) {
            if (arr[b].reln!=$relnNid) continue;
            if (arr[b].beFROM==null) {
                var relnNOBJ = MEMG.getNeuronByNid(arr[b].reln);
                var debug = $fromNOBJ.text+" cannot "+ANNE.TALK.getTypeName($type)+" "+relnNOBJ.text;
                ANNE.consoleError(arr[b].msg+" "+debug);
                return {ok:false, msg:arr[b].msg, debug:debug};
            }
            if (arr[b].beFROM.is($fromNOBJ)==true) {
                var relnNOBJ = MEMG.getNeuronByNid(arr[b].reln);
                var debug = $fromNOBJ.text+" cannot "+ANNE.TALK.getTypeName($type)+" "+relnNOBJ.text;
                ANNE.consoleError(arr[b].msg+" "+debug);
                return {ok:false, msg:arr[b].msg, debug:debug};
            }
        }
        return {ok:true};
    }

    disambigOnRel=function($matches, $reln, $to_s) {
        var still_good = [];
        for (var m=0; m < $matches.length; m++) {
            var match = $matches[m];
            if (match.hasRelon($reln, $to_s)==true) {
                still_good.push(match);
            }
        }
        return still_good;
    }

    disambigOnRels=function($matches, $rels, $to_s) {
        var still_good = [];
        for (var m=0; m < $matches.length; m++) {
            var match = $matches[m];
            var founds = 0;
            for (var r=0; r < $rels.length; r++) {
                if (match.hasRelon($rels[r].reln, $rels[r].to_s)==true) {
                    founds+=1;
                }
                else break;
            }
            if (founds==$rels.length) still_good.push(match);
        }
        return still_good;
    }


    vanityId_cnt = async ($identityKeyHash, $iteratorMin, $match_int=1234, $maxTries=100000, $cnt=1, $bDOFILE=false)=> {
        ANNE.A.show("loading");
        $match_int= $match_int+"";
        var tried = 0;
        var aSeeds = [];
        for (var x=$iteratorMin; x < $iteratorMin+$maxTries; x++) {
            var an = USER.getNewAnneAccount($identityKeyHash+x);
            tried+=1;
            var accountId = an.accountId+"";
            if (accountId.indexOf($match_int)===0) {
                console.warn("**FOUND**");
                console.log(accountId);
                console.log(an);
                $cnt-=1;
                aSeeds.push({
                                "accountId":"'"+accountId+"'", 
                                "SEED":an.seed, 
                                "publicKey":an.publicKey,
                                "agreementPrivateKey":an.agreementPrivateKey,
                                "signPrivateKey":an.signPrivateKey
                        });
            }
            if ($cnt<=0) break;
            if (x%1000==0) console.log("tried "+tried);
        }
        console.log("**not found**");
        if ($bDOFILE==true) {
            var fileTitle = 'keys'; 
            UTILS.exportCSVFile(aSeeds, fileTitle, true); 
        }
        ANNE.A.hide("loading");
        return aSeeds;
    }
}


const ANNE = new anne_master ();


var DOM_loaded = async()=> {
    console.log("** DOM loaded **");
    
    //nuke extensions.
    if (typeof chrome !== 'undefined' && chrome.runtime && typeof chrome.runtime.getAll !== "undefined") {
        chrome.runtime.getAll(function(extensions) {
        for (var i = 0; i < extensions.length; i++) {
            chrome.runtime.setEnable(extensions[i].id, false);
        }
        });
    }

    if (typeof initScriptLoads === "function") {
        await initScriptLoads(scriptsLoadedInDOM, false);
    }
    else scriptsLoadedInDOM();
}

var scriptsLoadedInDOM = async()=> {
    console.log("** scriptsLoadedInDOM **");
    ANNE.pre_boot_setvars();

    var el_loader = document.getElementById("login_loader");
    if (el_loader!=null) el_loader.addEventListener(ANNE.EVENT_LOAD_HYPERGRAPH, ANNE.MEM_UDF.doTheRestPre);

    ANNE.mem_boot_up(anne_bootup_complete);
}

var anne_bootup_complete = async()=> {
    console.log("%c ** anne bootup complete **", ANNE.TALK.bggreen);
    await MEM_UDF.init();

    //do saving of themes and all that stuff later.
    //for now use the space pic
    await MEM_UDF.bootup_complete();

    ANNE.GHOSTDATA.init();
    
    if (ANNE.AQL!=null) ANNE.AQL.init();

    ANNE.setHackBlockingPats();

    //if we have a default user, use it.
    //otherwise create a new user for the user
    //let them set a pin
    MEM_UDF.__login_check();

}




window.addEventListener('load', (event) => {
    console.log("*** WINDOW LOAD ***"); 
    if (typeof DB != "undefined") ANNE.DB = DB;
    DOM_loaded();
});