
class anne_vote {
    constructor ($pgui) {
        this.pgui = $pgui;
        this.ID = this.pgui._guid;
        this.pObj = $pgui.pObj;
        this.nid = this.pObj.p1;
        this.voteNObj = MEMG.getOrMakeIfNew(this.nid);
        this.vote_nid = this.voteNObj.nid;     //the neuron for the vote. (sb=.nid)   
        this.nObj = MEMG.getNeuronByNid(this.vote_nid);
        this.asset_nid = this.pObj.asset_nid;   //the item with the assets in it.

        this.el_title = document.getElementById("vote_anj_title");
        this.el_anj_me_delegate = document.getElementById("vote_anj_me_delegate");
        ANNE.A.hide(this.el_anj_me_delegate);

        this.el_anj_delegate_finalize = document.getElementById("vote_anj_delegate_finalize");
        ANNE.A.hide(this.el_anj_delegate_finalize);

        this.el_anj_details = document.getElementById("vote_anj_details");
        ANNE.A.empty(this.el_anj_details);

        this.el_anjucators = document.getElementById("vote_anjucators");

        this.el_make_delegate_btn = document.getElementById("make_delegate_btn_"+this.ID);
        ANNE.A.hide(this.el_make_delegate_btn);

        this.el_disambig = document.getElementById("ss_delegateDisambig_"+this.ID);
        
        this.vote_resultNOBJ=null;
        this.annies_paid_out=null;
        this.distro_audit_nid=null;
        this.distro_srcNOBJ=null;
        this.votes_to_pass = 10000;
        this.yay = 0;
        this.nay = 0;
        this.abstain = 0;
        this.unvoted= 0;

        this.anjucators = [];
        this.unvoted_anjucators = [];

        this.governanceText = "";
        this.governanceNOBJ = null;
        this.my_role = "observer";  //can be changed to anjucator 
        this.my_vote = "";
        this.quantity_number = 0;
        this.distro_toNOBJS = [];
        this.distro_req_nid = null;
        this.distro_aoe_nObj = null;
        
        this.payoutRelons = [];
        this.payoutTnids = [];
        this.sys_ref_realvote = [];
        this.bPAIDOUT = false;

        //receipts
        this.govReceiptRELONLINK = "";
        this.statusReceiptRELONLINK = "";
        this.myRoleReceiptRELONLINK = "";
        this.quantityReceiptRELONLINK = "";
        this.deadlineReceiptRELONLINK = "";
        this.assetOfExchangeReceiptRELONLINK = "";  

        this._SS_delegate = null;
        this.delgateMyVoteToNOBJ = null;
        this.my_original_vote_rights_txid = null;
        this.my_vote_rights_to_this_txid = null;

        this.validClassTempNids = null;
        this.delegated_relons = [];
        this.via_tracker = [];
        this.bMYVOTINGFORMDONE=false;
    }


    //this is stubborn to get the new data.. have to force refresh here..
    initASYNC = async($pgui, $bFORCEREFRESH=true)=> {
        ANNE.A.show('loading');
        var done = await CHASE.queryForOuts(this.voteNObj, $bFORCEREFRESH, [TYPE_SYS_MSG, TYPE_SYS, TYPE_BE, TYPE_HAS]);  
        ANNE.A.hide('loading');
        if (this.voteNObj.owned_by!=MEM.__ANNE__.nid) {
            alert("bad owned by");
            return;
        }
        if (this.voteNObj.bes[0]!=MEM.distro_vote.temp_nid) {
            alert("bad vote neuron class");
            return;
        }
        this.yay = 0;
        this.nay = 0;
        this.abstain = 0;
        this.unvoted = 0;
        var bDOVTP = false;
        //get all outs for vote_nid and asset_nid
        //populate this page.
        //NID_VOTE_RESULT
        ANNE.TALK.printRelons(this.voteNObj.outs);

        for (var r=0; r < this.voteNObj.outs.length; r++) {
            var relon = this.voteNObj.outs[r];
            if (relon.r==MEM.vote_result.temp_nid) {
                this.vote_resultNOBJ = MEMG.getNeuronByTempNid(relon.t);
                this.statusReceiptRELONLINK = relon.txid;
            }
            else if (relon.r==MEM.distro_req.temp_nid) {
                this.distro_req_nid = relon.to_s;
            }
            else if (relon.r==MEM.CMD_KEYLESS_PAYOUT.temp_nid) { //7771064906243877097
                this.annies_paid_out = relon.annies;
                this.distro_audit_nid = relon.to_s;
            }
            else if (relon.r==MEM.distro_src.temp_nid) {
                this.distro_srcNOBJ = MEMG.getNeuronByTempNid(relon.t);
                EXT_BTNS.makeNeuronLink(this.el_title, this.distro_srcNOBJ.nid, "", "distro vote for&nbsp;");
            }
            else if (relon.r==MEM.anj_votes_to_pass.temp_nid) {
                this.votes_to_pass = relon.to_s;
                bDOVTP = true;
            }

            //we copied this into the vote neuron after we calculated it.
            else if (relon.r==MEM.distro_quantity.temp_nid && relon.to_type==TO_TYPE_NUMBER) {
                this.quantity_number = relon.to_s;
                this.quantityReceiptRELONLINK = relon.txid;
            }

            //a delegated vote.  store the relon.. we will reference this later.
            else if (relon.t==MEM.anj_delegate.temp_nid) {
                this.delegated_relons.push(relon);
            }

            else if (relon.to_type==TO_TYPE_TXID) {
                this.via_tracker[relon.reln]=relon.to_s;
            }
        }


        for (var r=0; r < this.voteNObj.outs.length; r++) {
            console.log("r="+r);
            
            var relon = this.voteNObj.outs[r];
        
            if (relon.to_type==TO_TYPE_ANNE && MEM.vote_relns.indexOf(relon.t)!=-1) {
                var toNOBJ = MEMG.getNeuronByTempNid(relon.t);
                if (relon.reln==USER._userNObj.nid) {
                    this.my_role = "Anjucator";
                    this.myRoleReceiptRELONLINK = relon.txid;
                }
                var adjNOBJ = MEMG.getNeuronByTempNid(relon.r);

                //if this was delegated
                var via = this.via_tracker[relon.reln];
                var via_receipt = "";
                if (via!=undefined) {
                    if (relon.sys_ref_txid!=undefined) {
                        via_receipt = "&nbsp;delegated via->"+" txid:"+via;
                        delete this.via_tracker[relon.reln]
                    }
                }

                if (toNOBJ.temp_nid==MEM.anj_vote_yay.temp_nid) {
                    this.yay+=1;
                    this.anjucators.push(relon.reln);
                    if (relon.reln==USER._userNObj.nid) this.my_vote = "yay";
                    var span = ANNE.A.ezSpan(this.el_anjucators, "", "sblock");
                    span.classList.add("vote-yay");
                    EXT_BTNS.makeNeuronLink(span, adjNOBJ.nid);
                    this.makeReceipt(span, "yay", relon.txid);
                    this.sys_ref_realvote.push(relon.sys_ref_txid);
                }
                else if (toNOBJ.temp_nid==MEM.anj_vote_nay.temp_nid) {
                    this.nay+=1;
                    this.anjucators.push(relon.reln);
                    if (relon.reln==USER._userNObj.nid) this.my_vote = "nay";
                    var span = ANNE.A.ezSpan(this.el_anjucators, "", "sblock");
                    span.classList.add("vote-nay");
                    EXT_BTNS.makeNeuronLink(span, adjNOBJ.nid);
                    this.makeReceipt(span, "nay", relon.txid);
                    this.sys_ref_realvote.push(relon.sys_ref_txid);
                }
                else if (toNOBJ.temp_nid==MEM.anj_vote_abstain.temp_nid) {
                    this.abstain+=1;
                    this.anjucators.push(relon.reln);
                    if (relon.reln==USER._userNObj.nid) this.my_vote = "abstain";
                    var span = ANNE.A.ezSpan(this.el_anjucators, "", "sblock");
                    span.classList.add("vote-abstain");
                    EXT_BTNS.makeNeuronLink(span, adjNOBJ.nid);
                    this.makeReceipt(span, "abstain", relon.txid);
                    this.sys_ref_realvote.push(relon.sys_ref_txid);
                }
                else if (toNOBJ.temp_nid==MEM.anj_vote_hasnot.temp_nid) {
                    this.unvoted+=1;
                    this.anjucators.push(relon.reln);
                    this.unvoted_anjucators.push(relon.reln);
                    
                    if (relon.reln==USER._userNObj.nid && this.bMYVOTINGFORMDONE==false) {
                        this.bMYVOTINGFORMDONE=true;    //if we've been delegated more than 1 vote..
                        this.my_role="Anjucator";

                        //the relon on the vote neuron is an annode created relon.
                        //It references the original relon on the source neuron via its sys_ref_txid.
                        //no matter how many votes delegated, those delegated votes ALL VOTE IN LINE with a single
                        //vote of whatever the user votes.  Delgated votes to the same user means their vote 
                        //carries more weight.
                        this.my_original_vote_rights_txid = relon.sys_ref_txid;
                        this.my_vote_rights_to_this_txid = relon.txid;

                        var span = ANNE.A.ezSpan(this.el_anjucators, "", "sblock");
                        span.classList.add("vote-unvoted");
                        EXT_BTNS.makeNeuronLink(span, adjNOBJ.nid);
                    
                        this.makeReceipt(span, "unvoted (this is you)", relon.txid);
                        this.sys_ref_realvote.push(relon.sys_ref_txid);
                        this.my_vote = "unvoted";

                        var el_vote_btns = document.getElementById("vote_btns");
                        ANNE.A.show(el_vote_btns);
                        document.getElementById("btn_vote_yay").addEventListener("click", e=>this.voteYay(e));
                        document.getElementById("btn_vote_nay").addEventListener("click", e=>this.voteNay(e));
                        document.getElementById("btn_vote_abstain").addEventListener("click", e=>this.voteAbstain(e));
                        document.getElementById("btn_vote_delegate").addEventListener("click", e=>this.showVoteDelegate(e));
                    }
                    else {
                        var span = ANNE.A.ezSpan(this.el_anjucators, "", "sblock");;
                        EXT_BTNS.makeNeuronLink(span, adjNOBJ.nid, "", "unvoted");
                        span.classList.add("vote-unvoted");
                    } 
                }       

                //was this voted delegated to this user?  if so, show the txid for proof.
                var delegated_documentation = MEMG.getRelonFromWithRToType(this.voteNObj.outs, TYPE_HAS, relon.r, TO_TYPE_TXID);
                if (delegated_documentation!=null) {
                    var sys_ref_relon = MEMG.lookupByTXID(relon.sys_ref_txid);
                    if (sys_ref_relon && sys_ref_relon.r==MEM.anj_delegate.temp_nid) {
                        this.makeReceipt(span, "delegated from", delegated_documentation.to_s);
                    }
                }
            }
        }

        if (this.distro_req_nid==null) return;
        
        if (this.distro_srcNOBJ!=null) {
            ANNE.A.show('loading');
            var done = await CHASE.queryForOuts(this.distro_srcNOBJ, false, [TYPE_SYS_MSG, TYPE_SYS, TYPE_BE, TYPE_HAS]);  
            ANNE.A.hide('loading');
        }


        for (var g=0; g < this.distro_srcNOBJ.outs.length; g++) {
            var rel = this.distro_srcNOBJ.outs[g];

            if (rel.r==MEM.distro_quantity.temp_nid) {
                this.quantityReceiptRELONLINK = rel.txid;
            }

            //from the neuron paid out to the destination payees.
            else if (rel.r==MEM.CMD_KEYLESS_PAYOUT.temp_nid) {
                this.payoutRelons.push(rel);
                this.payoutTnids.push(rel.t);
            }

            //governance is on the base src neuron and is not copied over to the
            //vote neuron.. since the voters are copied and the total votes needed
            //is copied.. no need to re-document goverance there too.
            //7771671873508876461
            else if (rel.r == MEM.governance.temp_nid) {
                this.governanceNOBJ = MEMG.getNeuronByTempNid(rel.t);
                this.governanceText = this.governanceNOBJ.text;
                this.govReceiptRELONLINK = rel.txid;
            }
        }

        var distroReqNOBJ = MEMG.getNeuronByNid(this.distro_req_nid);
        ANNE.A.show('loading');
        var done = await CHASE.queryForOuts(distroReqNOBJ, false, [TYPE_SYS, TYPE_BE, TYPE_HAS]);  
        ANNE.A.hide('loading');

        var dupes = [];
        
        for (var g=0; g < distroReqNOBJ.outs.length; g++) {
            var rel = distroReqNOBJ.outs[g];
            if (dupes.indexOf(rel.txid)!=-1) continue;
            dupes.push(rel.txid);
            
            if (rel.r == MEM.distro_to_type.temp_nid) {
            }
            else if (rel.r == MEM.AOE.temp_nid) {
                this.assetOfExchangeReceiptRELONLINK = rel.txid;
                this.distro_aoe_nObj = MEMG.getOrMakeIfNew(rel.t);
            }
            else if (rel.r == MEM.distro_deadline.temp_nid) {
                this.deadlineReceiptRELONLINK = rel.txid;
            }
            else if (rel.r == MEM.distro_block_deadline.temp_nid) {
                this.deadlineReceiptRELONLINK = rel.txid;
            }
            else if (rel.r == MEM.distro_to_whom.temp_nid) {
                var towhomNOBJ = MEMG.getOrMakeIfNew(rel.to_s);
                this.distro_toNOBJS.push(towhomNOBJ);
            }
        }

        var voterez = "";
        if (this.vote_resultNOBJ!=null) {
            voterez=this.vote_resultNOBJ.text;
            bDOVTP = false;

        }
        else voterez = "in progress";

        if (this.governanceText=="") {
            if (this.anjucators.length==0) {
                this.governanceText="dicatorship (default)";
                this.governanceNOBJ = MEM.gov_dictatorship;
                if (USER._userNObj.nid==this.nObj.owned_by) {
                    this.my_role="anjucator";
                }
                
            }

            //????  gov should be set if anjucatoro majority
            //but if anjucators set with no gov, the default is anjucator majority.
            else {
                this.governanceText="anjucator majority (default)";
            }
        }
        
        var bobj = await USER.checkBalance(this.distro_srcNOBJ.nid);
        
        var span1 = ANNE.A.ezSpan(this.el_anj_details, "", "sblock");
        //this.makeNeuronLink(span1, distroReqNOBJ.nid, "distribution request");
        EXT_BTNS.makeNeuronLink(span1, distroReqNOBJ.nid, "", "distribution request&nbsp;");
                        
        var el_status = ANNE.A.ezlblSpan(this.el_anj_details, "distribution vote status", "<b class='bg-sharpgreen plr4'>"+voterez+"</b>", "sblock");
        this.makeReceipt(el_status, "", this.statusReceiptRELONLINK);
        
        var msg = "";
        
        if (bDOVTP==true) {
            ANNE.A.ezlblSpan(this.el_anj_details, "total votes needed to pass", "<b class='bg-sharpgreen plr4'>"+this.votes_to_pass+"</b>", "sblock");
        }

        //vote has passed or failed.
        else {
            ANNE.A.empty("vote_btns");
            if (this.vote_resultNOBJ.nid==MEM.vote_passed.nid) {
                el_status.classList.add("vote-passed");
                    
                //vote has passed but has not paid out relons..
                //this means the payout trigger (the last vote to trigger a passed overall vote)
                //has yet to to be mined.
                if (this.payoutRelons.length < this.distro_toNOBJS.length) {
                    ANNE.A.show("loading");
                    for (var s=0; s < this.sys_ref_realvote.length; s++) {
                        var srrv = this.sys_ref_realvote[s];
                        var json = await ANNE.API.getBlockchainTransaction(srrv);
                        console.log(json);
                        if (json.confirmations==undefined) {
                            msg = " (payout waiting for "+srrv+" to confirm.)";
                            break;
                        }
                    }
                    this.bPAIDOUT=false;
                    ANNE.A.hide("loading");
                }
                else this.bPAIDOUT=true;
            }
            else if (this.vote_resultNOBJ.nid==MEM.vote_didnt_pass.nid) {
                el_status.classList.add("vote-didnotpass");
            }
        }

        var sp1 = ANNE.A.ezlblSpan(this.el_anj_details, "governance", "<b>"+this.governanceText+"</b>", "sblock");
        this.makeReceipt(sp1, "", this.govReceiptRELONLINK);
        var sp2 = ANNE.A.ezlblSpan(this.el_anj_details, "my role", "<b class='bg-sharpgreen plr4'>"+this.my_role+"</b>", "sblock");
        this.makeReceipt(sp2, "", this.myRoleReceiptRELONLINK);
        var sp3 = ANNE.A.ezlblSpan(this.el_anj_details, "source neuron", "", "sblock");
        //this.makeNeuronLink(sp3, this.distro_srcNOBJ.nid);
        EXT_BTNS.makeNeuronLink(sp3, this.distro_srcNOBJ.nid);

        var sp4 = ANNE.A.ezlblSpan(this.el_anj_details, "source neuron balance", "", "sblock");
        var annies_bal = ANNE.A.ezAnniesToAnneDisplay(sp4, bobj.annies);
        
        //$el, $val=0, $acparen=true, $bRESET=false
        var sp5 = ANNE.A.ezlblSpan(this.el_anj_details, "distribution quantity", "", "sblock");
        var annies_bal2 = ANNE.A.ezAnniesToAnneDisplay(sp5, this.quantity_number);
        this.makeReceipt(sp5, "", this.quantityReceiptRELONLINK);
 
        //var sp6 = ANNE.A.ezlblSpan(this.el_anj_details, "deadline", "", "sblock");
        
        if (this.deadlineReceiptRELONLINK=="") {
            ANNE.A.ezlblSpan(this.el_anj_details, "deadline", "<b class='bg-sharpgreen plr4'>none</b>", "sblock");
        }
        else {
            var sp7 = ANNE.A.ezlblSpan(this.el_anj_details, "deadline", "", "sblock");
            this.makeReceipt(sp7, "", this.quantityReceiptRELONLINK);
        }
    
        var payout = "will pay";
        if (this.bPAIDOUT==true) payout = "paid out";
        else if (this.distro_toNOBJS.length>1) payout = "will pay"
        if (msg.length>0) payout = "pending pay out";
        var el_payout = ANNE.A.ezlblSpan(this.el_anj_details, payout, "", "sblock");
        for (var d=0; d < this.distro_toNOBJS.length; d++) {
            //this.makeNeuronLink(el_payout, this.distro_toNOBJS[d].nid);
            EXT_BTNS.makeNeuronLink(el_payout, this.distro_toNOBJS[d].nid);
        }
        ANNE.A.ezEl(el_payout, "span", "", msg);
        if (msg.length>0) el_payout.classList.add("payout-pending");
        else if (this.bPAIDOUT==true) el_payout.classList.add("payout-complete");
    }


    refreshAll=async($relon, $ge, $var)=>{
        ANNE.A.empty(this.el_anjucators);
        ANNE.A.empty(this.el_anj_details);
        await this.initASYNC(this.pgui, true);
    }


    //these are not ghosts.. they are temp relons and pushed to the queue immediately.
    voteYay = async($e)=>{
        MEMZ.ez_new_sys_msg(USER._userNObj, MEM.anj_vote_yay.nid, TO_TYPE_ANNE, this.vote_nid, null, this.refreshAll);
        ANNE.playSound("success");
        ANNE.SENDQ.___sendQueue();
    }


    voteNay = async($e)=>{
        MEMZ.ez_new_sys_msg(USER._userNObj, MEM.anj_vote_nay.nid, TO_TYPE_ANNE, this.vote_nid, null, this.refreshAll);
        ANNE.playSound("success");
        ANNE.SENDQ.___sendQueue();
    }

    
    voteAbstain = async($e)=>{
        MEMZ.ez_new_sys_msg(USER._userNObj, MEM.anj_vote_abstain.nid, TO_TYPE_ANNE, this.vote_nid, null, this.refreshAll);
        ANNE.playSound("success");
        ANNE.SENDQ.___sendQueue();
    }


    showVoteDelegate = async($e)=>{ 
        var el_cancel = document.getElementById("dynamic_cancel_"+this.ID);
        ANNE.A.empty(el_cancel);
        ANNE.A.show(el_cancel);
        ANNE.A.ezSquareDelete(el_cancel, async($e)=>{
            ANNE.A.hide(this.el_anj_me_delegate); 
            ANNE.A.hide(this.el_anj_delegate_finalize);
            await this.smartScroll();
        }, [], "36px", "nevermind");

        if (this.my_role=="Anjucator" && this._SS_delegate==null) {
            this.el_make_delegate_btn.addEventListener("click", $e=>this.voteDelegate($e));
            this.validClassTempNids = [];
            var bINSTS = true;
            var bNIDLIST = true;
            var bDOALLBES = false;
            var bINSTSONLY = true;
            MEM.identity.getAllDownlineChildren(this.validClassTempNids, 0, bINSTS, bNIDLIST, bINSTSONLY, true);
            console.warn("valid class temp nids:", this.validClassTempNids);
            UTILS.removeFromTnidsArray(this.validClassTempNids, USER._userNObj.temp_nid);

            var bSMARTSEARCH = true;    //allow smart search to find new users (by name)

            this._SS_delegate = new smart_search('smart_search_delegate_'+this.ID, this.ID, MEM.identity.temp_nid, bSMARTSEARCH, "select an ANNE identity to delegate to");
            this._SS_delegate.init_dd_vals(this.validClassTempNids);
            this._SS_delegate.onValid = this.validMemberSelection;
            this._SS_delegate.onInValid = this.invalidMemberSelection; 
        }
        ANNE.A.show(this.el_anj_me_delegate); 
        await this.smartScroll();
    }

    smartScroll = async()=>{
        ANNE.A.smartScroll("scrollable_"+this.ID, 72);
    }
    

    /**
     * We create a clump that gives away voting rights..
     * We then tie to that clump from the broadcaster (giver of rights)
     * using the delegate vote reln.
     * 
     * delegate vote pattern:
     * clump
     *  ->role_theme_thing -> ('distribution voting rights' inherited from the be class...)ded
     *  ->role_action -> ('delegates' inherited from the be class...) 
     
     *  ->role_actor -> sender (delegator of their rights)
     *  ->role_theme_thing_val -> txid of the voting rights relon
     *  ->role_affected_thing -> who gets the rights to vote
     * 
     *  note: we should also use this value to tie the roles TO the clump..
     * the action verb is most appropriate..ie, scat->delegates->clump123
     */
    voteDelegate = async($e)=>{
        if (this.delgateMyVoteToNOBJ==null) return;
        if (this.my_vote_rights_to_this_txid==null) return;
        
        var ge = new gui_extras(this.pgui, "", this.delegateNeuronMade);
        ge.ref_var="new_"+this.nObj.nid;  //delegate neuron

        //we get role_theme_thing (distro voting rights)
        //we get action_role (delegate)
        ge.znid=this.nObj.nid;
        await CHASE.makeKeylessNeuron(MEM.delegateDistVoteClump, MEM.inst, null, false, ge);  
        
        //we need to provide who from, who to, and WHAT_MOD (the txid of the delegated voting rights)
        var fromwhorelon = {type:TYPE_ROLE, from_nid:null, pending_from:"new_"+this.nObj.nid, reln:MEM.role_actor.nid, to_type:TO_TYPE_ANNE, to_s:USER._userNObj.nid}
        await SENDQ.pendingDynamicVarRelon(fromwhorelon, true, false, false, TXB.TXTYPE_CHILD_RELON, null, false);
    
        var towhorelon = {type:TYPE_ROLE, from_nid:null, pending_from:"new_"+this.nObj.nid, reln:MEM.role_affected_thing.nid, to_type:TO_TYPE_ANNE, to_s:this.delgateMyVoteToNOBJ.nid}
        await SENDQ.pendingDynamicVarRelon(towhorelon, true, false, false, TXB.TXTYPE_CHILD_RELON, null, false);
    
        var themethingmodrelon = {type:TYPE_ROLE, from_nid:null, pending_from:"new_"+this.nObj.nid, reln:MEM.role_theme_thing_mod.nid, to_type:TO_TYPE_TXID, to_s:this.my_vote_rights_to_this_txid}
        await SENDQ.pendingDynamicVarRelon(themethingmodrelon, true, false, false, TXB.TXTYPE_CHILD_RELON, null, false);
    
        //NOTE: WE FREEZE THE DELEGATION CLUMP ON ACTION_DELEGATE TRIGGER.
        //usually we connect to clumps in the TYPE_CLUMP dimension but we don't have to here.
        //we will use this as a trigger to update the vote neuron so we don't have to 
        //have such a burden upon every vote.
        var triggerRelon = {type:TYPE_SYS_MSG, from_nid:USER._userNObj.nid, reln:MEM.action_delegate.nid, to_type:TO_TYPE_ANNE, to_s:null, pending_to_s:"new_"+this.nObj.nid};
        await SENDQ.pendingDynamicVarRelon(triggerRelon, false, false, true, TXB.TXTYPE_SELF_RELON, null, true, this.refreshAll);
    
        ANNE.A.hide(this.el_anj_me_delegate);
        ANNE.A.hide(this.el_anj_delegate_finalize);
        ANNE.A.hide(this.el_disambig);
        ANNE.A.hide(this.el_make_delegate_btn);
        this.delgateMyVoteToNOBJ = null;

        await this.smartScroll();
    }


    /**
     * 
     * @param {*} $relon 
     * @param {*} $ge 
     * @param {*} $var 
     */
    delegateNeuronMade=async($relon, $ge, $var)=> {
        if ($ge!=null && $ge.passthru!=undefined) {
            var arr = [$ge.passthru];
            if ($ge.passthru2!=undefined) arr.push($ge.passthru2);
            await ANNE.MEMP.processNeuronsFromRelons(arr, false, true, "relons", "delegateNeuronMade passthru");
        }
    }


    /**
     */
     invalidMemberSelection = async()=> {
        ANNE.A.hide(this.el_anj_delegate_finalize);
        ANNE.A.hide(this.el_disambig);
        ANNE.A.hide(this.el_make_delegate_btn);
        this.delgateMyVoteToNOBJ = null;
    }



    /**
     * 
     * @param {*} $nObj 
     * @returns 
     */
    validMemberSelection = async($nObj)=> {
        if ($nObj==undefined || $nObj==null || $nObj.nid==USER._userNObj.nid) {
            ANNE.A.hide(this.el_anj_delegate_finalize);
            ANNE.A.hide(this.el_disambig);
            ANNE.A.hide(this.el_make_delegate_btn);
            this.delgateMyVoteToNOBJ = null;
            return;
        }
        if (this.unvoted_anjucators.indexOf($nObj.nid)==-1) {
            ANNE.A.hide(this.el_anj_delegate_finalize);
            ANNE.A.hide(this.el_disambig);
            ANNE.A.hide(this.el_make_delegate_btn);
            this.delgateMyVoteToNOBJ = null;
            return;
        }
        $nObj.disambigHTMLStr(this.el_disambig, true);
        ANNE.A.show(this.el_anj_delegate_finalize);
        ANNE.A.show(this.el_disambig);
        ANNE.A.show(this.el_make_delegate_btn);
        this.delgateMyVoteToNOBJ = $nObj; 
    }


    /**
     * 
     * @param {*} $el 
     * @param {*} $pre 
     * @param {*} $txid 
     * @param {*} $post 
     * @returns 
     */
    makeReceipt = function($el, $pre="", $txid, $post=""){
        var relon = MEMG.lookupRelonByTXID($txid);
        if (relon==null) {
            //try to get this relon???
            return "";
        }
        var ico = GUI_STUFF.getIco("RECEIPT");
        var span = document.createElement("span");
        span.classList="btn-launch vote-relon-launch relon-launch";
        var el = ANNE.A.__getEl($el);
        if (el==null) return;
        el.append(span);
        var img = ico+EXT_BTNS.getRelonLinkIco(relon, 12);
        span.title = "view hypergraph relon "+$txid;
        span.setAttribute("txid", $txid);
        span.innerHTML = $pre+"&nbsp;"+img+"&nbsp;"+$post;
        span.addEventListener("click", e=>EXT_BTNS.launchRelon(e));
        return span;
    }
}