
/**
 * help the annode user build their annode file.
 * 
 * anne.nodeAccountId = 8816721511704130929
 * anne.nodePubKey = 37361df0cd12a570f3265c26d641289fdd5bf09f94eeeb620f8572abf1b82c12
 * anne.nodePrivKey = c8936682a7c07c85299d2ffd261bdddb05e18c730de42d331e0bce27c7ba1477
 * anne.nodeSecret = testnodeparams
 * anne.nodeURI = http://localhost:9116
 * anne.dolocalnotifications = TRUE
 * anne.limitForRelonOffset = 1000

 */
 class dossier_annode extends neuron_dossier {
    constructor ($pgui, $secondary=null, $third=null, $misc=null) {
        super($pgui, $secondary, $third, $misc);
        console.log("%c dossier_annorg", TALK.bgredbig);
    }
    initASYNC = async($pguicopy)=>{
        //ANNE.A.hide(this.el_collab);
        //ANNE.A.hide(this.el_andy);

        //actions/ghosts can potentially get turned back on if there are pending
        //ghosts to send and this is the user's profile.
        ANNE.A.hide(this.el_actions);

        await this.getData(true, this.nObj);

        await this.doHeading(false, []);
        //if (this.nObj.nid==USER._userNObj.nid) 
        await this.getBalance();        

        this.doANNEID();    //snagged in get data instead of aplex record.

        await this.doAllParams(this.el_content);
        this.addAwarvu();
        //this._fixLayout();
        
        await this.doImgs(this.el_thumbs); //images after the body

        this.doMeta(this.el_meta);  //left stats
        this.doAllSysRelons(this.el_admin); //right admins

        ANNE.A.smartScroll("scrollable_"+this.ID, 72);
    }


    /**
     * to do, add blocks mined metric and find a way to capture it in the annode.
     */
    doANNEID = function() {
        var aObj = this.nObj._anneid;
        if (aObj==undefined || aObj==null) return;

        ANNE.A.ez2Col(this.el_bes_content, "sponsored neurons", aObj.sponsored_neurons+"", "span-lbl-bold ar", "text-success-lbl");
        ANNE.A.ez2Col(this.el_bes_content, "sponsored relons", aObj.sponsored_relons+"", "span-lbl-bold ar", "text-success-lbl");
        ANNE.A.ez2Col(this.el_bes_content, "hanai'd neurons", aObj.hanais+"", "span-lbl-bold ar", "text-success-lbl");
        //var andyico = "<img width='44px' height='44px' src='"+ANNE.___root+"/imgs/ANDY_ico.png' alt='' title='ANDY admin actions taken'></img>";
        ANNE.A.ez2Col(this.el_bes_content, "Andy actions", aObj.andy_actions+"", "span-lbl-bold ar", "text-success-lbl");
        ANNE.A.ez2Col(this.el_bes_content, "annexes", aObj.did_annex+"", "span-lbl-bold ar", "text-success-lbl");
        //var minerico = "<img width='44px' height='44px' src='"+ANNE.___root+"/imgs/miner_ico.png' alt='' title='blocks mined'></img>";
        ANNE.A.ez2Col(this.el_bes_content, "mined blocks", aObj.blocks_mined+"", "span-lbl-bold ar", "text-success-lbl");
        ANNE.A.ez2Col(this.el_bes_content, "boosties back", aObj.boostybacks_won+"", "span-lbl-bold ar", "text-success-lbl");
        ANNE.A.ez2Col(this.el_bes_content, "got annexed", aObj.got_annexed+"", "span-lbl-bold ar", "text-success-lbl");
        //var hanaiico = "<img width='44px' height='44px' src='"+ANNE.___root+"/imgs/hanai64_ico.png' alt='' title='neurons hanai\''d'></img>";
        
    }
}
