
class anne_bounty {
    constructor($nObj){
        this.el_stuff = null;
        this.dossier_inst = null;
        this.txtype = ANNE.TXB.TXTYPE_CHILD_RELON;
        this.nObj = $nObj;
        this.parentNOBJ = MEMG.getNeuronByTempNid(this.nObj.bes[0]);
        this.bVALID = false;
        this.rel_gov = null;
        this.gov_nid =null;
        
        this.rel_annies=null;
        this.annies = 0;
        this.btn_annies = null;
        this.rel_param_annies = null;

        this.rel_desc = null;
        this.anjucator_rels = [];
        this.anjucators_tnids = [];
        this.annode_chat_uri_rel = null;
        this.btn_add_anj = null;

        this.bHASANNIES = false;
        
        if (this.nObj.owned_by==USER._userNObj.nid) this._mode = "maker";
        else this._mode="user";
    }

    static getPayout = function($bountyNOBJ) {
        var bountyInst = new anne_bounty($bountyNOBJ);
        bountyInst.setVals();
        return parseInt(bountyInst.annies);
    }
    

    /**
     * 
     */
    setVals = function() {
        this.rel_gov = MEMG.getHasRelon(this.nObj.outs, MEM.governance.temp_nid);
        if (this.rel_gov!=null) {
            this.gov_nid = this.rel_gov.to_s;
        }

        //this is going to have to be the FIRST relon, in the event of multiple fundings.
        //those relons also can look the same.
        this.rel_annies = MEMG.getEarliestHasRelon(this.nObj.outs, MEM.annies.temp_nid);
        if (this.rel_annies!=null) {
            this.annies = this.rel_annies.to_s;  //leave as string
            this.bHASANNIES=true;
        }
        else {
            this.bHASANNIES=false;
            this.rel_param_annies = MEMG.getParamRelon(MEM.bounty.outs, MEM.annies.temp_nid);
        }

        this.rel_desc = MEMG.getHasRelon(this.nObj.outs, MEM.description.temp_nid);
        this.anjucator_rels = ANNE.MEM_UDF.getAnyHasRelsFromWith(this.nObj, MEM.anjucator);
        this.anjucators_tnids = [];
        if (this.anjucator_rels.length>0) {
            for (var a=0; a < this.anjucator_rels.length; a++) {
                var arel = this.anjucator_rels[a];
                if (this.anjucators_tnids.indexOf(arel.t)==-1) this.anjucators_tnids.push(arel.t);
            }
        }

        this.annode_chat_uri_rel = MEMG.getHasRelon(this.nObj.outs, MEM.ANNODE_URI.temp_nid);
    }


    /**
     * Intended for bounties that are defacto dictatorships with a single anjucator.
     * @returns 
     */
    canInstantVote = function($balanceAnnies) {
        if (this.rel_annies!=null && parseInt(this.annies)>$balanceAnnies) return false;
        if (this.gov_nid!=null && this.gov_nid!=MEM.gov_dictatorship.nid) return false;
        if (this.anjucators_tnids.length>1) return false;
        if (this.anjucators_tnids.length==1 && this.anjucators_tnids[0]==USER._userNObj.temp_nid) return true;
        else if (this.anjucators_tnids==0 && USER._userNObj.nid==this.nObj.owned_by) return true;
        return false;
    }


    /**
     */
    classifyBounty = async($el, $dossierINST)=> {
        this.bVALID=true;   //set to true, then turn it off if something missing.
        this.dossier_inst = $dossierINST;
        this.el_stuff=ANNE.A.ezEl($el, "div", "dossier-stuff");

        this.isValid();

        if (this._mode == "maker") {
            await this.makerMode();
        }
        else {
            await this.useMode();
        }
    }


    /**
     */
    isValid = function() {
        if (this.annies==null) this.bVALID=false;    
        if (this.gov_nid==null) this.bVALID=false;  
        if (this.rel_desc==null) this.bVALID=false;
        if (this.anjucators_tnids.length==0 && this.gov_nid!=MEM.gov_dictatorship.nid) this.bVALID=false;
    }


    /**
     */
    makerMode = async()=> {

        //this would only happen after an arbor prune of the annies relon.
        //to do testing -- PRUNE STUFF
        if (this.annies==null) {
            //var rel_annies = MEMG.getParamRelon(MEM.bounty.outs, MEM.annies.temp_nid);   
        }
        if (this.gov_nid==null) {
            //var rel_param_anj = MEMG.getParamRelon(MEM.bounty.outs, MEM.governance.temp_nid); 
        }
        if (this.rel_desc==null) {
        }

        //anjucator(s)
        if (this.anjucators_tnids.length==0) {
            var dictator = false;
            if (this.gov_nid==MEM.gov_dictatorship.nid) {

                var el_msg = ANNE.A.ezEl(this.el_stuff, "div", "dib tac");
                //akeNeuronLink=function($el, $nid, $class="", $pre="", $bADDCOPY=false, $txtoverride="", $page="dossier", $classpre="") {
                ANNE.EXT_BTNS.makeNeuronLink(el_msg, this.nObj.owned_by, "", "default dicator is owner&nbsp;");
                dictator = true;
                
            }

            else this.bVALID=false;
            
            //do add anjucator buttton
            if (this.nObj.freeze==false) {
                var rel_param_anj = MEMG.getParamRelon(MEM.bounty.outs, MEM.anjucator.temp_nid);
                if (rel_param_anj==null) {
                    
                    //hmmm.. get get these relons one-time for this app and save them.
                    await ANNE.CHASE.queryForOuts(MEM.bounty, true);
                    
                    rel_param_anj = MEMG.getParamRelon(MEM.bounty.outs, MEM.anjucator.temp_nid);
                    if (rel_param_anj==null) return;
                }

                this.btn_add_anj = this.dossier_inst.makeCollabBtn(this.el_stuff, this.txtype, rel_param_anj, "select anjucator to <b>invite</b>");
                ANNE.A.show(this.btn_add_anj);
                
                if (dictator==true) this.btn_add_anj.setAttribute("prompt", "Who would you like to determine when to make payout on this bounty?");
                else this.btn_add_anj.setAttribute("prompt", "Who would you like to serve as anjucator on this bounty?");
                
                this.btn_add_anj.setAttribute("insts_only", 1);
                this.btn_add_anj.setAttribute("no-dupes", 1);
                this.btn_add_anj.setAttribute("find-me", "heyro?");

                //paid to invitees
                // $bdclass="balance-display", $ico="annecoin-small-ico", $valClass="annecoin-balance-value"
                ANNE.A.ezAnniesToAnneDisplay(this.el_stuff, ANNE.fees.relon_anjucator_invite, "balance-display", "annecoin-small-ico", "annecoin-balance-value", false);
            }
        }
        
        else if (this.btn_add_anj==null && this.gov_nid!=MEM.gov_dictatorship.nid && this.nObj.freeze==0) {
            var rel_param_anj = MEMG.getParamRelon(MEM.bounty.outs, MEM.anjucator.temp_nid);
            this.btn_add_anj = this.dossier_inst.makeCollabBtn(this.el_stuff, this.txtype, rel_param_anj, "select anjucator to <b>invite</b>");
            this.btn_add_anj.setAttribute("prompt", "Who would you like to serve as anjucator on this bounty?");
            this.btn_add_anj.setAttribute("insts_only", 1);
        }

        
        //do the annies btn..
        if (this.bHASANNIES==false) {

            var msg = "enter annecoin for bounty.";
            this.btn_annies = this.dossier_inst.makeCollabBtn(this.el_stuff, ANNE.TXB.TXTYPE_CHILD_RELON, this.rel_param_annies, msg, true);
            var helpermsg = "Enter the annecoin that the bounty will pay out.";
            this.btn_annies.setAttribute("helperMsg", helpermsg);  //a bigger helper msg.
            this.btn_annies.setAttribute("prompt", msg);
            this.btn_annies.setAttribute("minimum", 500);
            //this.btn_annies.setAttribute("displayin_id", idboxID);
            this.btn_annies.setAttribute("col1", "tal50");
            this.btn_annies.setAttribute("col2", "tal50-block");
            this.btn_annies.setAttribute("annieshack", "1");

        }
    }


    dataAdded = async($new_relon)=> {
        this.validateAndHandle();
    }

    
    //signal interest  --> awareness w/ "interested" 
    //claim bounty
    useMode = async()=> {
        //if not valid, cannot use
        if (this.bVALID==false) return;
        //signal interest
        var interestNOBJ = MEMG.getOrMakeIfNew("3267686154079653646");
        await this.dossier_inst.collabGuiPresetValue(TYPE_AWARENESS, interestNOBJ, TO_TYPE_ANNE, this.nObj.nid, this.el_stuff, 
            {"btn_text":"signal interest", "title":"signal interest to that you are trying to achieve this bounty"});


        //if there are no funds in this neuron, don't turn on the claim bounty button.
        //(ok to show interest tho as bounties can be funded again).
        if (parseInt(this.nObj.balanceObj.annies) < parseInt(this.annies)) {
            return;
        }
        
        //bounty claim... (only possible if bounty is froze)
        //s.b. selfRelon [sys msg dimension] from self -> bounty_claim -> to the bounty nid
        if (this.nObj.freeze==true) {

            //send a self relon to signal that you claim the bounty.
            //adding an auto send param here.
            var attribs = {
                            "btn_text":"claim bounty", 
                            "from_nid":USER._userNObj.nid, 
                            "title":"claim publically that you have completed this bounty."
                        };

            //we actually just want to broadcast this straight away.
            attribs.broadcast_solo=true;
            
            //broadcast solo is in conjunction with a change of annode_uri required.
            //to keep things simple we do that and take care of it.
            if (this.annode_chat_uri_rel!=null) {   
                attribs.annode_uri = this.annode_chat_uri_rel.to_s;
            }
            await this.dossier_inst.collabGuiPresetValue(TYPE_SYS_MSG, MEM.bounty_claim, TO_TYPE_ANNE, this.nObj.nid, this.el_stuff, attribs);
        }

        else {
            ANNE.A.ezSpan(span, "", "", "When the bounty if froze by the owner it will be active to claim.");
        }

    }
}


/**
 * bounty
 */
 class dossier_bounty extends neuron_dossier {
    constructor ($pgui, $secondary=null, $third=null, $misc=null) {
        super($pgui, $secondary, $third, $misc);
        console.log("%c dossier_bounty", TALK.bgredbig);
    }

    initASYNC = async($pguicopy)=>{

        ANNE.A.removeSelf(this.el_bebox_img);

        this.open_status = 0;

        //load bounty ins/outs.  We want ins here because claims are ins from user identities.
        await this.getData(false, this.nObj);
        await this.doHeading(false, []);


        ANNE.A.removeSelf("garden_"+this.nObj.temp_nid);
        
        this._skips.push(MEM.anjucator.temp_nid);
        
        await this.doAllHas(this.el_content, "section-title-center", [], [], "tal50", "tal50");
        this.bounty = new anne_bounty(this.nObj);
        this.bounty.setVals();

        //TODO: show pending funding if neuron has balance ZERO and is froze.

        if (this.bounty.anjucator_rels.length) {
            var chase_txids = [];
            for(var r=0; r < this.bounty.anjucator_rels.length; r++) {
                var rel = this.bounty.anjucator_rels[r];

                if (ANNE.UTILS.isset(rel.sys_ref_txid)==true) {
                    var status_rel = MEMG.lookupByTXID(rel.sys_ref_txid);
                    if (status_rel==null) chase_txids.push(rel.sys_ref_txid);
                }
                else if (rel.status_txid!="" && rel.status_txid!=undefined) {
                    var status_rel = MEMG.lookupByTXID(rel.status_txid);
                    if (status_rel==null) chase_txids.push(rel.status_txid);
                }
            }

            //we need the status relons that tell us if the invite was accepted.
            //we store the invite (and rejection) in the hypergraph for record keeping.
            //we could have nuked it and then not did this check but then the inviters would
            //wonder what happened to their diappeared anjucator invite.
            if (chase_txids.length) await CHASE.lookupTxids(chase_txids);
            this.open_status = 0;
            for (var r=0; r < this.bounty.anjucator_rels.length; r++) {
                var rel = this.bounty.anjucator_rels[r];
                if (rel.txid=="") {
                    continue;
                }
                var row = ANNE.A.ezEl(this.el_content, "div", "simple-row");
                var col1 = ANNE.A.ezEl(row, "div", "simplee-col tal50");
                var col2 = ANNE.A.ezEl(row, "div", "simple-col tal50");
                ANNE.A.ezSpan(col1, "", "span-lbl", "anjucator");
                EXT_BTNS.makeRelonViewLink_SMART(col2, rel, false, 8, true);
                var status = "answer unknown";
                
                if (rel.to_s==this.nObj.owned_by) {
                    status = "auto-approved";
                }
                else if (rel.ghost==true) {
                    this.open_status+=1;
                    if (rel.to_type==TO_TYPE_ANNE) {
                        if (rel.to_s!="") ANNE.EXT_BTNS.makeNeuronLink(col2, rel.to_s, "", "("+status+")");
                    }
                    continue;
                }

                if (ANNE.UTILS.isset(rel.sys_ref_txid)==true) {
                    var status_rel = MEMG.lookupByTXID(rel.sys_ref_txid);
                    if (status_rel.r==MEM.anj_rejected.temp_nid) status = "declined";
                    else if (status_rel.r==MEM.anj_accepted.temp_nid) status = "approved";
                    else {
                        status = "anser unknown";
                        this.open_status+=1;
                    }
                }
                else if (rel.status_txid!=undefined && rel.status_txid!="") {
                 var status_rel = MEMG.lookupByTXID(rel.status_txid);
                    if (status_rel.r==MEM.anj_rejected.temp_nid) status = "declined";
                    else if (status_rel.r==MEM.anj_accepted.temp_nid) status = "approved";
                    else {
                        status = "answer unknown";
                        this.open_status+=1;
                    }
                }
                else if (rel.isAndyRel==true && rel.status_text!=undefined) {
                    if(rel.status_text=="p") {
                        status = "pending response";
                        this.open_status+=1;
                    }
                    else if (rel.status_text=="a") status = "approved";
                    else if (rel.status_text=="r" || rel.status_text=="d") status = "declined"; //todo: forgot the letter, look it up
                    else status = rel.status_text;
                }

                else {
                    var andy_rel = MEM_UDF.getAndyRel(rel.txid);
                    console.log("here", andy_rel);
                }

                if (rel.to_type==TO_TYPE_ANNE) {
                    if (rel.to_s!="") ANNE.EXT_BTNS.makeNeuronLink(col2, rel.to_s, "", "("+status+")");
                }
            }
        }

        this.el_balance = await this.getBalance(); 

        
        //note, we now have multiple funding relons.
        //the initial type_has relon, as well as NID_ANNIES to bump up the bounty and keep
        //it going.
        
        var fund_rel = ANNE.MEMG.getAnyRelonWithR(this.nObj.outs, ANNE.MEM.annies.temp_nid);
        
        if (fund_rel!=null && fund_rel.ghost==false) {
            
            //if this is unconfirmed, add it to the balance as unconf.
            if (fund_rel.time==-1) {
                console.log("unconf annies relon:"+fund_rel);
                if (this.el_balance!=null) {
                    var span_pending = document.createElement("span");
                    span_pending.classList="pending-balance";
                    this.el_balance.appendChild(span_pending);
                }
                else {
                    this.el_balance = ANNE.A.createElement(this.el_doss_info, "div", "balance-updatable", "", "anne_id_balance");
                    this.el_balance.setAttribute("id", "doss_balance_"+this.ID);
                    var span_pending = document.createElement("span");
                    span_pending.classList="pending-balance";
                    this.el_balance.appendChild(span_pending);
                }

                //fund rel was an annies rel to the to_s
                //this still isn't right tho...
                //would be better to have a real balance with a pending, auto displayed.
                //and be able to reuse it, anywhere.
                ANNE.A.ezAnniesToAnneDisplay(this.el_balance, fund_rel.to_s, true);
            }
        }

        else {
        }

        //display all param buttons in main area of page for owner.
        if (this.bounty._mode=="maker") {
            this.el_params = ANNE.A.ezEl(this.el_content, "div", "simple-row", "");
            await this.bounty.classifyBounty(this.el_params, this);

            //if we are froze, we can add more funds.
            if ((this.nObj.ghost==false && this.nObj.freeze==true) || (this.nObj.ghost==false && this.nObj.freeze==false && this.bounty.bVALID==true && parseInt(this.nObj.balanceObj.annies)==0)) {
                var el_fundmore_annies = document.getElementById("fundmore_annies_"+this.ID);
                if (el_fundmore_annies!=null) {
                    ANNE.A.show(el_fundmore_annies);

                    const el_holder = ANNE.A.ezAnnecoin_entry(el_fundmore_annies, async($annies)=>{
                        console.log("fund more annies");
                        ANNE.A.hide(el_holder);
                        var ghost_rel = await ANNE.GHOSTDATA.makeGhostRelon(TYPE_SYS_MSG, USER._userNObj, MEM.annies.nid, TO_TYPE_ANNE, this.nObj.nid, parseInt($annies));
                        await SENDQ.addRelonToSendQ(ghost_rel, true, TXB.TXTYPE_SELF_RELON);   
                        
                        ANNE.playSound("success");
                        return await SENDQ.___sendQueue();
                    }, "add more funds", "add more funds", null, "amf", "btn-stpd-xsm btn-addmorefunds btn-maxH"); //addmorefunds
    
                    var btnm = ANNE.A.setAttribute("btn_main_amf", "i_placeholder", "min annies "+this.bounty.annies);
                    btnm.setAttribute("i_min_val", parseInt(this.bounty.annies));
                }
            }
        }

        //display use buttons in right hand side of page for user.
        else {
            this.el_use = ANNE.A.ezEl(this.el_bes_content, "div", "", "");
            await this.bounty.classifyBounty(this.el_use, this);
        }
        
        //If all anjucators have answered, and this isn't yet frozen,
        //and this is a valid bounty up until this point...
        //The owner can freeze it to indicate it is now ready to go!
        if (this.nObj.ghost==false && this.open_status==0 
            && this.nObj.freeze==0 
            && this.bounty.bVALID==true) {
            if (this.bounty._mode=="maker") {
                var attribs = {
                    "btn_text":"freeze definition and activate"
                } 
                var btn_freeze = ANNE.A.showParent("freeze_selfOwned_btn_"+this.ID, true);
                btn_freeze.innerHTML = '<img class="dib" src="../imgs/ico_freeze.png" width="20px" title="FREEZE this neuron.">FREEZE';

                btn_freeze.addEventListener("click", e=>this.freezeBounty(e));
                var elf = ANNE.A.ezEl(this.el_bes_content, "div", "simple-row text-warning-lbl", "Freeze the bounty neuron to activate it!");
                elf.style['margin-top']='30px';
            }
            else {
                ANNE.A.ezEl(this.el_actions, "span", "text-warning-lbl", "This neuron is not yet froze. It can still change!");
            }
        }

        if (this.bounty._mode!="maker") {
            //ANNE.A.hide(this.el_upgrade_ghost_relons);
        }

        //get awareness ins of interested.
        var interestNOBJ = MEMG.getOrMakeIfNew("3267686154079653646");
        if (this.nObj.ghost==false && this.nObj.ntype==NTYPE_INST) {
            await ANNE.CHASE.getSpecificAwarenesses(this.nObj.nid, [interestNOBJ.nid]);
            var interested_signals = ANNE.MEMG.getAwarenessRelons(this.nObj.ins,interestNOBJ.temp_nid);
            if (interested_signals.length) {
                this.doTheseRelonsIN(this.el_bes_content, interested_signals, "interested signals");
            }
        }

        //get ins to this neuron of bounty_claim.
        var rel_claims = MEMG.getSysMsgRelonsTo(this.nObj.ins, MEM.bounty_claim.temp_nid, this.nObj.nid);
        if (rel_claims.length) {
            await this.bountyClaims(this.el_bes_content, rel_claims, "bounty claims");
        }
        
        var rel_payouts = MEMG.getInternalPayments(this.nObj.outs);
        if (rel_payouts.length) {
            this.doInternalPayouts(this.el_bes_content, rel_payouts, "payouts");
        }

        ANNE.A.smartScroll("scrollable_"+this.ID, 72);
    }


    /**
     * 
     * @param {*} $el 
     * @param {*} $relons 
     * @param {*} $title 
     * @param {*} $headingClass 
     * @param {*} $col1class 
     * @param {*} $col2class 
     * @returns 
     */
    bountyClaims = async($el, $relons, $title="title", $headingClass="section-title-center", $col1class="tal", $col2class="tal")=> {
        
        var sessions = null;
        if (this.bounty.anjucators_tnids.indexOf(USER._userNObj.temp_nid)!=-1 || this.bounty._mode=="maker") {
            sessions = await ANNE.API.getACHATSessions();     
        }

        else {
            for(var c=0; c <  $relons.length; c++) {
                if ($relons[c].from_nid==USER._userNObj.nid) {
                    sessions = await ANNE.API.getACHATSessions();     
                    break;
                }
            }
        }


        var map = new Object();

        if ($relons.length==0) return;
        var relonsDIV = ANNE.A.ezEl($el, "div", $headingClass, $title);

        ANNE.TALK.printRelons($relons);

        var txid_dupes = [];

        for (var r=0; r < $relons.length; r++) {
            var rel = $relons[r];           
            if (txid_dupes.indexOf(rel.txid)!=-1) continue;
            txid_dupes.push(rel.txid);
            var relNOBJ = MEMG.getNeuronByTempNid(rel.r);
            var lbl = relNOBJ.bestNameHTML();
            if (map[rel.f+"_"+rel.r]==undefined) map[rel.f+"_"+rel.r]={rel:rel, cnt:1, lbl:lbl};
            else map[rel.f+"_"+rel.r].cnt+=1;
        }

        var txid_dupes = [];

        var keys = Object.keys(map);
        for (var k=0; k < keys.length; k++) {
            var m = map[keys[k]];
            var claim_relon = m.rel;

            //if (txid_dupes.indexOf(txid_dupes)!=-1) continue;
            //txid_dupes.push(claim_relon.txid);
            
            var row = ANNE.A.ezEl($el, "div", "simple-row");
            var col1 = ANNE.A.ezEl(row, "div", "simple-col "+$col1class);
            var col2 = ANNE.A.ezEl(row, "div", "simple-col "+$col2class);
            ANNE.A.ezSpan(col1, "", "span-lbl", lbl);
            EXT_BTNS.makeRelonViewLink_SMART(col2, claim_relon, false, 8, true);
            var fire = "";
            if (m.cnt>1) fire="("+m.cnt+"x)";
            ANNE.EXT_BTNS.makeNeuronALink(col2, claim_relon["from_nid"], "", fire);

            //col2 -- put the achat in there.
            //achat link for anjucators?  lookup achats by txid_ref -5557386867298356327
            if (sessions!=null) {
                console.log(sessions);
                for (var s=0; s < sessions.length; s++) {
                    if (sessions[s].txid_ref==claim_relon.txid) {
                        var row2 = ANNE.A.ezEl($el, "div", "simple-row");
                        var btn=EXT_BTNS.makeNeuronLink(row2, "your <span class='achat-ico'></span>A𝄐chat", "link-bigger", "", false, "", "achat");
                        btn.setAttribute("miscp1", "achat_sesh_id");
                        btn.setAttribute("achat_sesh_id", sessions[s].sesh_id);
                        btn.setAttribute("page", "achat");  //change page to achat.
                    
                       break;
                    }
                }
            }

            //with the bounty claim, look for distro src pointing to this bounty...
            var rel_distro_srcs = MEMG.getHasRelonsTo(this.nObj.ins, MEM.distro_src.temp_nid, this.nObj.nid);
            
            
            var from_nids = [];
            for (var rc=0; rc < rel_distro_srcs.length; rc++) {
                var rel_distro_src = rel_distro_srcs[rc];
                if (from_nids.indexOf(rel_distro_src.from_nid)==-1) from_nids.push(rel_distro_src.from_nid);
            }
            
            if (from_nids.length) {
                await ANNE.API.queryForOutsAndInsFroms(from_nids, true, []);        
            }
            
            for (var rc=0; rc < rel_distro_srcs.length; rc++) {
                var rel_distro_src = rel_distro_srcs[rc];
                var fromDistroNOBJ = MEMG.getNeuronByTempNid(rel_distro_src.f);
                if (fromDistroNOBJ==null) continue;
                var distro_to_who = MEMG.getHasRelon(fromDistroNOBJ.outs, MEM.distro_to_whom.temp_nid);
                if (distro_to_who==null) continue;
                if (distro_to_who.to_s==claim_relon.from_nid) {
                    var row = ANNE.A.ezEl($el, "div", "simple-row");
                    var col1 = ANNE.A.ezEl(row, "div", "simple-col "+$col1class);
                    var col2 = ANNE.A.ezEl(row, "div", "simple-col "+$col2class);
                    ANNE.EXT_BTNS.makeNeuronALink(col1, fromDistroNOBJ.nid, "", "");  //distro nid
                    
                    //EXT_BTNS.makeRelonViewLink_SMART(col2, rel, false, 8, true);
                    
                    //find TYPE_HAS distribution request-> into this distro
                    var didit = false;
                    var rel_vote_neuron = MEMG.getHasRelon(fromDistroNOBJ.ins, MEM.distro_req.temp_nid);
                    if (rel_vote_neuron!=null) {
                        var voteNOBJ = MEMG.getNeuronByTempNid(rel_vote_neuron.f);
                        if (voteNOBJ!=null) {
                            var vote_rez_rel = MEMG.getHasRelon(voteNOBJ.outs, MEM.vote_result.temp_nid);
                            if (vote_rez_rel!=null) {
                                didit = true;
                                var statusNOBJ = MEMG.getNeuronByTempNid(vote_rez_rel.t);
                                ANNE.A.ezSpan(col2, "", "span-lbl", statusNOBJ.text);
                            }
                        }
                    }

                    if (didit==false) {
                        ANNE.A.ezSpan(col2, "", "span-lbl", "status unk");
                    }

                    //that's the VOTE neuron.
                    //go to that vote neuron.. look for Vote Result.
                }
            }
        }

        return relonsDIV;
    }  


    /**
     * Any bounty-definition altering TXs after the freeze will be rejected.
     * This includes anjucator changes, annie amount changes etc.
     * This helps ensure confidence in the bounty that its definition won't change
     * from under those who are working to satisfy it.
     * 
     * A bounty needs to be FROZE in order for it to become active.
     *
     * Make this relon and send it immediately.
     * 
     * @author Mr.scatman
     */
    freezeBounty=async($e)=>{
        console.log("freeze bounty!");
        ANNE.A.hideParent("freeze_selfOwned_btn_"+this.ID, true);
        if (this.open_status>0) {
            var r = confirm("This bounty has anjucators that have not yet responded.  Are you sure you want to freeze the neuron?  They will not be able to respond.");
            if (r == false) return;
        }
        var ghost_rel = await ANNE.GHOSTDATA.makeGhostRelon(TYPE_SYS_MSG, this.nObj, MEM.CMD_FREEZE, TO_TYPE_ANNE, this.nObj.nid, 0);
        ghost_rel.freeze = true;
        await SENDQ.addRelonToSendQ(ghost_rel, true, TXB.TXTYPE_CHILD_RELON);   
        ANNE.playSound("success");
        return await SENDQ.___sendQueue(this.freezeComplete);
    }


    /**
     * 
     * @param {*} $x 
     */
    freezeComplete=async($x)=>{
        ANNE.A.show("upgrade_ghost_neuron_btn_"+this.ID);
    }

    dataAdded = function($new_relon) {
        console.log($new_relon);
        this.bounty.isValid();
    }
}
