

/**
 * general
 */
 class dossier_general_inst extends neuron_dossier {
    constructor ($pgui, $secondary=null, $third=null, $misc=null) {
        console.log("%c dossier_general_inst", TALK.bgredbig);
        super($pgui, $secondary, $third, $misc);
    }
    initASYNC = async($pguicopy)=>{
        await this.getData(false, this.nObj);
        await this.doHeading();
        //await this.getBalance(); 
        //take away the be box
        //ANNE.A.hide(this.el_bes_content);
        //ANNE.A.addRemoveClass(this.el_content, "doss-body-box-full", "doss-body-box");

        if (this.nObj.is(MEM.fileX)==true) {
            this.showFile();
        }

        this.doSimpleRoles(this.el_content);

                
        //this.doAKA(this.el_bes_content);
       // this.doFKA(this.el_bes_content);
        this.doAltBES(this.el_bes_content);

        await this.doHas(this.el_content, "HAS attributes", true);    //generic.


        //this.doAllSysRelons(this.el_content);
        await this.doAllParams(this.el_content);

        await this.doAnumSection(this.el_content);
        
        this.doKwds();
        this.doAssociate();

        await this.doAllInsSection2(this.el_content, "inbound references", true);
        await this.doAllSysRelons(this.el_content);

        this.addAwarvu();

        //this._fixLayout();
        await this.doImgs(this.el_thumbs); //images after the body

        ANNE.A.smartScroll("scrollable_"+this.ID, 72);

    }

    showFile = function() {
        var local_rel = ANNE.MEMG.getHasRelon(this.nObj.outs, ANNE.MEM.dataRelativePath.temp_nid);
        if (local_rel!=null) {
            var path = local_rel.to_s;
            if (this.nObj.is(MEM.neuronAudio)==true) {
                var el_row = document.createElement("row");
                el_row.classList.add("simple-row");

                this.el_bes_content.appendChild(el_row);

                ANNE.A.soundFileLink(el_row, path, true);
            }
        }
    }
}