
/**
 * location
 */
 class dossier_location extends neuron_dossier {
    constructor ($pgui, $secondary=null, $third=null, $misc=null) {
        super($pgui, $secondary, $third, $misc);
        console.log("%c dossier_location", TALK.bgredbig);
    }
    initASYNC = async($pguicopy)=>{

        await this.getData(false, this.nObj, []);
        await this.doHeading();

        this._skips.push(MEM.constituent.temp_nid);

        if (this._bMAKEHANAIEVENT==true && this.ghost_cnt==0 && this.nObj.owned_by==USER._userNObj.nid) {
            if (this.nObj.ghost==false && this.nObj.temp==false) {
                if (this.el_hanai_to_anne_btn) ANNE.A.show(this.el_hanai_to_anne_btn);
            }
        }

        //this.doAKA(this.el_bes_content);
        //this.doFKA(this.el_bes_content);
        this.doAltBES(this.el_bes_content);

        if (this.nObj.functional_be!=undefined) {
            var fbNOBJ = MEMG.getNeuronByTempNid(this.nObj.functional_be);
            if (fbNOBJ!=null) {
                var coid = this.nObj['be_'+MEM.constituent_of.temp_nid];
                var coNOBJ = MEMG.getNeuronByTempNid(coid)
                if (coNOBJ!=null) {
                    var elco = document.createElement("div");
                    elco.classList = "simple-row";
                    EXT_BTNS.makeNeuronLink(elco, fbNOBJ.nid);
                    var span = document.createElement("span");
                    span.innerHTML = "&nbsp;in&nbsp;";
                    span.style['font-weight']=400;
                    elco.appendChild(span);
                    EXT_BTNS.makeNeuronLink(elco, coNOBJ.nid);
                    this.el_content.append(elco);
                }
            }
        }
        else {
            var coid = this.nObj['be_'+MEM.constituent_of.temp_nid];
            var coNOBJ = MEMG.getNeuronByTempNid(coid)
            if (coNOBJ!=null) {
                var elco = document.createElement("div");
                elco.classList = "simple-row";
                elco.innerHTML = "<b>located in </b>";
                EXT_BTNS.makeNeuronLink(elco, coNOBJ.nid);
                this.el_content.append(elco);
            }
            else await this.collabGui(MEM.constituent_of, this.el_collab_btns, "located in");

            //make polity  (collab btns are easier to see on the right)
            //this.collabGui(MEM.polity, this.el_collab_btns, "polity");
        }

        await this.doAllHas(this.el_bes_content, "section-title-center", [], 
                       [MEM.gps_lat.temp_nid, 
                        MEM.gps_long.temp_nid, 
                        MEM.location.temp_nid,
                        MEM.site.temp_nid,
                        MEM.geo_site.temp_nid]);

        await this.doAllHas(this.el_content, "section-title-center", []);
            
        await this.doAllInsSection2(this.el_content, "inbound references", true);
       
        //will delete this after debug.
        await this.doAllSysRelons(this.el_content);

        await this.doAnumSection(this.el_content);
        
        await this.doAllParams(this.el_content);

        this.addAwarvu();

        this.doKwds();
        this.doAssociate();


        //events in the body
        await this.displayEvents(this.el_content);

        //this.doBRAINSection(this.el_content);  
        await this.doImgs(this.el_thumbs); //images after the body

        //this.doMeta(this.el_meta);  //left stats
        //this.doAllSysRelons(this.el_admin); //right admins
        
        ANNE.TALK.printRelons(this.all_relons);

        ANNE.A.smartScroll("scrollable_"+this.ID, 72);
    }
}