var SENDER = {};
SENDER.pObj = null;
SENDER.bSUCCESS = false;
SENDER.pgui = null;
SENDER.txids = [];
SENDER.stage="pre";
SENDER.timer = null;
    
/**
 * 
 * @param {object} $pgui 
 * @returns 
 */
SENDER.init=async($pgui)=>{
    var defaultMsg="";
    SENDER.pgui = $pgui;
    var final_btn = ANNE.A.__getEl('qrb_final_btns_div');
    final_btn.addEventListener("click", e=>SENDER.makeProcessQFinalConfirm());  //not implemented
    
    if ($pgui!=null && $pgui.pObj!=undefined) {
        SENDER.pObj = $pgui.pObj;
        if (SENDER.pObj.p1!=null) defaultMsg = SENDER.pObj.p1;
    }
    
    document.getElementById('qrb_custom_msg').innerHTML=defaultMsg;
    document.getElementById('qrb_tx_status_div').innerHTML="";
    ANNE.A.hide('qrb_tx_status_div');
    document.getElementById('qrb_txs_list_div').innerHTML="";
    ANNE.A.hideMulti(['#qrb_txs_list_div', '#qrb_final_btns_div', '#qrb_progress', '#qrb_ghost_anne_final_btns']);
    
    SENDER.makeProcessQConfirmPW();

    ANNE.displayURI("qrb_annode_uri");

    SENDER.stage="pre";

    var el_clear = ANNE.A.__getEl("qrb_clear_all");
    el_clear.addEventListener("click", e=>{
            if (SENDER.stage=="pre") SENDER.cancel();
            else if (SENDER.stage=="fail") {
                console.log("fix this to call fail callback or close callback if it doesn't exist.")
            }
            else if (SENDER.stage=="post") SENDER.close();
        }
    );  
}


/**
 *
 */
SENDER.makeProcessQConfirmPW=async()=> {
    var statusEl = ANNE.A.setHTML('qrb_tx_status_div', "");
    ANNE.A.hide(statusEl);
    var el_txlist = ANNE.A.hide('qrb_txs_list_div');
    ANNE.A.setHTML(el_txlist, "");

    //pre-process items
    await TXB.analyzeAndFixMetaQ();
    
    if (TXB._metaQ.status!="ready") {
        var msg = "<span class='text-danger'><b>"+TXB._metaQ.status+"::"+TXB._metaQ.reason+"</b></span>";
        if(TXB._metaQ.recourse!=undefined && TXB._metaQ.recourse!=null) msg=msg+"<BR><BR>"+TXB._metaQ.recourse;

        //ANNE.A.setHTML('qrb_custom_msg', msg, true);
        ANNE.A.setHTML('qrb_tx_status_div', "Error. Recourse needed.", true, "");
        ANNE.A.show('qrb_infos_div');

        //do not pass the TXB._metaQ out on fail.  It will sometimes hold our cmds and wif.
        SENDQ.___sendFailed({status:TXB._metaQ.status, reason:msg});
        SENDER.cancel();
        return;
    }

    ANNE.A.show('qrb_infos_div');
    ANNE.A.hide('qrb_custom_msg');
    ANNE.A.empty("qrb_balance_update");
    ANNE.A.empty("qrb_id_info");
    ANNE.A.empty("qrb_needed");

    await ANNE.A.ezDisplayAnnecoinWithNeuron("qrb_balance_update", USER._userNObj, "balance&nbsp;");

    ANNE.A.ezlblSpan("qrb_id_info", "identity account", "<span class='text-primary-lbl'>"+USER._userNObj.nid+"</span>", "solo") 
    var totalAnnies = TXB._metaQ.totalAnnies;
    var eql_qrb = GUI_STUFF.doAnniesToAnneSpanFull('qrb_needed', "needed for these transactions&nbsp;", totalAnnies);
    var txs = "transactions";
    if (TXB._metaQ.total_txs==1) txs="transaction";
    eql_qrb.innerHTML = eql_qrb.innerHTML+"<span class='white-text pl4 pr4'>for</span><span class='green-text'>"+TXB._metaQ.total_txs+"</span><span class='white-text pl4'>"+txs+"</span>";
    
    if (ANNE.TALK!=null) ANNE.TALK.printSanitizedAlertCmds('qrb_txs_list_div', ANNE.SENDQ.aQ, true);

    var bal = USER._userNObj.balanceObj;
    
    if (bal!=null && parseInt(totalAnnies) > parseInt(bal.avail_now_annies)) {
        
        if (parseInt(bal.avail_soon_annies) > parseInt(totalAnnies)) {
            ANNE.A.setHTML(qrb_tx_status_div, "You do not have the funds until next block.", true);
            ANNE.A.addClass(qrb_tx_status_div, "bg-danger");
        }
        else {
            ANNE.A.setHTML(qrb_tx_status_div, "You do not have the funds for these transactions.", true);
            ANNE.A.addClass(qrb_tx_status_div, "bg-danger");
        }
    }
    else {
        ANNE.A.showMulti(['#qrb_final_btns_div', '#qrb_txs_list_div']);
    }

    //CHECK THE MEMPOOL IN CASE THIS ANNODE JUST TURNED ON.  IF SO, WE CAN"T SEND YET.
    //SET A TIMER TO KEEP CHECKING.
    var bMEMPOOLOK = await ANNE.API.mempoolOk();
    if (bMEMPOOLOK==false) {
        var secs = 5000;
        SENDER.timer = setInterval(async() => {
            secs+=1000;
            var diff = secs%5000;
            var left = (5000-diff) / 1000;
            if (diff==0) {
                bMEMPOOLOK = await ANNE.API.mempoolOk();
            }

            if (bMEMPOOLOK==true) {
                clearInterval(SENDER.timer);
                console.log('mempool ready.');
                ANNE.A.empty("mempool_msg", true)
                ANNE.A.show("qrb_confirm");
                ANNE.playSound("beep");
            }

            else {
                var el_mpm = ANNE.A.show("mempool_msg");
                if (el_mpm==null) {
                    clearInterval(SENDER.timer);
                    return;
                }
                el_mpm.innerHTML="mempool not available, checking again in <b>"+left+"</b> secs";
                ANNE.A.hide("qrb_confirm");
            }
        }, 1000);
    }
}



/**
 */
SENDER.makeProcessQFinalConfirm=async()=>{
    if (SENDER.timer!=null) {
        clearInterval(SENDER.timer);
    }

    ANNE.A.hide('qrb_ghost_btn');
    ANNE.A.showMulti(['loading', '#qrb_progress']);
    ANNE.A.hideMulti(['#qrb_conf_pw_btn', '#qrb_final_btns_div']);
    ANNE.A.setHTML("qrb_clear_all","");

    //do the TX sends of whatever is in the SEND
    var results = await TXB.sender(ANNE.SENDQ.aQ);
    
    ANNE.A.setHTML("qrb_clear_all", "close", true);

    if (results==false || typeof results!="object" || results.status!="success") {
        SENDER.stage = "post";
        return SENDER.failed(results);
    }

    else {
        SENDER.stage = "post";
        ANNE.A.animateProp("tx_totals", "height", "0px");
        ANNE.A.setHTML('qrb_tx_status_div', "Success!", true, "bg-success");

        //show post mortem if we have it.
        if (ANNE.hasPostMortem()==true) {

            //probably need a page part injected here.
            //do this later.
            ANNE.A.displayPostMortem("qrb_post_mortem", ANNE.bug_hunter.rejected_broadcasts);
        }

        SENDQ.sendSuccess(results);
    }

    return true;
}



/**
 * THIS IS OLD CODE... MUST BE REDONE...
 * 
 * rework this to use the fail cb.
 * 
 */
SENDER.failed = async($results)=> {
    console.log($results);
    var html = "<span class='text-danger'><b>"+$results.status+"::"+$results.reason+"</b></span>";
    ANNE.A.setHTML('qrb_custom_msg', html, true);
    ANNE.A.show('qrb_infos_div');
    ANNE.A.setHTML('qrb_tx_status_div', "Error. Recourse needed. "+$results.reason, true, "error-span");
    ANNE.A.hideMulti(['#loading']);

    var el_retry = ANNE.A.show("qrb_retry");
    if (el_retry==null) SENDQ.___sendFailed($results);
    
    el_retry.addEventListener("click", async ($e)=>{
        ANNE.A.hide("qrb_retry");
        var start_index = 0;
        for (var i=0; i < ANNE.SENDQ.aQ.length; i++) {
            var cmdObj = ANNE.SENDQ.aQ[i];
            if (cmdObj.skipped==true || cmdObj.success==true) continue;  
            start_index = i;
            break;
        }
    
        var results = await TXB.sender(ANNE.SENDQ.aQ, start_index);

        ANNE.A.setHTML("qrb_clear_all", "close", true);
        if (results==false || typeof results!="object" || results.status!="success") {
            SENDER.stage = "post";
            return SENDER.failed(results);
        }
        else {
            SENDER.stage = "post";
            ANNE.A.animateProp("tx_totals", "height", "0px");
            ANNE.A.setHTML('qrb_tx_status_div', "Success!", true, "bg-success");
            SENDQ.sendSuccess(results);
        }
        return true;
    });

    return SENDQ.___sendFailed($results);

}


/**
 * only possible after success
 */
SENDER.close = async()=> {
    TXB.exitQueue();
    if (SENDER.timer!=null) {
        clearInterval(SENDER.timer);
    }

    //we will be stuck on this if we don't have a refreshcallback.
    if (ANNE.SENDQ.__refreshCallbackTemp!=null) {
        ANNE.SENDQ.__refreshCallbackTemp();
        ANNE.SENDQ.clearAll(false);
        SENDER.destroyAll();
    }
    else {
        ANNE.SENDQ.clearAll(false);
        if (SENDER.pObj && SENDER.pObj.s_cbk!=null) {
            SENDER.pObj.s_cbk();
            SENDER.destroyAll();
        }
        else if (ANNE.PAGES!=null) {
            SENDER.destroyAll();
        }
    }               
}


/**
 * Should only be for form cancels (before sending)
 * This can be via manual click or by error in processing the queue (for pre-send prep stage)
 */
SENDER.cancel = function() {

    TXB.exitQueue();

    ANNE.SENDQ.clearAll(false);
     if (SENDER.timer!=null) {
        clearInterval(SENDER.timer);
    }

    //cancel callback present.
    if (SENDER.pObj && SENDER.pObj.c_cbk!=null) {
        SENDER.pObj.c_cbk(SENDER.pObj.page);
        SENDER.destroyAll();
        return;
    }

    //no cancel callback present..
    else {
        SENDER.destroyAll();
        return;
    }
}


/**
 */
SENDER.destroyAll = function() {
    if (SENDER.timer!=null) {
        clearInterval(SENDER.timer);
    }

    if (ANNE.TXB._metaQ!=undefined && ANNE.TXB._metaQ!=null)  {
        SENDER.TXB._metaQ = null;
    }
    SENDER.pObj = null
    SENDER.bSUCCESS = false;
    SENDER.pgui = null;
    SENDER.txids = [];
    SENDER.__refreshCallbackTemp = null;
    SENDER.stage="pre";

    if (ANNE.PAGES!=null) ANNE.PAGES.historyGoBack(null);
}