var SOLO_NEW = {};

    SOLO_NEW.init = function() {
        ANNE.A.hide("loading");
        document.getElementById("user_key").addEventListener("input", SOLO_NEW.seedChanged);
        
        var btn_make_new_key = ANNE.A.__getEl("btn_make_key");
        btn_make_new_key.addEventListener("click", e=>SOLO_NEW.makeNewKey(e));
       
        var btn_make_new_key_final= ANNE.A.__getEl("make_new_key_final");
        btn_make_new_key_final.addEventListener("click", e=>SOLO_NEW.makeKeyFINAL(e));
    }


    SOLO_NEW.seedChanged=function() {
        document.getElementById("btn_make_key").innerHTML="use custom seed";
        var k = document.getElementById("user_key").value.trim();
        console.log("check key");
        SOLO_NEW.checkKey(k);
    }


    /**
     * 
     * @param {*} $k 
     */
    SOLO_NEW.checkKey = function ($k) {
        var msgObj = USER.isValidSeedSOLO($k);
        if (msgObj.status=="good") {
            ANNE.A.show('final_div');
            ANNE.A.hide('btn_make_key');
            ANNE.A.hide("error");
            SOLO_NEW.makeNewKey();
        }
        else {
            console.log("not a valid key");
            ANNE.A.setHTML('error', msgObj.reason, true);
        }
    }

    
    /**
     * 
     */
    SOLO_NEW.makeNewKey = async()=>{
        ANNE.A.show('final_div');
        var seed = document.getElementById("user_key").value;
        if (seed==null) seed = ""; //autogen one.
        SOLO_NEW.neuron = await USER.makeSeedSOLO("user_key", seed);

        
        if (seed.length<64) {
           ANNE.A.setHTML("error", "For security, a manually chosen seed should be atleast 64 chars long.", true);
           ANNE.A.hide("nid_preview");
           ANNE.A.setHTML("nid_quick", "");
           return;
        }

        ANNE.A.show("nid_preview");
        ANNE.A.setHTML('nid_quick', SOLO_NEW.neuron.nid);
    }
    

    /**
     * 
     */
    SOLO_NEW.makeKeyFINAL =async()=> {
        var seedEl = ANNE.A.__getEl('user_key');
        var seed_text = seedEl.value;
        seed_text=seed_text.trim();
        if (seed_text.length<64) {
           ANNE.A.setHTML("error", "For security, a manually chosen seed should be atleast 64 chars long.", true);
           return;
        }

        ANNE.A.hide("error");

        USER.seedObj = {seed:seed_text, status:"success"};
        ANNE.A.setHTML("msg", "Here is your ANNE key info.")
        ANNE.A.hide("input_div");
        ANNE.A.hide("pw_div");
        ANNE.A.show("result_div");

        ANNE.A.setHTML("seed", SOLO_NEW.neuron.seed);
        ANNE.A.setHTML("nid", SOLO_NEW.neuron.nid);
        ANNE.A.setHTML("pubkey", SOLO_NEW.neuron.publicKey);

        ANNE.A.hide("nid_preview");
        ANNE.A.hide("make_new_key_final");
        
        return;
    }


    /**
     * 
     */
    SOLO_NEW.destroyAll = function() {    
        ANNE.A.hide('login_form');
        document.getElementById("user_key").removeEventListener("input", SOLO_NEW.loginkeytype);
    }