
var LOGIN_SOLO = {};

//this doesn't make much sense anymore with seeds
//and now wifs.
LOGIN_SOLO.loginkeytype=function() {
    var k = document.getElementById("user_key").value.trim();
    console.log("check key");
    LOGIN_SOLO.checkKey(k);
}


/**
 */
LOGIN_SOLO.init = function($pgui) {
    ANNE.A.hide("loading");
    var el_user_key = document.getElementById("user_key")
    el_user_key.addEventListener("input", LOGIN_SOLO.loginkeytype);
    el_user_key.focus();
    
    var btn_make_new_key = ANNE.A.__getEl("btn_make_key");
    btn_make_new_key.addEventListener("click", e=>LOGIN_SOLO.makeNewKey(e));

    var btn_user_login = ANNE.A.__getEl("user_login");
    btn_user_login.addEventListener("click", e=>LOGIN_SOLO.setUserSeed(e));

    if (LOGIN_SOLO.pObj && LOGIN_SOLO.pObj.p1==false) {
        console.log("new login only");
    }
    else {
        console.log("show historic options for login");
        //render and show accounts DD
    }

}


/**
 * TO DO:  
 *      The 12 words thing ?
 */ 
LOGIN_SOLO.makeNewKey = async()=>{
    USER._bNEWUSER=true;
    ANNE.A.showMulti(['#user_login_decision','#pw_div']);
    document.getElementById('user_pw').focus();
    ANNE._bFIRST_TIME_LOGIN = true;
    var public_nid = await USER.makeSeed('user_key');

    var thisKey = ANNE.A.getValue('user_key');
    var pa = "<STRONG>public address</STRONG>: <font class='text-success'>"+public_nid+"</font>";
    var pr_a = "<STRONG>private key</STRONG>: <font class='text-danger-lbl'>"+thisKey+"</font>";
    pr_a = pr_a + "<BR><span class='text-danger'>***Please safely store your key***.</span>  We cannot recover it if you lose it.";

    //if we alreaddy have a pw for this ext/wallet, use it.
    //we only need this once and it is used for all.
    //hide the pw field and change the submit button text to be more frenly.
    if (USER.unlock_pw!="") {
        var userpw_el = document.getElementById('user_pw');
        userpw_el.value = USER.unlock_pw;
        userpw_el.setAttribute('disabled', true);
        ANNE.A.hide(userpw_el);
        ANNE.A.setHTML("user_login","&nbsp;create new account");;
    }
}


/**
 * 
 * @param {*} $k 
 */
LOGIN_SOLO.checkKey = function ($k) {
    if (USER.isValidSeed($k)==true) {
        ANNE.A.showMulti(['#user_login_decision', '#pw_div']);
        ANNE.A.hide('btn_make_key');
        if (USER.unlock_pw!="") {
            var userpw_el = document.getElementById('user_pw');
            userpw_el.value = USER.unlock_pw;
            userpw_el.setAttribute('disabled', true);
            ANNE.A.hide(userpw_el);
            ANNE.A.setHTML("user_login","&nbsp;create new account");;
        }
    }
    else {
        console.log("not a valid key");
        ANNE.A.hide('user_login_decision');
    }

    ANNE.bFRESHLOGIN = true;
}


/**
 * 
 */
LOGIN_SOLO.setUserSeed=function() {
    USER.setSeedWithPW_gui('user_key', 'user_pw'); // 'login_public_nid'
}


/**
 * 
 */
LOGIN_SOLO.destroyAll = function() {    
    ANNE.A.hide('login_form');
    document.getElementById("user_key").removeEventListener("input", LOGIN_SOLO.loginkeytype);
}


var UNLOCK = {};    
UNLOCK.init = function() {
    console.log("UNLOCK.init"); 
    var el = ANNE.A.__getEl("unlock_password");
    if (USER.unlock_pw!="") {
        el.value=USER.unlock_pw;
    } 
    var btn_unlock = ANNE.A.__getEl("btn_unlock");
    btn_unlock.addEventListener("click", e=>UNLOCK.unlockANNEID(e));
    var btn_new_acct = ANNE.A.__getEl("unlock_new_acct");
    btn_new_acct.addEventListener("click", e=>UNLOCK.newAccount(e));
    var btn_logout = ANNE.A.__getEl("unlock_logout");
    btn_logout.addEventListener("click", e=>UNLOCK.logout(e));
}

UNLOCK.newAccount = async($e)=>{
    USER.logoutThisAccount();
}

UNLOCK.logout = async($e)=>{
    USER.logoutThisAccount();
}

UNLOCK.unlockANNEID = async()=> {
    var el = ANNE.A.__getEl("unlock_password");
    var pw = el.value;
    var seedObj = await USER.getSeedWithPW(pw);
    if (seedObj.status!="success") {
        console.log("no dice");
        USER._badPWAttempts+=1;
        el.classList.add("error-shake");
        el.style.animation = 'none';
        el.offsetHeight; /* trigger reflow */
        el.style.animation = null; 
        return false;
    }
    else {
        USER._badPWAttempts=0;
        USER.seedObj = seedObj; //we will delete this when we lock
        USER.unlock_pw = pw;    //we will delete this when we lock
        await ANNE.unlocked();
        UNLOCK.goToPage = null;
    }
}
